<?php # $Id: comment.php,v 1.47 2004/09/14 12:56:08 garvinhicking Exp $
# Copyright (c) 2003-2004, Jannis Hermanns
# All rights reserved.  See LICENSE file for licensing details

session_start();
include_once('serendipity_config.inc.php');
header('Content-Type: text/html; charset=' . LANG_CHARSET);

if (isset($serendipity['GET']['delete'], $serendipity['GET']['entry'], $serendipity['GET']['type'])) {
    serendipity_deleteComment($serendipity['GET']['delete'], $serendipity['GET']['entry'], $serendipity['GET']['type']);
    header('Location: '. $_SERVER['HTTP_REFERER']); die();
}

if (isset($serendipity['GET']['switch'], $serendipity['GET']['entry'])) {
    serendipity_allowCommentsToggle($serendipity['GET']['entry'], $serendipity['GET']['switch']);
}

serendipity_rememberComment();

if (!($type = @$_REQUEST['type'])) {
    $type = 'normal';
}

$tb_logging = false; // for developers: can be switched to true!

if ($type == 'trackback') {
    if ($tb_logging) {
        # PHP 4.2.2 way of doing things
        ob_start();
        print_r($_REQUEST);
        $tmp = ob_get_contents();
        ob_end_clean();

        $fp = fopen('trackback2.log', 'a');
        fwrite($fp, '[' . date('d.m.Y H:i') . '] RECEIVED TRACKBACK' . "\n");
        fwrite($fp, '[' . date('d.m.Y H:i') . '] ' . $tmp . "\n");
    }

    $uri = $_SERVER['REQUEST_URI'];
    if (isset($_REQUEST['entry_id'])) {
        $id = (int)$_REQUEST['entry_id'];
    } else if ($_REQUEST['amp;entry_id']) {
        // For possible buggy variable transmission caused by an intermediate CVS-release of s9y
        $id = (int)$_REQUEST['amp;entry_id'];
    } else if (preg_match('@/(\d+)_[^/]*$@', $uri, $matches)) {
        $id = (int)$matches[1];
    }

    if ($tb_logging) {
        fwrite($fp, '[' . date('d.m.Y H:i') . '] Match on ' . $uri . "\n");
        fwrite($fp, '[' . date('d.m.Y H:i') . '] ID: ' . $id . "\n");
        fclose($fp);
    }
    if (add_trackback($id, $_REQUEST['title'], $_REQUEST['url'],
                      $_REQUEST['blog_name'], $_REQUEST['excerpt'])) {
        if ($tb_logging) {
            $fp = fopen('trackback2.log', 'a');
            fwrite($fp, '[' . date('d.m.Y H:i') . '] TRACKBACK SUCCESS' . "\n");
        }
        report_trackback_success();
    } else {
        if ($tb_logging) {
            $fp = fopen('trackback2.log', 'a');
            fwrite($fp, '[' . date('d.m.Y H:i') . '] TRACKBACK FAILURE' . "\n");
        }
        report_trackback_failure();
    }

    if ($tb_logging) {
        fclose($fp);
    }
} else if ($type == 'pingback') {
    if(add_pingback($_REQUEST['entry_id'], $HTTP_RAW_POST_DATA)) {
        report_pingback_success();
    } else {
        report_pingback_failure();
    }
} else {
    $id = (int)(!empty($serendipity['POST']['entry_id']) ? $serendipity['POST']['entry_id'] : $serendipity['GET']['entry_id']);

    $html_header = '';

    if ($serendipity['XHTML11']) {
        $html_header .= '<?xml version="1.0" encoding="iso-8859-1" ?>' . "\n";
        $html_header .= '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">' . "\n";
    }

    $html_header .= '<html' . ($serendipity['XHTML11'] ? ' xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" dir="ltr"' : '') . '>
<head>
    <title>' . COMMENTS . '</title>
    <link rel="stylesheet" type="text/css" href="' .  $serendipity['serendipityHTTPPath'] . 'serendipity.css.php?mode=comments" />
    <meta http-equiv="Content-Type" content="text/html; charset=' . LANG_CHARSET . '" />
</head>
<body class="s9y_wrap" id="serendipity_comment_page">
';
    if (isset($_GET['success']) && $_GET['success'] == 'true') {
        echo $html_header;
        printf(
          COMMENT_ADDED . COMMENT_ADDED_CLICK,

          '<a href="' . $_GET['url'] . '&amp;serendipity[entry_id]=' . $_GET['entry_id'] . '">',
          '</a>',
          '<a href="#" onclick="self.close()">',
          '</a>'
        );
    } else if (!isset($serendipity['POST']['submit'])) {
        echo $html_header;
        if ($serendipity['GET']['type'] == 'trackbacks') {
            $tbu = $serendipity['baseURL'] . 'comment.php?type=trackback&amp;entry_id=' . (int)$serendipity['GET']['entry_id'];
            $query = "SELECT title FROM {$serendipity['dbPrefix']}entries WHERE id = '". (int)$serendipity['GET']['entry_id'] ."'";
            $entry = serendipity_db_query($query);
            $entry = serendipity_archiveURL($serendipity['GET']['entry_id'], $entry[0]['title'], 'baseURL');
?>
    <div class="serendipity_commentsTitle"><?php echo TRACKBACKS; ?></div><br />
    <dl>
        <dt><b><?php echo TRACKBACK_SPECIFIC; ?>:</b><br /></dt>
        <dd><a href="<?php echo $tbu; ?>"><?php echo $tbu; ?></a><br /></dd>

        <dt><b><?php echo DIRECT_LINK; ?>:</b><br /></dt>
        <dd><a href="<?php echo $entry; ?>"><?php echo $entry; ?></a></dd>
    </dl>
    <?php serendipity_printTrackbacks(serendipity_fetchTrackbacks($id)); ?>
<?php
        } else {
?>
    <div class="serendipity_commentsTitle"><?php echo COMMENTS; ?></div>
<?php
            $query = "SELECT allow_comments, moderate_comments FROM {$serendipity['dbPrefix']}entries WHERE id = '" . $id . "'";
            $ca    = serendipity_db_query($query, true);

            serendipity_printComments(serendipity_fetchComments($id), (isset($ca['allow_comments']) ? $ca['allow_comments'] : true));

            if ($serendipity['POST']['preview']) {
                serendipity_printComments(
                  array(
                    array(
                      'email'     => $serendipity['POST']['email'],
                      'username'  => $serendipity['POST']['name'],
                      'body'      => $serendipity['POST']['comment'],
                      'url'       => $serendipity['POST']['url'],
                      'timestamp' => time()
                    )
                  ),
                  false,
                  false
                );
            }

            if (serendipity_db_bool($ca['allow_comments']) || !is_array($ca)) {
?>
    <div class="serendipity_commentsTitle"><?php echo ADD_COMMENT; ?></div>
<?php
                serendipity_displayCommentForm($id, '?', $comments, $serendipity['POST'], true, serendipity_db_bool($ca['moderate_comments']));
            } elseif  (!serendipity_db_bool($ca['allow_comments'])) { ?>
                <div class="serendipity_center serendipity_msg_important"><?php echo COMMENTS_CLOSED; ?></div>
<?php
            }
        }
    } else {
        $comment['url']       = $serendipity['POST']['url'];
        $comment['comment']   = trim($serendipity['POST']['comment']);
        $comment['name']      = $serendipity['POST']['name'];
        $comment['email']     = $serendipity['POST']['email'];
        $comment['subscribe'] = $serendipity['POST']['subscribe'];
        $comment['parent_id'] = $serendipity['POST']['replyTo'];
        if (!empty($comment['comment'])) {
            if (serendipity_saveComment($serendipity['POST']['entry_id'], $comment, 'NORMAL')) {
                header('Location: ' . $serendipity['baseURL'] . 'comment.php?entry_id=' . $serendipity['POST']['entry_id'] . '&success=true&url=' . urlencode($_SERVER['HTTP_REFERER']));
                exit;
            } else {
                echo $html_header;
                printf(
                  COMMENT_NOT_ADDED . COMMENT_NOT_ADDED_CLICK,

                  '<a href="' . $_SERVER['HTTP_REFERER'] . '">',
                  '</a>',
                  '<a href="#" onclick="self.close()">',
                  '</a>'
                );
            }
        } else {
            echo $html_header;
            printf(
              EMPTY_COMMENT,

              '<a href="#" onclick="history.go(-1)">',
              '</a>'
            );
        }
    }
?>
</body>
</html>
<?php
}
/* vim: set sts=4 ts=4 expandtab : */
?>
