<?php # $Id: index.php,v 1.50 2004/09/14 12:56:08 garvinhicking Exp $

// We need to set this to return a 200 since we use .htaccess ErrorDocument
// rules to handle archives.
header('HTTP/1.0 200\r\n');

// Session and serendipity_login() are needed to also remember an autologin
// user on the frontend
session_start();
include_once('serendipity_config.inc.php');
serendipity_login();
header('Content-Type: text/html; charset='. LANG_CHARSET);

$track_referer = true;
$uri = $_SERVER['REQUEST_URI'];

if (preg_match(PAT_UNSUBSCRIBE, $uri, $res)) {
    if ( serendipity_cancelSubscription(urldecode($res[1]), $res[2]) ) {
        define('DATA_UNSUBSCRIBED', urldecode($res[1]));
    }

    $uri = '/'.PATH_UNSUBSCRIBE.'/'. $res[2] .'_untitled.html';
}

if (preg_match(PAT_DELETE, $uri, $res) && $serendipity['serendipityAuthedUser'] === true) {
    if ( $res[1] == 'comment' && serendipity_deleteComment($res[2], $res[3], 'comments') ) {
        define('DATA_COMMENT_DELETED', $res[2]);
    } elseif ( $res[1] == 'trackback' && serendipity_deleteComment($res[2], $res[3], 'trackbacks') ) {
        define('DATA_TRACKBACK_DELETED', $res[2]);
    }
}

if (preg_match(PAT_APPROVE, $uri, $res) && $serendipity['serendipityAuthedUser'] === true) {
    if ( $res[1] == 'comment' && serendipity_approveComment($res[2], $res[3]) ) {
        define('DATA_COMMENT_APPROVED', $res[2]);
    } elseif ( $res[1] == 'trackback' && serendipity_approveComment($res[2], $res[3]) ) {
        define('DATA_TRACKBACK_APPROVED', $res[2]);
    }
}


if (preg_match(PAT_ARCHIVES, $uri, $matches) || isset($serendipity['GET']['range']) && is_numeric($serendipity['GET']['range'])) {
    if (!empty($serendipity['GET']['range'])) {
        $range                         = $serendipity['GET']['range'];
    } else {
        $range                         = $matches[1];
    }
    $_GET['serendipity']['action']     = 'read';
    $_GET['serendipity']['range']      = $range;

    if (strlen($range) == 6) {
        $date = serendipity_formatTime('%B %Y', mktime(0, 0, 0, substr($range, 4, 6), 2, substr($range, 0, 4)));
    } else {
        $date = serendipity_formatTime(DATE_FORMAT_ENTRY, strtotime($range));
    }

    $serendipity['blogSubTitle'] = sprintf(ENTRIES_FOR, $date);
    ob_start();
    include_once(S9Y_INCLUDE_PATH . 'serendipity_genpage.inc.php');
    $data = ob_get_contents();
    ob_end_clean();

    if (isset($serendipity['pregenerate']) && $serendipity['pregenerate']) {
        $fp = fopen('./'.PATH_ARCHIVES.'/' . $matches[1], 'w');
        fwrite($fp, $data);
        fclose($fp);
    }

    echo $data;
} else if (preg_match(PAT_ARCHIVES_SHORT, $uri, $matches)) {
    $range = $matches[1];
    $_GET['serendipity']['action'] = 'read';
    $_GET['serendipity']['range']  = $range;
    $serendipity['short_archives'] = true;

    if (strlen($range) == 6) {
        $date = date('m/Y', mktime(0,0,0, substr($range, 4, 6), 2, substr($range, 0, 4)));
    } else {
        $date = date('d/m/Y', strtotime($range));
    }

    $serendipity['blogSubTitle'] = sprintf(ENTRIES_FOR, $date);
    ob_start();
    include_once(S9Y_INCLUDE_PATH . 'serendipity_genpage.inc.php');
    $data = ob_get_contents();
    ob_end_clean();

    if (isset($serendipity['pregenerate']) && $serendipity['pregenerate']) {
        $fp = fopen('./archives/' . $matches[1], 'w');
        fwrite($fp, $data);
        fclose($fp);
    }

    echo $data;
} else if (preg_match(PAT_COMMENTSUB, $uri, $matches)) {
    serendipity_rememberComment();

    if (!empty($serendipity['POST']['submit'])) {
        $comment['url']       = $serendipity['POST']['url'];
        $comment['comment']   = trim($serendipity['POST']['comment']);
        $comment['name']      = $serendipity['POST']['name'];
        $comment['email']     = $serendipity['POST']['email'];
        $comment['subscribe'] = $serendipity['POST']['subscribe'];
        $comment['parent_id'] = $serendipity['POST']['replyTo'];
        if (!empty($comment['comment'])) {
            if (serendipity_saveComment($serendipity['POST']['entry_id'], $comment, 'NORMAL')) {
                header('Location: ' . $_SERVER['REQUEST_URI'] . (strstr($_SERVER['REQUEST_URI'], '?') ? '&' : '?') . 'serendipity[csuccess]=true');
                exit;
            } else {
                $serendipity['messagestack']['comments'][] = COMMENT_NOT_ADDED;
            }
        } else {
                $serendipity['messagestack']['comments'][] = sprintf(EMPTY_COMMENT, '', '');
        }
    }

    $id = (int)$matches[1];

    serendipity_track_referrer($id);
    $track_referer = false;

    $_GET['serendipity']['action'] = 'read';
    $_GET['serendipity']['id']     = $id;

    $title = serendipity_db_query("SELECT title FROM {$serendipity['dbPrefix']}entries WHERE id=$id", true);
    $title = $title[0];

    $serendipity['blogSubTitle'] = $serendipity['blogTitle'];
    $serendipity['blogTitle'] = $title;

    ob_start();
    include_once(S9Y_INCLUDE_PATH . 'serendipity_genpage.inc.php');
    $data = ob_get_contents();
    ob_end_clean();

    if (isset($serendipity['pregenerate']) && $serendipity['pregenerate']) {
        $fp = fopen('./'.PATH_ARCHIVES.'/' . $matches[1], 'w');
        fwrite($fp, $data);
        fclose($fp);
    }
    print $data;
} else if (preg_match(PAT_FEEDS, $uri)) {
    header('Content-Type: text/html; charset=utf-8');
    if (preg_match('@/(index|atom|rss|b2rss|b2rdf).(rss|rdf|rss2|xml)$@', $uri, $matches)) {
        $_GET['version'] = serendipity_discover_rss($matches[1], $matches[2]);

        ob_start();
        include_once(S9Y_INCLUDE_PATH . 'rss.php');
        $data = ob_get_contents();
        ob_end_clean();

        $data = ltrim($data);

        if ($serendipity['pregenerate']) {
            $fp = fopen('./'.PATH_FEEDS.'/index.' . $matches[1], 'w');
            fwrite($fp, $data);
            fclose($fp);
        }

        print $data;
        exit;
    }
} else if (preg_match(PAT_ADMIN, $uri)) {
    header("Location: {$serendipity['serendipityHTTPPath']}serendipity_admin.php");
    exit;
} else if (preg_match(PAT_ENTRIES, $uri)) {
    header("Location: {$serendipity['serendipityHTTPPath']}serendipity_entries.php");
    exit;
} else if (preg_match(PAT_ARCHIVE, $uri)) {
    $serendipity['GET']['action'] = 'archives';
    include_once(S9Y_INCLUDE_PATH . 'serendipity_genpage.inc.php');
} else if (preg_match(PAT_PLUGIN, $uri, $matches)) {
    serendipity_plugin_api::hook_event('external_plugin', $matches[1]);
    exit;
} else if (preg_match(PAT_CATEGORIES, $uri, $matches) ||
           preg_match('@/(index\.(php|html))?@', $uri) ||
           preg_match('@/(' . preg_quote($serendipity['indexFile']) . ')?@', $uri)) {

    if (count($serendipity['GET']) == 2) {
        if (isset($matches) && is_array($matches) && isset($matches[1])) {
            $serendipity['GET']['category'] = $matches[1];
        }

        ob_start();
        include_once(S9Y_INCLUDE_PATH . 'serendipity_genpage.inc.php');
        $data = ob_get_contents();
        ob_end_clean();
        if (isset($serendipity['pregenerate']) && $serendipity['pregenerate']) {
            $fp = fopen('./index.html', 'w');
            fwrite($fp, $data);
            fclose($fp);
        }
        print $data;
    } else {
        if (isset($matches) && is_array($matches) && isset($matches[1])) {
            $serendipity['GET']['category'] = $matches[1];
        }

        if (isset($serendipity['GET']['calendarZoom'])) {
            $serendipity['GET']['action'] = 'read';
            $serendipity['GET']['range'] = $serendipity['GET']['calendarZoom'];
        }
        include_once(S9Y_INCLUDE_PATH . 'serendipity_genpage.inc.php');
    }
} else {
    printf(DOCUMENT_NOT_FOUND, $uri);
}

if ($track_referer) {
    serendipity_track_referrer();
}

/* vim: set sts=4 ts=4 expandtab : */
?>
