<?php # $Id: serendipity_event_emoticate.php,v 1.11 2004/09/15 17:09:31 garvinhicking Exp $

switch ($serendipity['lang']) {
    case 'de':
        @define('PLUGIN_EVENT_EMOTICATE_NAME', 'Textformatierung: Smilies');
        @define('PLUGIN_EVENT_EMOTICATE_DESC', 'Standard Text-Smilies in Grafiken konvertieren');
        @define('PLUGIN_EVENT_EMOTICATE_TRANSFORM', 'Standard-Text Smilies wie :-) und ;-) werden zu Bildern konvertiert.');
        break;

    case 'en':
    default:
        @define('PLUGIN_EVENT_EMOTICATE_NAME', 'Markup: Emoticate');
        @define('PLUGIN_EVENT_EMOTICATE_DESC', 'Convert standard emoticons into graphic images');
        @define('PLUGIN_EVENT_EMOTICATE_TRANSFORM', 'Standard emoticons like :-) and ;-) are converted to images.');
        break;
}

class serendipity_event_emoticate extends serendipity_event
{

    function introspect(&$propbag)
    {
        global $serendipity;

        $propbag->add('name',          PLUGIN_EVENT_EMOTICATE_NAME);
        $propbag->add('description',   PLUGIN_EVENT_EMOTICATE_DESC);
        $propbag->add('event_hooks', array('frontend_display' => true, 'frontend_comment' => true));

        $this->markup_elements = array(
            array(
              'name'     => ENTRY_BODY,
              'element'  => 'body',
            ),
            array(
              'name'     => EXTENDED_BODY,
              'element'  => 'extended',
            ),
            array(
              'name'     => COMMENT,
              'element'  => 'comment',
            ),
            array(
              'name'     => HTML_NUGGET,
              'element'  => 'html_nugget',
            )
        );
        $conf_array = array();
        foreach($this->markup_elements as $element) {
            $conf_array[] = $element['name'];
        }
        $propbag->add('configuration', $conf_array);

    }

    function getEmoticons() {
        global $serendipity;

        /* Avoid multiple runs of serendipity_getTemplateFile(),
           in other words - if we already have a list of smilies, don't bother looking for another */
        if (isset($this->smilies) && sizeof($this->smilies) != 0) {
            return $this->smilies;
        }

        /* Hijack global variable $serendipity['custom_emoticons'] if it exists */
        $hijack_file = serendipity_getTemplateFile('emoticons.inc.php', 'serendipityPath');
        if (@file_exists($hijack_file)) {
            @include $hijack_file;
            if (isset($serendipity['custom_emoticons']) && is_array($serendipity['custom_emoticons'])) {
                $this->smilies = $serendipity['custom_emoticons'];
            }
        }

        if (!isset($this->smilies)) {
            $this->smilies = array(
                ":'("  => serendipity_getTemplateFile('img/emoticons/cry.png'),

                ':-)'  => serendipity_getTemplateFile('img/emoticons/smile.png'),
                ':)'   => serendipity_getTemplateFile('img/emoticons/smile.png'),

                ':|'   => serendipity_getTemplateFile('img/emoticons/normal.png'),

                ':-O'  => serendipity_getTemplateFile('img/emoticons/eek.png'),
                ':O'   => serendipity_getTemplateFile('img/emoticons/eek.png'),

                ':-('  => serendipity_getTemplateFile('img/emoticons/sad.png'),
                ':('   => serendipity_getTemplateFile('img/emoticons/sad.png'),

                '8-)'  => serendipity_getTemplateFile('img/emoticons/cool.png'),
                '8)'   => serendipity_getTemplateFile('img/emoticons/cool.png'),

                ':-D'  => serendipity_getTemplateFile('img/emoticons/laugh.png'),
                ':D'   => serendipity_getTemplateFile('img/emoticons/laugh.png'),

                ':-P'  => serendipity_getTemplateFile('img/emoticons/tongue.png'),
                ':P'   => serendipity_getTemplateFile('img/emoticons/tongue.png'),

                ';-)'  => serendipity_getTemplateFile('img/emoticons/wink.png'),
                ';)'   => serendipity_getTemplateFile('img/emoticons/wink.png'),
            );
        }

        return $this->smilies;
    }

    function generate_content(&$title) {
        $title = PLUGIN_EVENT_EMOTICATE_NAME;
    }


    function introspect_config_item($name, &$propbag)
    {
        $propbag->add('type',        'boolean');
        $propbag->add('name',        $name);
        $propbag->add('description', sprintf(APPLY_MARKUP_TO, $name));
        $propbag->add('default', 'true');
        return true;
    }


    function event_hook($event, &$bag, &$eventData) {
        global $serendipity;
        $hooks = &$bag->get('event_hooks');

        if (isset($hooks[$event])) {
            switch($event) {
                case 'frontend_display':

                    foreach ($this->markup_elements as $temp) {
                        if (serendipity_db_bool($this->get_config($temp['name'], true)) && isset($eventData[$temp['element']])) {
                            $element = &$eventData[$temp['element']];

                            foreach ($this->getEmoticons() as $key => $value) {
                                $element = preg_replace("/([\t\ ]?)" . preg_quote($key, '/') . "([\t\ \!\.\)]?)/m",
                                    "$1<img src=\"$value\" alt=\"$key\" style=\"display: inline; vertical-align: bottom;\" class=\"emoticon\" />$2",
                                    $element);
                            }
                        }
                    }
                    return true;
                    break;

                case 'frontend_comment':
                    if (serendipity_db_bool($this->get_config(COMMENT, true))) {
                        echo '<div class="serendipity_commentDirection">' . PLUGIN_EVENT_EMOTICATE_TRANSFORM . '</div>';
                    }
                    return true;
                    break;

              default:
                return false;
            }
        } else {
            return false;
        }
    }

}

/* vim: set sts=4 ts=4 expandtab : */
?>
