<?php # $Id: serendipity_event_livesearch.php,v 1.7 2004/08/31 12:52:56 garvinhicking Exp $

switch ($serendipity['lang']) {
    case 'de':
        @define('PLUGIN_EVENT_LIVESEARCH_NAME', 'LiveSearch');
        @define('PLUGIN_EVENT_LIVESEARCH_DESC', 'Erweitert die Suchfunktion mit einer Live-aktualisierung (JavaScript)');
        @define('PLUGIN_EVENT_LIVESEARCH_WAIT', 'Suche aktiviert, bitte warten...');

        break;

    case 'en':
    case 'es':
    default:
        @define('PLUGIN_EVENT_LIVESEARCH_NAME', 'LiveSearch');
        @define('PLUGIN_EVENT_LIVESEARCH_DESC', 'Enhances the Search function with live-updates on keypress (JavaScript)');
        @define('PLUGIN_EVENT_LIVESEARCH_WAIT', 'Wait, sending request...');
        break;
}

class serendipity_event_livesearch extends serendipity_event
{
    function introspect(&$propbag)
    {
        global $serendipity;

        $propbag->add('name',          PLUGIN_EVENT_LIVESEARCH_NAME);
        $propbag->add('description',   PLUGIN_EVENT_LIVESEARCH_DESC);
        $propbag->add('event_hooks',    array(
            'external_plugin'  => true,
            'frontend_header' => true,
            'css' => true,
            'quicksearch_plugin' => true
        ));
    }

    function generate_content(&$title) {
        $title = PLUGIN_EVENT_LIVESEARCH_NAME;
    }

    function event_hook($event, &$bag, &$eventData, $addData = null) {
        global $serendipity;

        $hooks = &$bag->get('event_hooks');

        if (isset($hooks[$event])) {
            switch($event) {
                case 'css':
                    if (stristr('.serendipity_livesearch_row', $addData)) {
                        // class exists in CSS, so a user has customized it and we don't need default
                        return true;
                    }
?>
#LSResult {
    position: absolute;
    margin-left: 4px;
    margin-top: 4px;
}

#LSShadow {
    position: relative;
    bottom: 1px;
    right: 1px;
    color: inherit;
    border-right: 2px solid #ccc;
    border-bottom: 2px solid #ccc;
}

#LSHighlight {
    background-color: #80FF80;
    color: black;
}

.serendipity_livesearch_row {
  margin: 0px;
  line-height: 1.2em;
  padding-top: 0.2em;
  padding-bottom: 0.2em;
  text-indent: -1em;
  padding-left: 1em;
  line-height: 1.2em;
  padding-right: 1em;
}

.serendipity_livesearch_result {
    position: relative;
    bottom: 2px;
    right: 2px;
    border: 1px solid black;
    padding: 2px;
}
<?php
                    break;

                case 'frontend_header':
                    if (!$serendipity['embed'] || $serendipity['embed'] === 'false' || $serendipity['embed'] === false) {
                        echo '<script type="text/javascript" src="' . $serendipity['baseURL'] . ($serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : '') . 'plugin/ls-js"></script>';
                    }
                    break;

                case 'quicksearch_plugin':
                    echo '<script type="text/javascript">
                    lsbase = "' . $serendipity['baseURL'] . ($serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : '') . 'plugin/ls' . ($serendipity['rewrite'] == 'none' ? '&' : '?') . '";
                    waittext = "' . PLUGIN_EVENT_LIVESEARCH_WAIT . '";
                    addLoadEvent(liveSearchInit);
                    </script>';
                    break;

                case 'external_plugin':
                    $uri_parts = explode('?', str_replace('&amp;', '&', $eventData));

                    // Try to get request parameters from eventData name
                    if (!empty($uri_parts[1])) {
                        $reqs = explode('&', $uri_parts[1]);
                        foreach($reqs AS $id => $req) {
                            $val = explode('=', $req);
                            if (empty($_REQUEST[$val[0]])) {
                                $_REQUEST[$val[0]] = $val[1];
                            }
                        }
                    }

                    $parts     = explode('_', $uri_parts[0]);
                    if (!empty($parts[1])) {
                        $param     = (int) $parts[1];
                    } else {
                        $param     = null;
                    }

                    switch($parts[0]) {
                        case 'ls-js':
                            header('Content-Type: text/javascript');
                            echo file_get_contents(S9Y_INCLUDE_PATH . 'plugins/serendipity_event_livesearch/serendipity_event_livesearch.js');
                            break;

                        case 'ls':
                            $res = serendipity_searchEntries($_REQUEST['s']);

                            if (is_array($res) && count($res) > 0) {
                                echo '<?xml version="1.0" encoding="utf-8" ?>';
                                echo '<div class="serendipity_livesearch_result">';
                                foreach($res AS $id => $entry) {
                                    echo '<div class="serendipity_livesearch_row"><a href="' . serendipity_archiveURL($entry['id'], $entry['title'], 'baseURL') . '">' . htmlspecialchars($entry['title']) . '</a></div>';
                                }
                                echo '</div>';
                            }

                            break;
                    }

                    return true;
                    break;

                default:
                    return false;
                    break;
            }
        } else {
            return false;
        }
    }
}

/* vim: set sts=4 ts=4 expandtab : */
?>
