<?php # $Id: serendipity_event_mailer.php,v 1.5 2004/06/22 13:45:45 garvinhicking Exp $

switch ($serendipity['lang']) {
    case 'de':
        @define('PLUGIN_EVENT_MAILER_NAME', 'Artikel mailen');
        @define('PLUGIN_EVENT_MAILER_DESC', 'Verschickt jeden neuen Artikel im Blog via E-Mail');
        @define('PLUGIN_EVENT_MAILER_RECIPIENT', 'Mail-Empfnger');
        @define('PLUGIN_EVENT_MAILER_RECIPIENTDESC', 'Die E-Mail Adresse an die die Artikel verschickt werden sollen (empfohlen: Eine Mailing-Liste)');
        @define('PLUGIN_EVENT_MAILER_LINK', 'URL des Artikels mailen?');
        @define('PLUGIN_EVENT_MAILER_LINKDESC', 'Verschickt die URL des Artikels.');
        @define('PLUGIN_EVENT_MAILER_STRIPTAGS', 'HTML entfernen?');
        @define('PLUGIN_EVENT_MAILER_STRIPTAGSDESC', 'Entfernt HTML-Anweisungen aus der Mail.');
        break;

    case 'en':
    case 'es':
    default:
        @define('PLUGIN_EVENT_MAILER_NAME', 'Mail entry');
        @define('PLUGIN_EVENT_MAILER_DESC', 'Mails each new entry to your blog via E-Mail');
        @define('PLUGIN_EVENT_MAILER_RECIPIENT', 'Mail recipient');
        @define('PLUGIN_EVENT_MAILER_RECIPIENTDESC', 'E-Mail address you want to send the entries to (suggested: a mailing list)');
        @define('PLUGIN_EVENT_MAILER_LINK', 'Mail link to article?');
        @define('PLUGIN_EVENT_MAILER_LINKDESC', 'Include a link to the article in the mail.');
        @define('PLUGIN_EVENT_MAILER_STRIPTAGS', 'Remove HTML?');
        @define('PLUGIN_EVENT_MAILER_STRIPTAGSDESC', 'Remove HTML-Tags from the mail.');
        break;
}

class serendipity_event_mailer extends serendipity_event
{
    function introspect(&$propbag)
    {
        global $serendipity;

        $propbag->add('name',          PLUGIN_EVENT_MAILER_NAME);
        $propbag->add('description',   PLUGIN_EVENT_MAILER_DESC);
        $propbag->add('event_hooks',    array(
            'backend_publish' => true
        ));
        
        $propbag->add('configuration', array('mailto', 'includelink', 'striptags'));
    }

    function introspect_config_item($name, &$propbag)
    {
        switch($name) {
            case 'mailto':
                $propbag->add('type',        'string');
                $propbag->add('name',        PLUGIN_EVENT_MAILER_RECIPIENT);
                $propbag->add('description', PLUGIN_EVENT_MAILER_RECIPIENTDESC);
                $propbag->add('default', '');
                break;

            case 'includelink':
                $propbag->add('type',        'boolean');
                $propbag->add('name',        PLUGIN_EVENT_MAILER_LINK);
                $propbag->add('description', PLUGIN_EVENT_MAILER_LINKDESC);
                $propbag->add('default',     'false');
                break;

            case 'striptags':
                $propbag->add('type',        'boolean');
                $propbag->add('name',        PLUGIN_EVENT_MAILER_STRIPTAGS);
                $propbag->add('description', PLUGIN_EVENT_MAILER_STRIPTAGSDESC);
                $propbag->add('default',     'false');
                break;

            default:
                break;
        }

        return true;
    }

    function generate_content(&$title) {
        $title = PLUGIN_EVENT_MAILER_NAME;
    }

    function event_hook($event, &$bag, &$eventData) {
        global $serendipity;

        $hooks = &$bag->get('event_hooks');

        if (isset($hooks[$event])) {
            switch($event) {
                case 'backend_publish':
                    $mail = array(
                      'to'      => $this->get_config('mailto'),
                      'subject' => '[' . $serendipity['blogTitle'] . '] ' . $eventData['title'],
                      'body'    => $eventData['body'] . $eventData['extended'] . $serendipity['signature'],
                      'from'    => $serendipity['blogTitle'] . ' - ' . $eventData['author'] . ' <' . $serendipity['serendipityEmail'] . '>'
                    );
                    
                    if($this->get_config('includelink') == true) {
                       $mail['body'] = serendipity_archiveURL($eventData['id'], $eventData['title']) . "\n\n" . $mail['body'];
                    }

                    if($this->get_config('striptags') == true) {
                       $mail['body'] = strip_tags($mail['body']);
                    }

                    mail($mail['to'], $mail['subject'], $mail['body'], "From: {$mail['from']}\r\n{$serendipity['mailheaders']}");
                    return true;
                    break;

                default:
                    return false;
                    break;
            }
        } else {
            return false;
        }
    }
}

/* vim: set sts=4 ts=4 expandtab : */
?>
