<?php # $Id: serendipity_event_nl2br.php,v 1.4 2004/06/22 13:45:45 garvinhicking Exp $

switch ($serendipity['lang']) {
    case 'de':
        @define('PLUGIN_EVENT_NL2BR_NAME',     'Textformatierung: NL2BR');
        @define('PLUGIN_EVENT_NL2BR_DESC',     'Konvertiert Zeilenumbrche zu HTML');
        break;

    case 'en':
    default:
        @define('PLUGIN_EVENT_NL2BR_NAME',     'Markup: NL2BR');
        @define('PLUGIN_EVENT_NL2BR_DESC',     'Convert newlines to BR tags');
        break;
}

class serendipity_event_nl2br extends serendipity_event
{
    function introspect(&$propbag)
    {
        global $serendipity;

        $propbag->add('name',          PLUGIN_EVENT_NL2BR_NAME);
        $propbag->add('description',   PLUGIN_EVENT_NL2BR_DESC);
        $propbag->add('event_hooks', array('frontend_display' => true));

        $this->markup_elements = array(
            array(
              'name'     => ENTRY_BODY,
              'element'  => 'body',
            ),
            array(
              'name'     => EXTENDED_BODY,
              'element'  => 'extended',
            ),
            array(
              'name'     => COMMENT,
              'element'  => 'comment',
            ),
            array(
              'name'     => HTML_NUGGET,
              'element'  => 'html_nugget',
            )
        );

        $conf_array = array();
        foreach($this->markup_elements as $element) {
            $conf_array[] = $element['name'];
        }
        $propbag->add('configuration', $conf_array);
    }


    function generate_content(&$title) {
        $title = PLUGIN_EVENT_NL2BR_NAME;
    }


    function introspect_config_item($name, &$propbag)
    {
        $propbag->add('type',        'boolean');
        $propbag->add('name',        $name);
        $propbag->add('description', sprintf(APPLY_MARKUP_TO, $name));
        $propbag->add('default', 'true');
        return true;
    }

    function event_hook($event, &$bag, &$eventData) {
        global $serendipity;

        $hooks = &$bag->get('event_hooks');

        if (isset($hooks[$event])) {
            switch($event) {
              case 'frontend_display':

                foreach ($this->markup_elements as $temp) {
                    if (serendipity_db_bool($this->get_config($temp['name'], true)) && isset($eventData[$temp['element']])) {
                        $element = $temp['element'];
                        $eventData[$element] = nl2br($eventData[$element]);
                    }
                }
                return true;
                break;

              default:
                return false;
            }

        } else {
            return false;
        }
    }
}

/* vim: set sts=4 ts=4 expandtab : */
?>
