<?php # $Id: serendipity_plugin_recententries.php,v 1.9 2004/08/24 17:33:06 tomsommer Exp $

// Contributed by Christian Machmeier <cm@redsplash.de>

switch ($serendipity['lang']) {
    case 'de':
        @define('PLUGIN_RECENTENTRIES_TITLE', 'Aktuelle Eintrge');
        @define('PLUGIN_RECENTENTRIES_BLAHBLAH', 'Zeigt die Titel der aktuellsten Eintrge mit Datum');
        @define('PLUGIN_RECENTENTRIES_NUMBER', 'Anzahl der Eintrge');
        @define('PLUGIN_RECENTENTRIES_NUMBER_BLAHBLAH', 'Wieviele Eintrge sollen angezeigt werden? (Standard: 10)');
        break;

    case 'en':
    case 'es':
    default:
        @define('PLUGIN_RECENTENTRIES_TITLE', 'Recent Entries');
        @define('PLUGIN_RECENTENTRIES_BLAHBLAH', 'Shows the titles and dates of the most recent entries');
        @define('PLUGIN_RECENTENTRIES_NUMBER', 'Number of entries');
        @define('PLUGIN_RECENTENTRIES_NUMBER_BLAHBLAH', 'How many entries should be displayed? (Default: 10)');

        break;
}

class serendipity_plugin_recententries extends serendipity_plugin {

    function introspect(&$propbag) {
        $propbag->add('name',        PLUGIN_RECENTENTRIES_TITLE);
        $propbag->add('description', PLUGIN_RECENTENTRIES_BLAHBLAH);
        $propbag->add('configuration', array('number', 'dateformat'));
    }

    function introspect_config_item($name, &$propbag) {
        switch($name) {
            case 'number':
                $propbag->add('type', 'string');
                $propbag->add('name', PLUGIN_RECENTENTRIES_NUMBER);
                $propbag->add('description', PLUGIN_RECENTENTRIES_NUMBER_BLAHBLAH);
                $propbag->add('default', 10);
                break;

            case 'dateformat':
                $propbag->add('type', 'string');
                $propbag->add('name', GENERAL_PLUGIN_DATEFORMAT);
                $propbag->add('description', sprintf(GENERAL_PLUGIN_DATEFORMAT_BLAHBLAH, '%A, %B %e %Y'));
                $propbag->add('default', '%A, %B %e %Y');
                break;

            default:
                return false;
        }
        return true;
    }

    function generate_content(&$title) {
        global $serendipity;

        $number     = $this->get_config('number');
        $dateformat = $this->get_config('dateformat');

        if (!$number || !is_numeric($number) || $number < 1) {
            $number = 10;
        }

        if (!$dateformat || strlen($dateformat) < 1) {
            $dateformat = '%A, %B %e %Y';
        }

        $title = PLUGIN_RECENTENTRIES_TITLE;

        $entries = serendipity_db_query("SELECT id,
                                                title,
                                                timestamp
                                           FROM {$serendipity['dbPrefix']}entries
                                          WHERE isdraft = 'false'
                                       ORDER BY timestamp DESC
                                          LIMIT $number");

        if (isset($entries) && is_array($entries)) {
            foreach ($entries as $k => $entry) {
                $entryLink = serendipity_archiveURL(
                               $entry['id'],
                               $entry['title'],
                               'serendipityHTTPPath'
                            );

                echo '<a href="' . $entryLink . '" title="' . htmlspecialchars($entry['title']) . '">' . $entry['title'] . '</a><br />'
                     . '<div class="serendipitySideBarDate">'
                     . htmlspecialchars(strftime($dateformat, $entry['timestamp']))
                     . '</div><br />';
            }
        }
    }
}

/* vim: set sts=4 ts=4 expandtab : */
?>
