<?php # $Id: rss.php,v 1.28 2004/07/01 11:43:07 garvinhicking Exp $
header('Content-Type: text/xml');

include_once('serendipity_config.inc.php');
$version = strtolower($_GET['version']);
if (empty($version)) {
    $version = serendipity_discover_rss($_GET['file'], $_GET['ext']);
}

$description     = $serendipity['blogDescription'];
$title           = $serendipity['blogTitle'];
$comments        = FALSE;
if (isset($_GET['category'])) {
    $serendipity['GET']['category'] = $_GET['category'];
}

if (!isset($_GET['type'])) {
    $_GET['type'] = 'content';
}

if (!isset($_GET['nocache'])) {
    switch ($_GET['type']) {
    case 'comments':
            $latest_entry = serendipity_fetchComments(isset($_GET['cid']) ? $_GET['cid'] : null, 1, 'desc');
        break;
    case 'content':
    default:
            $latest_entry = serendipity_fetchEntries(null, false, 1, false, false, 'last_modified DESC');
        break;
    }

    /*
     * Caching logic - Do not send feed if nothing has changed
     * Implementation inspired by Simon Willison [http://simon.incutio.com/archive/2003/04/23/conditionalGet], Thiemo Maettig
     */

    // See if the client has provided the required headers.
    // Always convert the provided header into GMT timezone to allow comparing to the server-side last-modified header
    $modified_since = !empty($_SERVER['HTTP_IF_MODIFIED_SINCE'])
                    ? gmdate('D, d M Y H:i:s \G\M\T', strtotime(stripslashes($_SERVER['HTTP_IF_MODIFIED_SINCE'])))
                    : false;
    $none_match     = !empty($_SERVER['HTTP_IF_NONE_MATCH'])
                    ? str_replace('"', '', stripslashes($_SERVER['HTTP_IF_NONE_MATCH']))
                    : false;

    if (is_array($latest_entry) && isset($latest_entry[0]['last_modified'])) {
        $last_modified = gmdate('D, d M Y H:i:s \G\M\T', $latest_entry[0]['last_modified']);
        $etag          = '"' . $last_modified . '"';

        header('Last-Modified: ' . $last_modified);
        header('ETag: '          . $etag);

        if (($none_match == $last_modified && $modified_since == $last_modified) ||
            (!$none_match && $modified_since == $last_modified) ||
            (!$modified_since && $none_match == $last_modified)) {
            header('HTTP/1.0 304 Not Modified');
            return;
        }
    }
}

switch ($_GET['type']) {
case 'comments':
    $entries     = serendipity_fetchComments(isset($_GET['cid']) ? $_GET['cid'] : null, 15, 'desc');
    $title       = $title . ' ' . COMMENTS;
    $description = COMMENTS_FROM . ' ' . $description;
    $comments    = TRUE;
    break;
case 'content':
default:
    if (isset($_GET['all']) && $_GET['all']) {
        $entries = serendipity_fetchEntries(null, true);
    } else {
        $entries = serendipity_fetchEntries(null, true, 15, false, (isset($modified_since) ? $modified_since : false));
    }
    break;
}

$title       = serendipity_utf8_encode(htmlspecialchars($title));
$description = serendipity_utf8_encode(htmlspecialchars($description));

include_once(S9Y_INCLUDE_PATH . 'serendipity_plugin_api.php');
$plugins = serendipity_plugin_api::enum_plugins();

if (is_array($plugins)) {
    // load each plugin to make some introspection
    foreach ($plugins as $plugin_data) {
        if (preg_match('|@serendipity_syndication_plugin|', $plugin_data['name'])) {
            $plugin =& serendipity_plugin_api::load_plugin($plugin_data['name']);
            $additional_fields = $plugin->generate_rss_fields($title, $description, $entries);
            break;
        }
    }
}

echo '<?xml version="1.0" encoding="utf-8" ?>';

if (strstr($version, 'atom')) {
    echo "\n" . '<?xml-stylesheet href="' . serendipity_getTemplateFile('atom.css') . '" type="text/css" ?>';
}

echo "\n";
switch ($version) {
case '0.91':
    print <<<HEAD
<rss version="0.91">
<channel>
<title>$title</title>
<link>{$serendipity['baseURL']}</link>
<description>$description</description>
<language>{$serendipity['lang']}</language>
{$additional_fields['image']}

HEAD;
break;

case '1.0':
    $rdf_seq_li = "\n";
    if (is_array($entries)) {
        foreach($entries AS $entry) {
            $rdf_seq_li .= '        <rdf:li resource="' . serendipity_rss_getguid($entry, $comments) . '" />' . "\n";
        }
    }
    $eventData = array_merge(array('display_dat' => ''), $entries);
    serendipity_plugin_api::hook_event('frontend_display:rss-1.0:namespace', $eventData);
    print <<<HEAD
<rdf:RDF {$eventData['display_dat']}
   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
   xmlns:admin="http://webns.net/mvcb/"
   xmlns:content="http://purl.org/rss/1.0/modules/content/"
   xmlns:dc="http://purl.org/dc/elements/1.1/"
   xmlns:slash="http://purl.org/rss/1.0/modules/slash/"
   xmlns:wfw="http://wellformedweb.org/CommentAPI/">
<channel rdf:about="{$serendipity['baseURL']}rss.php?version=1.0">
    <title>$title</title>
    <link>{$serendipity['baseURL']}</link>
    <description>$description</description>
    <dc:language>{$serendipity['lang']}</dc:language>
    <admin:errorReportsTo rdf:resource="mailto:{$serendipity['email']}" />

    {$additional_fields['image_rss1.0_channel']}

    <items>
      <rdf:Seq>{$rdf_seq_li}</rdf:Seq>
    </items>
</channel>

{$additional_fields['image_rss1.0_rdf']}

HEAD;
break;

case '2.0':
    $eventData = array_merge(array('display_dat' => ''), $entries);
    serendipity_plugin_api::hook_event('frontend_display:rss-2.0:namespace', $eventData);
    print <<<HEAD
<rss version="2.0"
   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
   xmlns:admin="http://webns.net/mvcb/"
   xmlns:dc="http://purl.org/dc/elements/1.1/"
   xmlns:slash="http://purl.org/rss/1.0/modules/slash/"
   xmlns:wfw="http://wellformedweb.org/CommentAPI/"
   xmlns:content="http://purl.org/rss/1.0/modules/content/"
   {$eventData['display_dat']}>
<channel>
    <title>$title</title>
    <link>{$serendipity['baseURL']}</link>
    <description>$description</description>
    <dc:language>{$serendipity['lang']}</dc:language>
    <admin:errorReportsTo rdf:resource="mailto:{$serendipity['email']}" />
    <generator>Serendipity {$serendipity['version']} - http://www.s9y.org/</generator>
    {$additional_fields['channel']}
    {$additional_fields['image']}

HEAD;
break;

case 'atom0.3':
    $modified = gmdate('Y-m-d\TH:i:s\Z', $entries[0]['last_modified']);
    print <<<HEAD
<feed version="0.3"
   xmlns="http://purl.org/atom/ns#"
   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
   xmlns:dc="http://purl.org/dc/elements/1.1/"
   xmlns:admin="http://webns.net/mvcb/"
   xmlns:slash="http://purl.org/rss/1.0/modules/slash/"
   xmlns:wfw="http://wellformedweb.org/CommentAPI/">
    <link href="{$serendipity['baseURL']}rss.php?version=atom0.3" rel="service.feed" title="$title" type="application/x.atom+xml" />
    <link href="{$serendipity['baseURL']}"                        rel="alternate"    title="$title" type="text/html" />
    <link href="{$serendipity['baseURL']}rss.php?version=2.0"     rel="alternate"    title="$title" type="application/rss+xml" />
    <title mode="escaped" type="text/html">$title</title>
    <tagline mode="escaped" type="text/html">$description</tagline>
    <id>{$serendipity['baseURL']}</id>
    <modified>$modified</modified>
    <generator url="http://www.s9y.org/" version="{$serendipity['version']}">Serendipity {$serendipity['version']} - http://www.s9y.org/</generator>
    <dc:language>{$serendipity['lang']}</dc:language>
    <admin:errorReportsTo rdf:resource="mailto:{$serendipity['email']}" />
    <info mode="xml" type="text/html">
        <div xmlns="http://www.w3.org/1999/xhtml">You are viewing an ATOM formatted XML site feed. Usually this file is inteded to be viewed in an aggregator or syndication software. If you want to know more about ATOM, please visist <a href="http://atomenabled.org/">Atomenabled.org</a></div>
    </info>

HEAD;
break;

case 'opml1.0':
    $modified = gmdate('Y-m-d\TH:i:s\Z', $entries[0]['last_modified']);
    print <<<HEAD
<opml version="{$version}">
<head>
    <title>$title</title>
    <dateModified>$modified</dateModified>
    <ownerName>Serendipity {$serendipity['version']} - http://www.s9y.org/</ownerName>
</head>
<body>
HEAD;
break;

default:
    die("Invalid RSS version specified\n");
}

serendipity_printEntries_rss($entries, $version, $comments);

switch ($version) {
case '0.91':
case '2.0':
    print "</channel>\n";
    print "</rss>\n";
    break;
case '1.0':
    $eventData = array_merge(array('display_dat' => ''), $entries);
    serendipity_plugin_api::hook_event('frontend_display:rss-1.0:once', $eventData);
    echo $eventData['display_dat'];
    print '</rdf:RDF>';
    break;
case 'atom0.3':
    print '</feed>';
    break;
case 'opml1.0':
    print "</body>\n</opml>";
}

/* vim: set sts=4 ts=4 expandtab : */
?>
