<?php # $Id: serendipity_admin_comments.inc.php,v 1.20 2004/09/16 10:29:08 garvinhicking Exp $
if (IN_serendipity !== true) {
    die ("Don't hack!");
}

$commentsPerPage = 10;
$summaryLength = 200;

if ( $serendipity['POST']['formAction'] == 'multiDelete' && sizeof($serendipity['POST']['delete']) != 0 ) {
    foreach ( $serendipity['POST']['delete'] as $k => $v ) {
        serendipity_deleteComment($k, $v);
        echo DONE . ': '. sprintf(COMMENT_DELETED, $k) . '<br />';
    }
    return true;
}


/* We are asked to save the edited comment, and we are not in preview mode */
if ( isset($serendipity['GET']['adminAction']) && $serendipity['GET']['adminAction'] == 'doEdit' && !isset($serendipity['POST']['preview']) ) {
    $sql = "UPDATE {$serendipity['dbPrefix']}comments
                    SET
                        author    = '" . serendipity_db_escape_string($serendipity['POST']['name'])    . "',
                        email     = '" . serendipity_db_escape_string($serendipity['POST']['email'])   . "',
                        url       = '" . serendipity_db_escape_string($serendipity['POST']['url'])     . "',
                        parent_id = '" . serendipity_db_escape_string($serendipity['POST']['replyTo']) . "',
                        body      = '" . serendipity_db_escape_string($serendipity['POST']['comment']) . "'
            WHERE id = " . (int)$serendipity['GET']['id'] . " AND
                  entry_id = " . (int)$serendipity['POST']['entry_id'];
    serendipity_db_query($sql);
    echo COMMENT_EDITED;
    return true;
}


/* We approve a comment */
if ( isset($serendipity['GET']['adminAction']) && $serendipity['GET']['adminAction'] == 'approve' ) {
    $sql = "SELECT c.*, e.title, a.email as authoremail, a.mail_comments
            FROM {$serendipity['dbPrefix']}comments c
            LEFT JOIN {$serendipity['dbPrefix']}entries e ON (e.id = c.entry_id)
            LEFT JOIN {$serendipity['dbPrefix']}authors a ON (e.authorid = a.authorid)
            WHERE c.id = " . (int)$serendipity['GET']['id']  ." AND status = 'pending'";
    $rs  = serendipity_db_query($sql, true);

    if ($rs === false) {
        echo ERROR .': '. sprintf(COMMENT_ALREADY_APPROVED, $serendipity['GET']['id']);
        return true;
    }

    serendipity_approveComment($serendipity['GET']['id'], $rs['entry_id']);
    echo DONE . ': '. sprintf(COMMENT_APPROVED, $serendipity['GET']['id']);
    return true;
}

/* We are asked to delete a comment */
if ( isset($serendipity['GET']['adminAction']) && $serendipity['GET']['adminAction'] == 'delete' ) {
    serendipity_deleteComment($serendipity['GET']['id'], $serendipity['GET']['entry_id']);
    echo DONE . ': '. sprintf(COMMENT_DELETED, $serendipity['GET']['id']);
    return true;
}

/* We are either in edit mode, or preview mode */
if ( isset($serendipity['GET']['adminAction']) && $serendipity['GET']['adminAction'] == 'edit' || isset($serendipity['POST']['preview'])) {

    /* If we are not in preview, we need data from our database */
    if (!isset($serendipity['POST']['preview']) ) {
        $comment = serendipity_db_query("SELECT * FROM {$serendipity['dbPrefix']}comments WHERE id = ". (int)$serendipity['GET']['id']);
        $data['name']       = $comment[0]['author'];
        $data['email']      = $comment[0]['email'];
        $data['url']        = $comment[0]['url'];
        $data['replyTo']    = $comment[0]['parent_id'];
        $data['comment']    = $comment[0]['body'];

    /* If we are in preview, we get data from our form */
    } elseif ( isset($serendipity['POST']['preview']) ) {
        $data['name']       = $serendipity['POST']['name'];
        $data['email']      = $serendipity['POST']['email'];
        $data['url']        = $serendipity['POST']['url'];
        $data['replyTo']    = $serendipity['POST']['replyTo'];
        $data['comment']    = $serendipity['POST']['comment'];
        serendipity_printComments(
              array(
                array(
                  'email'     => $serendipity['POST']['email'],
                  'author'    => $serendipity['POST']['name'],
                  'body'      => $serendipity['POST']['comment'],
                  'url'       => $serendipity['POST']['url'],
                  'timestamp' => time()
                )
              ),
              false,
              false
            );

    }

    serendipity_displayCommentForm(
      $serendipity['GET']['entry_id'],
      '?serendipity[action]=admin&amp;serendipity[adminModule]=comments&amp;serendipity[adminAction]=doEdit&amp;serendipity[id]=' . $serendipity['GET']['id'] . '&amp;serendipity[entry_id]=' . $serendipity['GET']['entry_id'],
      NULL,
      $data,
      false
    );

    return true;
}

/* Searchable fields */
$filters = array('author', 'email', 'ip', 'url', 'body');

/* Compress the filters into an "AND" SQL query, and a querystring */
foreach ( $filters as $filter ) {
    $and          .= (!empty($serendipity['GET']['filter'][$filter]) ? "AND c.". $filter ." LIKE '%". serendipity_db_escape_string($serendipity['GET']['filter'][$filter]) ."%'" : "");
    $searchString .= (!empty($serendipity['GET']['filter'][$filter]) ? "&amp;serendipity[filter][". $filter ."]=". $serendipity['GET']['filter'][$filter] : "");
}


/* Paging */
$sql = serendipity_db_query("SELECT COUNT(*) AS total FROM {$serendipity['dbPrefix']}comments c WHERE c.type = 'NORMAL' ". $and, true);

$totalComments = $sql['total'];
$pages = ceil($totalComments/$commentsPerPage);
$page = (int)$serendipity['GET']['page'];
if ( $page == 0 || $page > $pages ) {
    $page = 1;
}

if ( $page != 1 && $page <= $pages ) {
    $linkPrevious = '<input type="button" name="serendipity[previouspage]" value="&lt;&lt;&lt;" onclick="location.href=\'serendipity_entries.php?serendipity[adminModule]=comments&amp;serendipity[page]='. ($page-1) . $searchString . '\'" />';
} else {
    $linkPrevious = '<input type="button" name="serendipity[previouspage]" value="&lt;&lt;&lt;" disabled="disabled" />';
}

if ( $page != $pages ) {
    $linkNext = '<input type="button" name="serendipity[nextpage]" value="&gt;&gt;&gt;" onclick="location.href=\'serendipity_entries.php?serendipity[adminModule]=comments&amp;serendipity[page]='. ($page+1) . $searchString . '\'" />';
} else {
    $linkNext = '<input type="button" name="serendipity[nextpage]" value="&gt;&gt;&gt;" disabled="disabled" />';
}

$limit = serendipity_db_limit_sql(serendipity_db_limit(($page-1)*$commentsPerPage, $commentsPerPage));
$sql = serendipity_db_query("SELECT c.*, e.title FROM {$serendipity['dbPrefix']}comments c
                                LEFT JOIN {$serendipity['dbPrefix']}entries e ON (e.id = c.entry_id)
                                WHERE type = 'NORMAL'
                                ". $and ."
                                " . (($serendipity['serendipityUserlevel'] != USERLEVEL_ADMIN) ? 'AND e.authorid = ' . $serendipity['authorId'] : '') . "
                                ORDER BY id DESC $limit");
if (!is_array($sql)) {
    echo NO_COMMENTS;
    return;
}

?>
<script type="text/javascript">
function toggle(id) {
    if ( document.getElementById(id + '_full').style.display == '' ) {
        document.getElementById(id + '_full').style.display='none';
        document.getElementById(id + '_summary').style.display='';
        document.getElementById(id + '_link').innerHTML = '<?php echo VIEW ?>';
    } else {
        document.getElementById(id + '_full').style.display='';
        document.getElementById(id + '_summary').style.display='none';
        document.getElementById(id + '_link').innerHTML = '<?php echo HIDE ?>';
    }
}
function invertSelection() {
    var f = document.formMultiDelete;
    for (var i = 0; i < f.elements.length; i++) {
        if( f.elements[i].type == 'checkbox' ) {
            f.elements[i].checked = !(f.elements[i].checked);
            f.elements[i].onclick();
        }
    }
}
function highlightComment(id, checkvalue) {
    var comment = document.getElementById(id);
    if (checkvalue) {
        comment.style.borderColor = '#FF0000';
        comment.style.borderWidth = 2;
    } else {
        comment.style.borderColor = '';
        comment.style.borderWidth = '';
    }
}
</script>
<form action="" method="GET" style="margin: 0">
<input type="hidden" name="serendipity[adminModule]" value="comments" />
<input type="hidden" name="serendipity[page]" value="<?php echo $page ?>" />
<table class="serendipity_admin_filters" width="100%">
    <tr>
        <td colspan="6" class="serendipity_admin_filters_headline"><strong><?php echo FILTERS ?></strong> - <?php echo FIND_COMMENTS ?></td>
    </tr>
    <tr>
        <td><?php echo AUTHOR ?>:</td>
        <td><input type="text" name="serendipity[filter][author]" size="15" value="<?php echo $serendipity['GET']['filter']['author'] ?>" /></td>
        <td><?php echo EMAIL ?>:</td>
        <td><input type="text" name="serendipity[filter][email]" size="15" value="<?php echo $serendipity['GET']['filter']['email'] ?>" /></td>
        <td><?php echo URL ?>:</td>
        <td><input type="text" name="serendipity[filter][url]" size="15" value="<?php echo $serendipity['GET']['filter']['url'] ?>" /></td>
    </tr>
    <tr>
        <td>IP:</td>
        <td><input type="text" name="serendipity[filter][ip]" size="15" value="<?php echo $serendipity['GET']['filter']['ip'] ?>" /></td>
        <td><?php echo CONTENT ?>:</td>
        <td><input type="text" name="serendipity[filter][body]" size="15" value="<?php echo $serendipity['GET']['filter']['body'] ?>" /></td>
        <td colspan="2" align="center"><input type="submit" name="submit" value=" - <?php echo GO ?> - " /></td>
    </tr>
</table>
</form>
<form action="" method="POST" name="formMultiDelete" id="formMultiDelete">
<input type="hidden" name="serendipity[formAction]" value="multiDelete" />
<table width="100%" cellspacing="5" cellpadding="0" border="0" class="serendipity_admin_list">
<tr>
    <td align="center">
        <table width="100%" cellspacing="5" cellpadding="0" border="0">
            <tr>
                <td><?php echo $linkPrevious; ?></td>
                <td align="center"><?php printf(PAGE_BROWSE_COMMENTS, $page, $pages, $totalComments); ?></td>
                <td align="right"><?php echo $linkNext ?></td>
            </tr>
        </table>
    </td>
</tr>
<?php
$i = 0;
foreach ($sql as $rs) {
    $i++;
    if (empty($rs['author'])) {
        $rs['author'] = ANONYMOUS;
    }
    if (empty($rs['ip'])) {
        $rs['ip'] = '0.0.0.0';
    }
    if (empty($rs['email'])) {
        $rs['email'] = 'N/A';
    }
    if (empty($rs['url'])) {
        $rs['url'] = 'N/A';
    }

    $fullBody = nl2br(strip_tags($rs['body']));
    $summary = substr($fullBody, 0, $summaryLength);

    if (strlen($fullBody) > strlen($summary) ) {
        $summary .= ' ...';
    }

    $class = 'serendipity_admin_list_item_' . (($i++ % 2 == 0 ) ? 'even' : 'uneven');
?>
<tr>
    <td><a name="c<?php echo $rs['id'] ?>"></a>
        <?php echo '#'. $rs['id'] .', '. IN_REPLY_TO .' <strong>'. $rs['title'] .'</strong>, '. ON . ' ' . ucfirst(strftime('%b %e %Y, %H:%M', $rs['timestamp']))?>
    </td>
</tr>
<tr>
    <td class="serendipity_admin_list_item <?php echo $class ?>" style="padding: 3px" id="comment_<?php echo $rs['id'] ?>">
        <table width="100%" cellspacing="0" cellpadding="2" border="0">
            <tr>
                <td rowspan="2" width="20" align="center"><input type="checkbox" name="serendipity[delete][<?php echo $rs['id'] ?>]" value="<?php echo $rs['entry_id'] ?>" onclick="highlightComment('comment_<?php echo $rs['id'] ?>', this.checked)" tabindex="<?php echo $i ?>" /></td>
                <td width="250"><strong><?php echo AUTHOR ?></strong>: <?php echo htmlspecialchars($rs['author']) ?></td>
                <td><strong><?php echo EMAIL ?></strong>: <?php echo htmlspecialchars($rs['email']) ?></td>
            </tr>
            <tr>
                <td><strong>IP</strong>: <?php echo htmlspecialchars($rs['ip']) ?></td>
                <td><strong>URL</strong>: <?php echo htmlspecialchars($rs['url']) ?></td>
            </tr>
            <tr>
                <td style="border-top: 1px solid #CCCCCC; border-bottom: 1px solid #CCCCCC" colspan="3">
                    <div id="<?php echo $rs['id'] ?>_summary"><?php echo $summary ?></div>
                    <div id="<?php echo $rs['id'] ?>_full" style="display: none"><?php echo $fullBody ?></div>
                </td>
            </tr>
        </table>
<?php if ($rs['status'] == 'pending') { ?>
          <strong>[<a href="?serendipity[action]=admin&amp;serendipity[adminModule]=comments&amp;serendipity[adminAction]=approve&amp;serendipity[id]=<?php echo $rs['id'] ?>">Approve</a>]</strong> -
<?php } ?>
          [<a href="?serendipity[action]=admin&amp;serendipity[adminModule]=comments&amp;serendipity[adminAction]=delete&amp;serendipity[id]=<?php echo $rs['id'] ?>&amp;serendipity[entry_id]=<?php echo $rs['entry_id'] ?>" onclick="return confirm('<?php echo sprintf(COMMENT_DELETE_CONFIRM, $rs['id'], htmlspecialchars($rs['author'])) ?>')"><?php echo DELETE ?></a>]
        - [<a href="?serendipity[action]=admin&amp;serendipity[adminModule]=comments&amp;serendipity[adminAction]=edit&amp;serendipity[id]=<?php echo $rs['id'] ?>&amp;serendipity[entry_id]=<?php echo $rs['entry_id'] ?>"><?php echo EDIT ?></a>]
<?php if (strlen($fullBody) > strlen($summary) ) { ?>
        - [<a href="#c<?php echo $rs['id'] ?>" onclick="toggle(<?php echo $rs['id'] ?>); return false;" id="<?php echo $rs['id'] ?>_link"><?php echo VIEW ?></a>]
<?php } ?>
    </td>
</tr>
<tr>
    <td><hr noshade="noshade"></td>
</tr>
<?php } ?>
<tr>
    <td><input type="button" name="toggle" value="<?php echo INVERT_SELECTIONS ?>" onclick="invertSelection()" /> <input type="submit" name="toggle" value="<?php echo DELETE_SELECTED_COMMENTS ?>" onclick="return confirm('<?php echo COMMENTS_DELETE_CONFIRM ?>')" tabindex="<?php echo ($i+1) ?> /></td>
</tr>
<tr>
    <td align="center">
           <table width="100%" cellspacing="5" cellpadding="0" border="0">
            <tr>
                <td><?php echo $linkPrevious; ?></td>
                <td align="center"><?php printf(PAGE_BROWSE_COMMENTS, $page, $pages, $totalComments); ?></td>
                <td align="right"><?php echo $linkNext ?></td>
            </tr>
        </table>
    </td>
</tr>
</table>
</form>
