<?php # $Id: serendipity_admin_entries.inc.php,v 1.37 2004/09/01 17:17:41 tomsommer Exp $

##########################################################################
# serendipity - another blogger...                                       #
##########################################################################
#                                                                        #
# (c) 2003 Jannis Hermanns <J@hacked.it>                                 #
# http://www.jannis.to/programming/serendipity.html                      #
#                                                                        #
##########################################################################

if (IN_serendipity !== true) {
    die ("Don't hack!");
}

$sort_order = array('timestamp'     => DATE,
                    'username'      => AUTHOR,
                    'category_name' => CATEGORY,
                    'last_modified' => LAST_UPDATED,
                    'title'         => TITLE);
$per_page = array('12', '16', '50', '100');


// A little helper we don't want in _functions.inc.php
function serendipity_drawList() {
    global $serendipity, $sort_order, $per_page;

    $perPage = (!empty($serendipity['GET']['sort']['perPage']) ? $serendipity['GET']['sort']['perPage'] : $per_page[0]);
    $page    = (int)$serendipity['GET']['page'];
    $offSet  = $perPage*$page;

    if (empty($serendipity['GET']['sort']['ordermode'])) {
        $serendipity['GET']['sort']['ordermode'] = 'DESC';
    }

    if (!empty($serendipity['GET']['sort']['order'])) {
        $orderby = serendipity_db_escape_string($serendipity['GET']['sort']['order'] . ' ' . $serendipity['GET']['sort']['ordermode']);
    } else {
        $orderby = 'timestamp ' . serendipity_db_escape_string($serendipity['GET']['sort']['ordermode']);
    }

    $filter = array();
    if (!empty($serendipity['GET']['filter']['author'])) {
        $filter[] = "e.authorid = '" . serendipity_db_escape_string($serendipity['GET']['filter']['author']) . "'";
    }

    if (!empty($serendipity['GET']['filter']['category'])) {
        $filter[] = "ec.categoryid = '" . serendipity_db_escape_string($serendipity['GET']['filter']['category']) . "'";
    }

    if (!empty($serendipity['GET']['filter']['body'])) {
        if ($serendipity['dbType'] == 'mysql') {
            $filter[] = "MATCH (title,body,extended) AGAINST ('" . serendipity_db_escape_string($serendipity['GET']['filter']['body']) . "')";
            $full     = true;
        }
    }

    $filter_sql = implode(' AND ', $filter);

    // Fetch the entries
    $entries = serendipity_fetchEntries(
                 false,
                 false,
                 serendipity_db_limit(
                   $offSet,
                   $perPage
                 ),
                 true,
                 false,
                 $orderby,
                 $filter_sql
               );
?>
<form action="?" method="get">
<div class="serendipity_admin_list">
    <input type="hidden" name="serendipity[action]"      value="admin"      />
    <input type="hidden" name="serendipity[adminModule]" value="entries"    />
    <input type="hidden" name="serendipity[adminAction]" value="editSelect" />
    <table width="100%" class="serendipity_admin_filters">
        <tr>
            <td class="serendipity_admin_filters_headline" colspan="6"><strong><?php echo FILTERS ?></strong> - <?php echo FIND_ENTRIES ?></td>
        </tr>
        <tr>
            <td width="80"><?php echo AUTHOR ?></td>
            <td>
                <select name="serendipity[filter][author]">
                    <option value="">--</option>
<?php
                    $users = serendipity_fetchUsers();
                    if (is_array($users)) {
                        foreach ($users AS $user) {
                            echo '<option value="' . $user['authorid'] . '" ' . (isset($serendipity['GET']['filter']['author']) && $serendipity['GET']['filter']['author'] == $user['authorid'] ? 'selected="selected"' : '') . '>' . $user['username'] . '</option>' . "\n";
                        }
                    }
?>              </select>
            </td>
            <td width="80"><?php echo CATEGORY ?></td>
            <td>
                <select name="serendipity[filter][category]">
                    <option value="">--</option>
<?php
                    $categories = serendipity_fetchCategories();
                    if (is_array($categories)) {
                        echo serendipity_generateCategoryList($categories, (isset($serendipity['GET']['filter']['category']) ? array($serendipity['GET']['filter']['category']) : array(0)), 2);
                    }
?>              </select>
            </td>
            <td width="80"><?php echo CONTENT ?></td>
            <td><input size="10" type="text" name="serendipity[filter][body]" value="<?php echo (isset($serendipity['GET']['filter']['body']) ? htmlspecialchars($serendipity['GET']['filter']['body']) : '') ?>" /></td>
        </tr>
        <tr>
            <td class="serendipity_admin_filters_headline" colspan="6"><strong><?php echo SORT_ORDER ?></strong></td>
        </tr>
        <tr>
            <td><?php echo SORT_BY ?></td>
            <td>
                <select name="serendipity[sort][order]">
<?php
    foreach($sort_order as $so_key => $so_val) {
        echo '<option value="' . $so_key . '" ' . (isset($serendipity['GET']['sort']['order']) && $serendipity['GET']['sort']['order'] == $so_key ? 'selected="selected"': '') . '>' . $so_val . '</option>' . "\n";
    }
?>              </select>
            </td>
            <td><?php echo SORT_ORDER ?></td>
            <td>
                <select name="serendipity[sort][ordermode]">
                    <option value="DESC" <?php echo (isset($serendipity['GET']['sort']['ordermode']) && $serendipity['GET']['sort']['ordermode'] == 'DESC' ? 'selected="selected"' : '') ?>><?php echo SORT_ORDER_DESC ?></option>
                    <option value="ASC" <?php echo (isset($serendipity['GET']['sort']['ordermode']) && $serendipity['GET']['sort']['ordermode'] == 'ASC'  ? 'selected="selected"' : '') ?>><?php echo SORT_ORDER_ASC ?></option>
                </select>
            </td>
            <td><?php echo ENTRIES_PER_PAGE ?></td>
            <td>
                <select name="serendipity[sort][perPage]">
<?php
    foreach($per_page AS $per_page_nr) {
       echo '<option value="' . $per_page_nr . '"   ' . (isset($serendipity['GET']['sort']['perPage']) && $serendipity['GET']['sort']['perPage'] == $per_page_nr ? 'selected="selected"' : '') . '>' . $per_page_nr . '</option>' . "\n";
    }

?>
                </select>
            </td>
        </tr>
        <tr>
            <td align="right" colspan="6"><input type="submit" name="go" value="<?php echo GO ?>" /></td>
        </tr>
    </table>
    <table class="serendipity_admin_list" cellpadding="5" width="100%">
<?php
    if (is_array($entries)) {
        $count = count($entries);
        $qString = '?serendipity[adminModule]=entries&amp;serendipity[adminAction]=editSelect';
        foreach ((array)$serendipity['GET']['sort'] as $k => $v) {
            $qString .= '&amp;serendipity[sort]['. $k .']='. $v;
        }
        foreach ((array)$serendipity['GET']['filter'] as $k => $v) {
            $qString .= '&amp;serendipity[filter]['. $k .']='. $v;
        }
        $linkPrevious = $qString . '&amp;serendipity[page]=' . ($page-1);
        $linkNext     = $qString . '&amp;serendipity[page]=' . ($page+1);
?>
        <tr>
            <td>
                <input type="button" name="serendipity[prevpage]" value="&lt;&lt;&lt;" onclick="location.href='<?php echo $linkPrevious ?>'" <?php if ($offSet <= 0) echo ' disabled="disabled"' ?> />
            </td>
            <td align="right">
                <input type="button" name="serendipity[nextpage]" value="&gt;&gt;&gt;" onclick="location.href='<?php echo $linkNext ?>'" <?php if ($count != $perPage) echo ' disabled="disabled"'; ?> />
            </td>
        </tr>
    </table>
    <table class="serendipity_admin_list" cellpadding="5" width="100%">
<?php
        // Print the entries
        $rows = 0;
        foreach ( $entries as $entry ) {
            $rows++;
            // Find out if the entry has been modified later than 30 minutes after creation
            if ($entry['timestamp'] <= ($entry['last_modified'] - 60*30)) {
                $lm = '<a href="#" title="' . LAST_UPDATED . ': ' . serendipity_formatTime(DATE_FORMAT_SHORT, $entry['last_modified']) . '" onclick="alert(this.title)">*</a>';
            } else {
                $lm = '';
            }

?>
        <tr>
            <td class="serendipity_admin_list_item serendipity_admin_list_item_<?php echo ($rows % 2 ? 'even' : 'uneven'); ?>">
                <table width="100%">
                    <tr>
                        <td>
                            <strong><?php if ($entry['isdraft'] == 'true') echo DRAFT . ': '; ?><a href="?serendipity[action]=admin&amp;serendipity[adminModule]=entries&amp;serendipity[adminAction]=edit&amp;serendipity[id]=<?php echo $entry['id']; ?>" title="#<?php echo $entry['id']; ?>"><?php echo serendipity_truncateString($entry['title'],50) ?></a></strong>
                        </td>
                        <td align="right">
                            <?php echo serendipity_formatTime(DATE_FORMAT_SHORT, $entry['timestamp']) . ' ' .$lm; ?>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <?php
                echo POSTED_BY . ' ' . $entry['username'];
                if (count($entry['categories'])) {
                    echo ' ' . IN . ' ';
                    $cats = array();
                    foreach ($entry['categories'] as $cat) {
                        $cats[] = '<a href="' . $serendipity['serendipityHTTPPath'] . ($serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : '') . 'categories/' . $cat['categoryid'] . '_' . serendipity_makeFilename($cat['category_name']) . '">' . $cat['category_name'] . '</a>';
                    }
                    echo implode(', ', $cats);
                }
                ?>

                        </td>
                        <td align="right">
                            [<a href="?serendipity[action]=admin&amp;serendipity[adminModule]=entries&amp;serendipity[adminAction]=edit&amp;serendipity[id]=<?php echo $entry['id']; ?>" title="#<?php echo $entry['id']; ?>"><?php echo EDIT ?></a>]
                          - [<a href="?serendipity[action]=admin&amp;serendipity[adminModule]=entries&amp;serendipity[adminAction]=delete&amp;serendipity[id]=<?php echo $entry['id']; ?>" title="#<?php echo $entry['id']; ?>"><?php echo DELETE ?></a>]
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
<?php
        } // end entries output
?>

        <tr>
            <td class="serendipity_admin_list_item serendipity_admin_list_item_<?php echo (($rows+1) % 2 ? 'even' : 'uneven'); ?>">
                <br />
                    <?php echo EDIT_ENTRY . ': #<input type="text" size="3" name="serendipity[id]" /> <input type="submit" name="serendipity[editSubmit]" value="' . GO . '" />'; ?>
            </td>
        </tr>
 <?php
    } else {
        // We've got nothing
?>
        <tr>
            <td align="center">
                - <?php echo NO_ENTRIES_TO_PRINT ?> -
            </td>
        </tr>
<?php
    }
?>
    </table>
</div>
</form>
<?php
} // End function serendipity_drawList()

if (!empty($serendipity['GET']['editSubmit'])) {
    $serendipity['GET']['adminAction'] = 'edit';
}

switch($serendipity['GET']['adminAction']) {
    case 'save':
        $entry = array(
                   'id'                 => $serendipity['POST']['id'],
                   'title'              => $serendipity['POST']['title'],
                   'timestamp'          => $serendipity['POST']['timestamp'],
                   'body'               => $serendipity['POST']['body'],
                   'extended'           => $serendipity['POST']['extended'],
                   'categories'         => $serendipity['POST']['categories'],
                   'isdraft'            => $serendipity['POST']['isdraft'],
                   'allow_comments'     => $serendipity['POST']['allow_comments'],
                   'moderate_comments'  => $serendipity['POST']['moderate_comments']
        );

        if ($entry['allow_comments'] != 'true' && $entry['allow_comments'] !== true) {
            $entry['allow_comments'] = 'false';
        }

        if ($entry['moderate_comments'] != 'true' && $entry['moderate_comments'] !== true) {
            $entry['moderate_comments'] = 'false';
        }

        // Check if the user changed the timestamp.
        if (isset($serendipity['allowDateManipulation']) && $serendipity['allowDateManipulation'] && isset($serendipity['POST']['new_timestamp']) && $serendipity['POST']['new_timestamp'] != date(DATE_FORMAT_2, $serendipity['POST']['chk_timestamp'])) {
            // The user changed the timestamp, now set the DB-timestamp to the user's date
            $entry['timestamp'] = strtotime($serendipity['POST']['new_timestamp']);

            if ($entry['timestamp'] == -1) {
                echo DATE_INVALID . '<br />';
                // The date given by the user is not convertable. Reset the timestamp.
                $entry['timestamp'] = $serendipity['POST']['timestamp'];
            }
        }

        // Save the entry, or just display a preview
        if ($serendipity['POST']['preview'] != 'true') {
            $res = serendipity_updertEntry($entry);
            if (is_string($res)) {
                serendipity_printEntryForm(
                  '?',
                  array(
                    'serendipity[action]'      => 'admin',
                    'serendipity[adminModule]' => 'entries',
                    'serendipity[adminAction]' => 'save'
                  ),
                  $entry,
                  ERROR . ': <b>' . $res . '</b>');
            } else {
                echo '<div class="serendipity_msg_notice">' . ENTRY_SAVED . '</div>';
            }
        } else {
            // Only display the preview
            $serendipity['hidefooter'] = true;
            if (!is_numeric($entry['timestamp'])) $entry['timestamp']  = time();
            if (!isset($entry['trackbacks']) || !$entry['trackbacks']) $entry['trackbacks'] = 0;
            if (!isset($entry['comments']) || !$entry['comments'])     $entry['comments']   = 0;
            if (!isset($entry['username']) || !$entry['username'])     $entry['username']   = $serendipity['serendipityUser'];

            $categories = (array)$entry['categories'];
            $entry['categories'] = array();
            foreach ( $categories as $catid ) {
                $entry['categories'][] = serendipity_fetchCategoryInfo($catid);
            }

            echo '<strong>' . PREVIEW . '</strong>';
            echo '<div style="border:1px solid #000000; padding: 15px;">';
            serendipity_printEntries(array($entry), ($entry['extended'] != '' ? 1 : 0), true);
            echo '</div>';

            serendipity_printEntryForm(
                '?',
                array(
                  'serendipity[action]'      => 'admin',
                  'serendipity[adminModule]' => 'entries',
                  'serendipity[adminAction]' => 'save',
                  'serendipity[timestamp]'   => $entry['timestamp']
                ),

                $entry
            );
        }
        break;

    case 'editSelect':
        serendipity_drawList();
        break;

    case 'delete':
        $newLoc = '?serendipity[action]=admin&amp;serendipity[adminModule]=entries&amp;serendipity[adminAction]=doDelete&amp;serendipity[id]=' . $serendipity['GET']['id'];
        printf(DELETE_SURE, $serendipity['GET']['id']);
?>
<br />
<div>
    <input type="button" value="<?php echo NOT_REALLY; ?>" onclick="history.go(-1);" />
    <span style="width: 50px;"></span>
    <input type="button" value="<?php echo DUMP_IT; ?>" onclick="location.href='<?php echo $newLoc; ?>'" />
</div>
<?php
        break;

    case 'doDelete':
        serendipity_deleteEntry($serendipity['GET']['id']);
        printf(RIP_ENTRY, $serendipity['GET']['id']);
        break;

    case 'edit':
        $entry = serendipity_fetchEntry('id', $serendipity['GET']['id'], 1, 1);
    default:
        serendipity_printEntryForm(
            '?',
            array(
            'serendipity[action]'      => 'admin',
            'serendipity[adminModule]' => 'entries',
            'serendipity[adminAction]' => 'save'
            ),
            (isset($entry) ? $entry : array())
        );
}
/* vim: set sts=4 ts=4 expandtab : */
?>
