<?php # $Id: serendipity_admin_plugins.inc.php,v 1.44 2004/09/03 23:12:48 tomsommer Exp $

if (IN_serendipity !== true) {
    die ('Don\'t hack!');
}
session_start();

include_once S9Y_INCLUDE_PATH . 'serendipity_plugin_api.php';
include_once S9Y_INCLUDE_PATH . 'serendipity_sidebar_items.php';

if ($serendipity['serendipityUserlevel'] < USERLEVEL_CHIEF) {
    return;
}

function serendipity_pluginListSort($x, $y) {
    return strnatcasecmp($x['name'] . ' - ' . $x['desc'], $y['name'] . ' - ' . $y['desc']);
}

function show_plugins($event_only = false)
{
    global $serendipity;

    /* list of classes for creating instances (standard plugins) */
    $classes = serendipity_plugin_api::enum_plugin_classes($event_only);
?>
<form action="?serendipity[adminModule]=plugins" method="post">
<?php
    $event_only_uri = '';
    if ($event_only) {
        $event_only_uri = '&amp;serendipity[event_plugin]=true';
?>
    <input type="hidden" name="serendipity[event_plugin]" value="true" />
<?php
    }
?>
    <table cellspacing="0" align="center">
        <tr>
            <td colspan="2">
<?php
    $errorstack = array();
    $pluginstack = array();
    foreach ($classes as $class_name) {
        $plugin =& serendipity_plugin_api::load_plugin($class_name);
        if (is_object($plugin)) {
            /* query for its name, description and configuration data */
            $bag = new serendipity_property_bag;
            $plugin->introspect($bag);

            $name = $bag->get('name');
            $desc = $bag->get('description');

            $pluginstack[] = array('class_name' => $class_name,
                                   'name'       => $name,
                                   'desc'       => $desc);
        } else {
            $errorstack[] = $class_name;
        }
    }
    usort($pluginstack, 'serendipity_pluginListSort');
    foreach($errorstack as $e_idx => $e_name) {
        echo ERROR . ': ' . $e_name . '<br />';
    }
?>
                <select name="serendipity[plugin_to_add]">
                    <option value="0">[ <?php echo SELECT_A_PLUGIN_TO_ADD; ?> ]</option>
<?php
    foreach ($pluginstack as $plug) {
?>
                    <option value="<?php echo $plug['class_name']; ?>"><?php echo $plug['name'] . ' - ' . $plug['desc']; ?></option>
<?php
    }
?>
                </select>
            </td>
        </tr>
        <tr>
            <td>
                <input type="checkbox" name="serendipity[all_authors]" value="true" checked="checked" id="all_authors" />
                <label for="all_authors"><?php echo ALL_AUTHORS; ?></label>
            </td>
            <td align="right">
                <input name="NEW" value="<?php echo ADD_PLUGIN; ?>" type="submit" />
            </td>
        </tr>
    </table>
        <br />

        <table border="0" cellpadding="5" cellspacing="0" width="100%">
            <tr>
                <th>&nbsp;</th>
                <th><?php echo TITLE; ?></th>
                <th><?php echo PERMISSIONS; ?></th>
<?php
    if (!$event_only) {
?>
                <th colspan="3"><?php echo PLACEMENT; ?></th>
<?php
    } else {
?>
                <th colspan="2">&nbsp;</th>
<?php } ?>
            </tr>
<?php
    $sort_order = 0;

    /* Block display the plugins per placement location. */
    if ($event_only) {
        $plugin_placements = array('event');
    } else {
        $plugin_placements = array('left', 'right', 'hide');
    }

    foreach ($plugin_placements as $plugin_placement) {
        $plugins = serendipity_plugin_api::enum_plugins($plugin_placement);

        if (!is_array($plugins)) {
            continue;
        }

        $sort_idx = 0;
        foreach ($plugins as $plugin_data) {
            $plugin =& serendipity_plugin_api::load_plugin($plugin_data['name']);
            $key    = urlencode($plugin_data['name']);

            /* query for its name, description and configuration data */
            $bag = new serendipity_property_bag;
            $plugin->introspect($bag);

            $name  = htmlspecialchars($bag->get('name'));
            $desc  = htmlspecialchars($bag->get('description'));
            if ($event_only) {
                $place = '<input type="hidden" name="serendipity[placement][' . $plugin_data['name'] . ']" value="event" />';
            } else {
                $place = placement_box('serendipity[placement][' . $plugin_data['name'] . ']', $plugin_data['placement']);
            }

            $title = serendipity_plugin_api::get_plugin_title($plugin, '[' . $name . ']');

            if ($bag->is_set('configuration') && ($plugin->protected === FALSE || $plugin_data['authorid'] == '0' || $plugin_data['authorid'] == $serendipity['authorid'] || $serendipity['serendipityUserlevel'] >= USERLEVEL_ADMIN)) {
                $url   = '?serendipity[adminModule]=plugins&amp;serendipity[plugin_to_conf]=' . $key;
                $name  = '<a href="' . $url . '">' . $name  . '</a>';
                $title = '<a href="' . $url . '">' . $title . '</a>';
            }

            /* Only display UP/DOWN links if there's somewhere for the plugin to go */
            if ($sort_idx == 0) {
                $moveup   = '&nbsp;';
            } else {
                $moveup   = '<a href="?serendipity[adminModule]=plugins&amp;submit=move+up&amp;serendipity[plugin_to_move]=' . $key . $event_only_uri . '" style="border: 0"><img src="' . serendipity_getTemplateFile('img/up.png') .'" border="0" alt="' . UP . '" /></a>';
            }

            if ($sort_idx == (count($plugins)-1)) {
                $movedown = '&nbsp;';
            } else {
                $movedown = ($moveup != '' ? '&nbsp;' : '') . '<a href="?serendipity[adminModule]=plugins&amp;submit=move+down&serendipity[plugin_to_move]=' . $key . $event_only_uri . '" style="border: 0"><img src="' . serendipity_getTemplateFile('img/down.png') . '" alt="'. DOWN .'" border="0" /></a>';
            }
?>
            <tr>
                <td style="border-bottom: 1px solid #000000">
                    <div>
                    <?php if ($plugin_data['authorid'] == '0' || $plugin_data['authorid'] == $serendipity['authorid'] || $serendipity['serendipityUserlevel'] >= USERLEVEL_ADMIN) { ?>
                        <input type="checkbox" name="serendipity[plugin_to_remove][]" value="<?php echo $plugin_data['name']; ?>" />
                    <?php } else { ?>
                        &nbsp;
                    <?php } ?>
                    </div>
                </td>

                <td style="border-bottom: 1px solid #000000"><strong><?php echo $title; ?></strong><br /><div style="font-size: 8pt"><?php echo $desc; ?></div></td>
                <td style="border-bottom: 1px solid #000000" nowrap="nowrap">
                    <div>
                    <?php
                    if ($plugin_data['authorid'] == $serendipity['authorid'] || $serendipity['serendipityUserlevel'] >= USERLEVEL_ADMIN) {
                        ownership($plugin_data['authorid'], $plugin_data['name']);
                    } else {
                        ownership($plugin_data['authorid'], $plugin_data['name'], true);
                    }
                    ?>
                    </div>
                </td>
            <?php if ( !$event_only ) { ?>
                <td style="border-bottom: 1px solid #000000" nowrap="nowrap">
                    <div><?php echo $place ?></div>
                </td>
            <?php } ?>
                <td style="border-bottom: 1px solid #000000"><?php echo $moveup ?></td>
                <td style="border-bottom: 1px solid #000000"><?php echo $movedown ?></td>
            </tr>
<?php
            $sort_idx++;
        }
    }
?>
        </table>
        <br />
        <div>
            <input type="submit" name="REMOVE" title="<?php echo REMOVE_TICKED_PLUGINS; ?>"  value="<?php echo DELETE; ?>" />
            <input type="submit" name="SAVE"   title="<?php echo SAVE_CHANGES_TO_LAYOUT; ?>" value="<?php echo SAVE; ?>"   />
        </div>
</form>
<?php
}

function ownership($authorid, $name, $readonly = false) {
    global $serendipity;

    static $users = array();
    if (empty($users)) {
        $users = serendipity_fetchUsers();
    }

    if (!$readonly) {
?>
<select name="serendipity[ownership][<?php echo $name; ?>]">
    <option value="0"><?php echo ALL_AUTHORS; ?></option>
<?php
    }

    foreach($users AS $user) {
        if ($readonly && $user['authorid'] == $authorid) {
            $username = htmlspecialchars($user['username']);
        } elseif (!$readonly) {
?>
    <option value="<?php echo $user['authorid']; ?>"<?php echo ($user['authorid'] == $authorid ? ' selected="selected"' : ''); ?>><?php echo htmlspecialchars($user['username']); ?></option>
<?php
        }
    }

    if (!$readonly) {
?>
</select>
<?php
    } else {
        echo (empty($username) ? ALL_AUTHORS : $username);
    }
}

function placement_box($name, $val)
{
    static $opts = array(
                    'left'  => LEFT,
                    'right' => RIGHT,
                    'hide'  => HIDDEN
        );

    $x = "\n<select name=\"$name\">\n";
    foreach ($opts as $k => $v) {
        $x .= "    <option value=\"$k\"" . ($k == $val ? ' selected="selected"' : '') . ">$v</option>\n";
    }
    return $x . "</select>\n";
}

if (isset($_GET['serendipity']['plugin_to_move']) && isset($_GET['submit'])) {
    if (isset($_GET['serendipity']['event_plugin'])) {
        $plugins = serendipity_plugin_api::enum_plugins('event', false);
    } else {
        $plugins = serendipity_plugin_api::enum_plugins('event', true);
    }

    /* Renumber the sort order to be certain that one actually exists
        Also look for the one we're going to move */
    $idx_to_move = -1;
    for($idx = 0; $idx < count($plugins); $idx++) {
        $plugins[$idx]['sort_order'] = $idx;

        if ($plugins[$idx]['name'] == $_GET['serendipity']['plugin_to_move']) {
            $idx_to_move = $idx;
        }
    }

    /* If idx_to_move is still -1 then we never found it (shouldn't happen under normal conditions)
        Also make sure the swaping idx is around */
    if ($idx_to_move >= 0 && (($_GET['submit'] == 'move down' && $idx_to_move < (count($plugins)-1)) || ($_GET['submit'] == 'move up' && $idx_to_move > 0))) {

        /* Swap the one were moving with the one that's in the spot we're moving to */
        $tmp = $plugins[$idx_to_move]['sort_order'];

        $plugins[$idx_to_move]['sort_order'] = (int)$plugins[$idx_to_move + ($_GET['submit'] == 'move down' ? 1 : -1)]['sort_order'];
        $plugins[$idx_to_move + ($_GET['submit'] == 'move down' ? 1 : -1)]['sort_order'] = (int)$tmp;

        /* Update table */
        foreach($plugins as $plugin) {
            $key = serendipity_db_escape_string($plugin['name']);
            serendipity_db_query("UPDATE {$serendipity['dbPrefix']}plugins SET sort_order = {$plugin['sort_order']} WHERE name='$key'");
        }
    }

    /* TODO: Moving The first Right oriented plugin up,
            or the last left oriented plugin down
            should not be displayed to the user as an option.
            It's a behavior which really has no meaning. */
}

if (isset($_GET['serendipity']['plugin_to_conf'])) {
    /* configure a specific instance */
    $plugin =& serendipity_plugin_api::load_plugin($_GET['serendipity']['plugin_to_conf']);

    if (!($plugin->protected === FALSE || $plugin->serendipity_owner == '0' || $plugin->serendipity_owner == $serendipity['authorid'] || $serendipity['serendipityUserlevel'] >= USERLEVEL_ADMIN)) {
        return;
    }

    $bag  = new serendipity_property_bag;
    $plugin->introspect($bag);
    $name = htmlspecialchars($bag->get('name'));
    $desc = htmlspecialchars($bag->get('description'));

    $config_names = $bag->get('configuration');

    if (isset($_POST['SAVECONF'])) {
        /* enum properties and set their values */

        foreach ($config_names as $config_item) {
            $cbag = new serendipity_property_bag;
            if ($plugin->introspect_config_item($config_item, $cbag)) {
                $plugin->set_config($config_item, $_POST['serendipity']['plugin'][$config_item]);
            }
        }

        $plugin->cleanup();
        $statusMsg = sprintf(SETTINGS_SAVED_AT, strftime('%T'));
    }
?>
<form method="post" name="serendipityPluginConfigure">
    <table cellpadding="5" style="border: 1px dashed" width="90%" align="center">
        <tr>
            <th width="100"><?php echo NAME; ?></th>
            <td><?php echo $name; ?></td>
        </tr>

        <tr>
            <th><?php echo DESCRIPTION; ?></th>
            <td><?php echo $desc; ?></td>
        </tr>
    </table>
<br />
    <table border="0" cellspacing="0" cellpadding="3" width="100%">
<?php
    foreach ($config_names as $config_item) {
        $cbag = new serendipity_property_bag;
        $plugin->introspect_config_item($config_item, $cbag);

        $cname      = htmlspecialchars($cbag->get('name'));
        $cdesc      = htmlspecialchars($cbag->get('description'));
        $value      = $plugin->get_config($config_item, 'unset');

        /* Apparently no value was set for this config item */
        if ($value === 'unset') {
            /* Try and the default value for the config item */
            $value = $cbag->get('default');
           
            /* Still, we don't have a value, try and get (bool)false - from an old plugin */ 
            if ($value === '') {
                $value = $plugin->get_config($config_item, false, true);
            }
        }
        $hvalue   = (isset($_POST['serendipity']['plugin'][$config_item]) ? htmlspecialchars($_POST['serendipity']['plugin'][$config_item]) : htmlspecialchars($value));
        $radio    = array();
        $select   = array();

        switch ($cbag->get('type')) {
            case 'seperator':
?>
        <tr>
            <td colspan="2"><hr noshade="noshade" size="1" /></td>
        </tr>
<?php
                break;

            case 'select':
                $select = $cbag->get('select_values');
?>
        <tr>
            <td style="border-bottom: 1px solid #000000; vertical-align: top"><strong><?php echo $cname; ?></strong>
<?php
    if ($cdesc != '') {
?>
                <br><span  style="color: #5E7A94; font-size: 8pt;">&nbsp;<?php echo $cdesc; ?></span>
<?php } ?>
            </td>
            <td style="border-bottom: 1px solid #000000; vertical-align: middle" width="250">
                <div>
                    <select name="serendipity[plugin][<?php echo $config_item; ?>]">
<?php
                foreach($select AS $select_value => $select_desc) {
                    $id = htmlspecialchars($config_item . $select_value);
?>
                        <option value="<?php echo $select_value; ?>" <?php echo ($select_value == $hvalue ? 'selected="selected"' : ''); ?> title="<?php echo htmlspecialchars($select_desc); ?>" />
                            <?php echo htmlspecialchars($select_desc); ?>
                        </option>
<?php
                }
?>
                    </select>
                </div>
            </td>
        </tr>
<?php
                break;

            case 'tristate':
                $per_row = 3;
                $radio['value'][] = 'default';
                $radio['desc'][]  = USE_DEFAULT;

            case 'boolean':
                $radio['value'][] = 'true';
                $radio['desc'][]  = YES;

                $radio['value'][] = 'false';
                $radio['desc'][]  = NO;

           case 'radio':
                if (!count($radio) > 0) {
                    $radio = $cbag->get('radio');
                }

                if (empty($per_row)) {
                    $per_row = $cbag->get('radio_per_row');
                    if (empty($per_row)) {
                        $per_row = 2;
                    }
                }
?>
        <tr>
            <td style="border-bottom: 1px solid #000000; vertical-align: top"><strong><?php echo $cname; ?></strong>
<?php
                if ($cdesc != '') {
?>
                <br /><span  style="color: #5E7A94; font-size: 8pt;">&nbsp;<?php echo $cdesc; ?></span>
<?php
                }
?>
            </td>
            <td style="border-bottom: 1px solid #000000; vertical-align: middle;" width="250">
<?php
                $counter = 0;
                foreach($radio['value'] AS $radio_index => $radio_value) {
                    $id = htmlspecialchars($config_item . $radio_value);
                    $counter++;
                    $checked = "";

                    if ($radio_value == 'true' && ($hvalue === '1' || $hvalue === 'true')) {
                        $checked = " checked";
                    } elseif ($radio_value == 'false' && ($hvalue === '' || $hvalue === 'false')) {
                        $checked = " checked";
                    } elseif ($radio_value == $hvalue) {
                        $checked = " checked";
                    }

                    if ($counter == 1) {
?>
                <div>
<?php
                    }
?>
                    <input type="radio" id="serendipity_plugin_<?php echo $id; ?>" name="serendipity[plugin][<?php echo $config_item; ?>]" value="<?php echo $radio_value; ?>" <?php echo $checked ?> title="<?php echo htmlspecialchars($radio['desc'][$radio_index]); ?>" />
                        <label for="serendipity_plugin_<?php echo $id; ?>"><?php echo htmlspecialchars($radio['desc'][$radio_index]); ?></label>
<?php
                    if ($counter == $per_row) {
                        $counter = 0;
?>
                </div>
<?php
                    }
                }
?>
            </td>
        </tr>
<?php
                break;

            case 'string':
?>
        <tr>
            <td style="border-bottom: 1px solid #000000">
                    <strong><?php echo $cname; ?></strong>
                    <br><span style="color: #5E7A94; font-size: 8pt;">&nbsp;<?php echo $cdesc; ?></span>
            </td>
            <td style="border-bottom: 1px solid #000000" width="250">
                <div>
                    <input type="text" name="serendipity[plugin][<?php echo $config_item; ?>]" value="<?php echo $hvalue; ?>" size="30" />
                </div>
            </td>
        </tr>
<?php
                break;

            case 'html':
            case 'text':
?>
        <tr>
            <td colspan="2"><strong><?php echo $cname; ?></strong>
                &nbsp;<span style="color: #5E7A94; font-size: 8pt;">&nbsp;<?php echo $cdesc; ?></span>
            </td>
        </tr>

        <tr>
            <td colspan="2">
                <div>
                    <textarea style="width: 100%" id="nugget" name="serendipity[plugin][<?php echo $config_item; ?>]" rows="20" cols="80"><?php echo $hvalue; ?></textarea>
                </div>
            </td>
        </tr>
<?php
                if ($cbag->get('type') == 'html') {
                    serendipity_emit_htmlarea_code('nugget', 'nugget');
                }
                break;

            case 'hidden':
                ?><tr><td colspan="2"><input type="hidden" name="serendipity[plugin][<?php echo $config_item; ?>]" value="<?php echo $cbag->get('value'); ?>" /></td></tr><?php
                break;
        }
    }
?>
    </table>
<br />
    <div style="padding-left: 20px">
        <input type="submit" name="SAVECONF" value="<?php echo SAVE; ?>" />
    </div>
</form>
<?php
    if (isset($_POST['SAVECONF'])) {
        echo '<span class="serendipity_msg_notice">' . DONE . ': '. $statusMsg .'</span>';
    }
} else {
    /* show general plugin list */

    if (isset($_POST['SAVE']) && isset($_POST['serendipity']['placement'])) {
        foreach ($_POST['serendipity']['placement'] as $plugin_name => $placement) {
            serendipity_plugin_api::update_plugin_placement(
                addslashes($plugin_name),
                addslashes($placement)
            );

            serendipity_plugin_api::update_plugin_owner(
                addslashes($plugin_name),
                addslashes($_POST['serendipity']['ownership'][$plugin_name])
            );
        }
    }

    if (isset($_POST['NEW']) && $_POST['serendipity']['plugin_to_add'] != '0') {
        $authorid = $serendipity['authorid'];
        if (isset($_POST['serendipity']['all_authors']) && $_POST['serendipity']['all_authors'] == 'true') {
            $authorid = '0';
        }

        if (isset($_POST['serendipity']['event_plugin'])) {
            $inst = serendipity_plugin_api::create_plugin_instance($_POST['serendipity']['plugin_to_add'], null, 'event', $authorid);
        } else {
            $inst = serendipity_plugin_api::create_plugin_instance($_POST['serendipity']['plugin_to_add'], null, 'right', $authorid);
        }

        /* Load the new plugin */
        $plugin = &serendipity_plugin_api::load_plugin($inst);
        $bag  = new serendipity_property_bag;
        $plugin->introspect($bag);

        /* Only play with the plugin if there is something to play with */
        if ($bag->is_set('configuration')) {
            echo '<script type="text/javascript">location.href = \'' . $serendipity['baseurl'] . '?serendipity[adminModule]=plugins&amp;serendipity[plugin_to_conf]=' . $inst . '\';</script>';
            die();
        }
    }

    if (isset($_POST['REMOVE'])) {
        foreach ($_POST['serendipity']['plugin_to_remove'] as $key) {
            $plugin =& serendipity_plugin_api::load_plugin($key);

            if ($plugin->serendipity_owner == '0' || $plugin->serendipity_owner == $serendipity['authorid'] || $serendipity['serendipityUserlevel'] >= USERLEVEL_ADMIN) {
                serendipity_plugin_api::remove_plugin_instance($key);
            }
        }
    }

    echo '<h2>' . SIDEBAR_PLUGINS . '</h2>';
    show_plugins(false);

    echo '<h2>' . EVENT_PLUGINS . '</h2>';
    show_plugins(true);
}
/* vim: set sts=4 ts=4 expandtab : */
?>
