<?php # $Id: serendipity_config.inc.php,v 1.95 2004/09/16 13:53:04 garvinhicking Exp $
# Copyright (c) 2003-2004, Jannis Hermanns
# All rights reserved.  See LICENSE file for licensing details
if (!defined('S9Y_INCLUDE_PATH')) {
    define('S9Y_INCLUDE_PATH', dirname(__FILE__) . '/');
}
define('S9Y_CONFIG_TEMPLATE', S9Y_INCLUDE_PATH . 'serendipity_config_local.tpl');
define('S9Y_CONFIG_USERTEMPLATE', S9Y_INCLUDE_PATH . 'serendipity_config_user.tpl');

define('IS_installed', file_exists('serendipity_config_local.inc.php'));

if ( IS_installed === true ) {
    define('IN_serendipity', true);
}

include_once(S9Y_INCLUDE_PATH . 'compat.php');

$serendipity['version']         = '0.7-beta3';
$serendipity['defaultTemplate'] = 'default'; // Name of folder for the default theme
$serendipity['production']      = 1;
$serendipity['rewrite']         = 'none';
$serendipity['messagestack']    = array();

if ($serendipity['production'] == 1) {
    error_reporting(E_ALL & ~E_NOTICE);
} else {
    error_reporting(E_ALL);
}

// Can the user change the date of publishing for an entry?
$serendipity['allowDateManipulation'] = true;

// Is the possibility to comment and entry enabled by default?
$serendipity['allowCommentsDefault'] = true;

// Should comment moderation be enabled by default?
$serendipity['moderateCommentsDefault'] = false;

// How much time is allowed to pass since the publising of an entry, so that a comment to that entry
// will update it's LastModified stamp? If the time is passed, a comment to an old entry will no longer
// push an article as being updated.
$serendipity['max_last_modified']    = 60 * 60 * 24 * 7;

// Clients can send a If-Modified Header to the RSS Feed (Conditional Get) and receive all articles beyond
// that date. However it is still limited by the number below of maximum entries
$serendipity['max_fetch_limit']      = 50;

// How many bytes are allowed for fetching trackbacks, so that no binary files get accidently trackbacked?
$serendipity['trackback_filelimit']  = 150 * 1024;

/*
 *   Load main language file
 */
include($serendipity['serendipityPath'] . 'serendipity_lang.inc.php');

/* URI paths
 * These could be defined in the language headers, except that would break
 * backwards URL compatibility
 */
@define('PATH_ARCHIVES', 'archives');
@define('PATH_ARCHIVE', 'archive');
@define('PATH_UNSUBSCRIBE', 'unsubscribe');
@define('PATH_DELETE', 'delete');
@define('PATH_APPROVE', 'approve');
@define('PATH_FEEDS', 'feeds');
@define('PATH_ADMIN', 'admin');
@define('PATH_ENTRIES', 'entries');
@define('PATH_CATEGORIES', 'categories');
@define('PATH_PLUGIN', 'plugin');

/* URI patterns
 * Note that it's important to use @ as the pattern delimiter.
 */
@define('PAT_FILENAME', '0-9a-z\.\_!%;,\+\-');
@define('PAT_UNSUBSCRIBE', '@/'.PATH_UNSUBSCRIBE.'/(.*)/([0-9]+)@');
@define('PAT_APPROVE', '@/'.PATH_APPROVE.'/(.*)/(.*)/([0-9]+)@');
@define('PAT_DELETE', '@/'.PATH_DELETE.'/(.*)/(.*)/([0-9]+)@');
@define('PAT_ARCHIVES', '@/'.PATH_ARCHIVES.'/(\d+)\.html@');
@define('PAT_ARCHIVES_SHORT', '@/'.PATH_ARCHIVES.'/(\d+)[_\-]short\.html@');
@define('PAT_COMMENTSUB', '@/(\d+)[_\-][' . PAT_FILENAME . ']*\.html@i');
@define('PAT_FEEDS', '@/'.PATH_FEEDS.'/@');
@define('PAT_FEED', '@/(index|atom|rss|b2rss|b2rdf).(rss|rdf|rss2|xml)$@');
@define('PAT_ADMIN', '@/'.PATH_ADMIN.'$@');
@define('PAT_ENTRIES', '@/'.PATH_ENTRIES.'$@');
@define('PAT_ARCHIVE', '@/'.PATH_ARCHIVE.'$@');
@define('PAT_CATEGORIES', '@/'.PATH_CATEGORIES.'/(\d+)[_\-].*@');
@define('PAT_PLUGIN', '@/' . PATH_PLUGIN . '/(.*)@');

@define('USERLEVEL_ADMIN', 255);
@define('USERLEVEL_CHIEF', 1);
@define('USERLEVEL_EDITOR', 0);

@define('VIEWMODE_THREADED', 'threaded');
@define('VIEWMODE_LINEAR', 'linear');


/*
 *   Kill the script if we are not installed, and not inside the installer
 */
if ( !defined('IN_installer') && IS_installed === false ) {
    die(sprintf(SERENDIPITY_NOT_INSTALLED, 'serendipity_admin.php'));
}

if (defined('IN_installer') && IS_installed === false) {
    $serendipity['lang'] = $serendipity['autolang'];
    return 1;
}

/*
 *   Load DB configuration information
 *   Load Functions
 *   Make sure that the file included is in the current directory and not any possible
 *   include path
 */
if (file_exists($_SERVER['DOCUMENT_ROOT'] . dirname($_SERVER['PHP_SELF']) . '/serendipity_config_local.inc.php')) {
    include_once($_SERVER['DOCUMENT_ROOT'] . dirname($_SERVER['PHP_SELF']) . '/serendipity_config_local.inc.php');
} elseif (file_exists($serendipity['serendipityPath'] . '/serendipity_config_local.inc.php')) {
    include_once($serendipity['serendipityPath'] . '/serendipity_config_local.inc.php');
} else {
    include_once(S9Y_INCLUDE_PATH . '/serendipity_config_local.inc.php');
}

/*
 *  Include main functions
 */
include_once(S9Y_INCLUDE_PATH . 'serendipity_functions.inc.php');

if (serendipity_FUNCTIONS_LOADED!== true) {
    die(sprintf(INCLUDE_ERROR, 'serendipity_functions.inc.php'));
}

/*
 *   Attempt to connect to the database
 */
if (!serendipity_db_connect()) {
    die(DATABASE_ERROR);
}


/*
 *   Load Configuration options from the database
 */

serendipity_load_configuration();

/*
 * If a user is logged in, fetch his preferences. He possibly wants to have a different language
 */
if (isset($_SESSION['serendipityAuthorid'])) {
    serendipity_load_configuration($_SESSION['serendipityAuthorid']);
}

/*
 *   Load main language file again, because now we have the preferred language
 */
define('IS_up2date', version_compare(serendipity_version($serendipity['version']), serendipity_version($serendipity['versionInstalled']), '<='));

include(S9Y_INCLUDE_PATH .'serendipity_lang.inc.php');

/*
 *   Set current locale, if any has been defined
 */
if (defined('DATE_LOCALES')) {
    $locales = explode(',', DATE_LOCALES);
    foreach ($locales as $locale) {
        $locale = trim($locale);
        if (setlocale(LC_TIME, $locale) == $locale) {
            break;
        }
    }
}

/*
 *   Fallback charset, if none is defined in the language files
 */
@define('LANG_CHARSET', 'ISO-8859-1');


if ($serendipity['embed'] && ($serendipity['embed'] === 'true' || $serendipity['embed'] === true)) {
    $serendipity['baseURL'] = 'http://' . $_SERVER['HTTP_HOST'] . $serendipity['serendipityHTTPPath'];
}

/*
 *  Check if the installed version is highter than the version of the config
 */

if (IS_up2date === false && $serendipity['production'] && !defined('IN_upgrader')) {
    die(sprintf(SERENDIPITY_NEEDS_UPGRADE, $serendipity['versionInstalled'], $serendipity['version'], 'serendipity_admin.php'));
}

// We don't care who tells us what to do
if (!isset($serendipity['GET']['action'])) {
    $serendipity['GET']['action'] = (isset($serendipity['POST']['action']) ? $serendipity['POST']['action'] : '');
}

if (!isset($serendipity['GET']['adminAction'])) {
    $serendipity['GET']['adminAction'] = (isset($serendipity['POST']['adminAction']) ? $serendipity['POST']['adminAction'] : '');
}

// Some stuff...
if (!isset($_SESSION['serendipityAuthedUser'])) {
    $_SESSION['serendipityAuthedUser'] = false;
}

$old_include = @ini_get('include_path');
@ini_set('include_path', $serendipity['serendipityPath'] . PATH_SEPARATOR . $serendipity['serendipityPath'] . 'bundled-libs/' . PATH_SEPARATOR . $old_include);

if (isset($_SESSION['serendipityUser'])) {
    $serendipity['user']  = $_SESSION['serendipityUser'];
}

if (isset($_SESSION['serendipityEmail'])) {
    $serendipity['email'] = $_SESSION['serendipityEmail'];
}

/* Signature sent with all mails */
$serendipity['signature'] = sprintf(SIGNATURE, $serendipity['blogTitle']);

/* Default mail headers */
$serendipity['mailheaders'] = 'X-Mailer: Serendipity/'. $serendipity['version'] . "\n"
                            . 'X-Engine: PHP/'. phpversion();

serendipity_plugin_api::hook_event('frontend_configure', $serendipity);

/* vim: set sts=4 ts=4 expandtab : */
?>
