<?php # $Id: serendipity_entries.php,v 1.40 2004/08/30 18:56:19 tadpole9 Exp $
# Copyright (c) 2003-2004, Jannis Hermanns
# All rights reserved.  See LICENSE file for licensing details


session_start();
if (file_exists('./serendipity_config_local.inc.php')) {
    include('serendipity_config.inc.php');
} else {
    $_SESSION['serendipityAuthedUser'] = true;
}

header('Content-Type: text/html; charset=' . LANG_CHARSET);

if (isset($serendipity['GET']['adminModule']) && $serendipity['GET']['adminModule'] == 'logout'){
    serendipity_logout();
} else {
    serendipity_login();
}

?>
<html>
<head>
    <title><?php echo SERENDIPITY_AUTHORING_SUITE; ?></title>
    <meta http-equiv="Content-Type" content="text/html; charset=<?php echo LANG_CHARSET; ?>" />
    <link rel="stylesheet" type="text/css" href="<?php echo $serendipity['serendipityHTTPPath']; ?>serendipity.css.php" />
<?php
if (strtolower($serendipity['extCSS']) != 'none' && $serendipity['extCSS'] != '') {
?>
    <link rel="stylesheet" type="text/css" href="<?php echo $serendipity['extCSS']; ?>" />
<?php
}
?>

</head>

<body class="s9y_wrap" id="serendipity_admin_entries_page" onload="if (self.Spawnextended) { Spawnextended(); } if (self.Spawnbody) { Spawnbody(); }">
    <div id="serendipity_banner">
        <h1><?php echo $serendipity['blogTitle'] ; ?></h1>
        <h2><?php echo SERENDIPITY_AUTHORING_SUITE . ((serendipity_userLoggedIn()) ? ' ('. sprintf(USER_SELF_INFO, $serendipity['serendipityUser'], $serendipity['serendipityUserlevel']) .')' : ''); ?></h2>
    </div>

    <table id="mainpane">
        <tr valign="top">
<?php
if ( !serendipity_userLoggedIn() ) {
   serendipity_printLogin();
} else {
?>
            <td id="serendipityLeftSideBar">
                <div class="serendipitySideBarItem">
                    <div class="serendipitySideBarTitle"><?php echo ucfirst(ENTRIES); ?>:</div>
                    <div class="serendipitySideBarContent">
                        &bull; <a href="?serendipity[adminModule]=entries&amp;serendipity[adminAction]=new"><?php          echo NEW_ENTRY;      ?></a><br />
                        &bull; <a href="?serendipity[adminModule]=entries&amp;serendipity[adminAction]=editSelect"><?php   echo EDIT_ENTRIES;   ?></a><br />
                        &bull; <a href="?serendipity[adminModule]=comments"><?php                                          echo COMMENTS;   ?></a><br />
                        <?php serendipity_plugin_api::hook_event('backend_sidebar_entries', $serendipity); ?>
                    </div>
                </div>

                <div class="serendipitySideBarItem">
                    <div class="serendipitySideBarTitle"><?php echo CATEGORIES; ?>:</div>
                    <div class="serendipitySideBarContent">
                        &bull; <a href="?serendipity[adminModule]=category&amp;serendipity[adminAction]=editSelect"><?php  echo EDIT_CATEGORIES; ?></a><br />
                        <?php serendipity_plugin_api::hook_event('backend_sidebar_entries_categories', $serendipity); ?>
                    </div>
                </div>

                <div class="serendipitySideBarItem">
                    <div class="serendipitySideBarTitle"><?php echo MEDIA; ?></div>
                    <div class="serendipitySideBarContent">
                        &bull; <a href="?serendipity[adminModule]=images&amp;serendipity[adminAction]=addSelect"><?php echo ADD_MEDIA; ?></a><br />
                        &bull; <a href="?serendipity[adminModule]=images"><?php echo MEDIA_LIBRARY; ?></a><br />
                        <?php if ($serendipity['serendipityUserlevel'] >= USERLEVEL_CHIEF) { ?>
                        &bull; <a href="?serendipity[adminModule]=images&amp;serendipity[adminAction]=directorySelect"><?php echo MANAGE_DIRECTORIES; ?></a><br />
                        <?php } ?>
                        &bull; <a href="?serendipity[adminModule]=images&amp;serendipity[adminAction]=sync" onclick="return confirm('<?php echo WARNING_THIS_BLAHBLAH; ?>');"><?php echo CREATE_THUMBS; ?></a><br />
                        <?php serendipity_plugin_api::hook_event('backend_sidebar_entries_images', $serendipity); ?>
                    </div>
                </div>

                <div class="serendipitySideBarItem">
                    <div class="serendipitySideBarContent">
                        &bull; <a href="<?php echo $serendipity['serendipityHTTPPath']; ?>serendipity_admin.php"><?php echo ADMIN_INTERFACE; ?></a><br />
                        &bull; <a href="<?php echo $serendipity['serendipityHTTPPath']; ?>"                     ><?php echo BACK_TO_BLOG;    ?></a><br />
                        &bull; <a href="?serendipity[adminModule]=logout"                                       ><?php echo LOGOUT;          ?></a><br />
                    </div>
                </div>
            </td>

            <td id="content">
                <div class="serendipity_Admin_title"><?php echo SERENDIPITY_AUTHORING_SUITE; ?></div>
                <div class="serendipity_Admin">
<?php
    if (!isset($serendipity['GET']['adminModule'])) {
        $serendipity['GET']['adminModule'] = (isset($serendipity['POST']['adminModule']) ? $serendipity['POST']['adminModule'] : '');
    }

    switch($serendipity['GET']['adminModule']) {
        case 'entries':
            include S9Y_INCLUDE_PATH . 'serendipity_admin_entries.inc.php';
            break;

        case 'images':
            include S9Y_INCLUDE_PATH . 'serendipity_admin_images.inc.php';
            break;

        case 'comments':
            include S9Y_INCLUDE_PATH . 'serendipity_admin_comments.inc.php';
            break;

        case 'category':
            include S9Y_INCLUDE_PATH . 'serendipity_admin_category.inc.php';
            break;

        case 'logout':
            echo LOGGEDOUT;
            break;

        case 'event_display':
            serendipity_plugin_api::hook_event('backend_sidebar_entries_event_display_' . $serendipity['GET']['adminAction'], $serendipity);
            break;

        default:
            include S9Y_INCLUDE_PATH . 'serendipity_entries_overview.inc.php';
    }
?>
                </div>
<?php
}
?>
            </td>
        </tr>
    </table>
</body>
</html>
<?php
/* vim: set sts=4 ts=4 expandtab : */
?>
