<?php # $Id: serendipity_functions.inc.php,v 1.430 2004/09/20 14:17:33 garvinhicking Exp $
# Copyright (c) 2003-2004, Jannis Hermanns
# All rights reserved.  See LICENSE file for licensing details

$serendipity['imageList'] = array();
include_once(S9Y_INCLUDE_PATH . "serendipity_db.inc.php");
include_once(S9Y_INCLUDE_PATH . "compat.php");
include_once(S9Y_INCLUDE_PATH . "serendipity_functions_config.inc.php");
include_once(S9Y_INCLUDE_PATH . "bundled-libs/XML/RPC.php");
include_once(S9Y_INCLUDE_PATH . "serendipity_plugin_api.php");
include_once(S9Y_INCLUDE_PATH . "serendipity_functions_images.inc.php");
include_once(S9Y_INCLUDE_PATH . "serendipity_functions_installer.inc.php");

function serendipity_truncateString($s, $len) {
    if ( strlen($s) > ($len+3) ) {
        $s = substr($s, 0, $len) . '...';
    }
    return $s;
}

function serendipity_formatTime($format, $time) {
    static $cache;
    if (!isset($cache)) {
        $cache = array();
    }

    if (!isset($cache[$format])) {
        $cache[$format] = $format;
        if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
            $cache[$format] = str_replace('%e', '%d', $cache[$format]);
        }
    }
    return ucfirst(strftime($cache[$format], (int)$time));
}


function serendipity_logout() {
    $_SESSION['serendipityAuthedUser'] = false;
    @session_destroy();
    serendipity_deleteCookie('author_information');
}

function serendipity_login() {
    global $serendipity;

    if (serendipity_authenticate_author()) {
        #The session has this data already
        #we previously just checked the value of $_SESSION['serendipityAuthedUser'] but
        #we need the authorid still, so call serendipity_authenticate_author with blank
        #params
        return true;
    }

    if (serendipity_authenticate_author($serendipity['POST']['user'], $serendipity['POST']['pass'])) {
        if (empty($serendipity['POST']['auto'])) {
            serendipity_deleteCookie('author_information');
            return false;
        } else {
            $package = serialize(array('username' => $serendipity['POST']['user'],
                                       'password' => $serendipity['POST']['pass']));
            serendipity_setCookie('author_information', base64_encode($package));
            return true;
        }
    } elseif ( isset($serendipity['COOKIE']['author_information']) ) {
        $cookie = unserialize(base64_decode($serendipity['COOKIE']['author_information']));
        if (serendipity_authenticate_author($cookie['username'], $cookie['password'])) {
            return true;
        } else {
            serendipity_deleteCookie('author_information');
            return false;
        }
    }
}

function serendipity_userLoggedIn() {
    if ($_SESSION['serendipityAuthedUser'] === true && IS_installed) {
        return true;
    } else {
        return false;
    }
}

function serendipity_printLogin() {
    global $serendipity;
?>
    <td id="content">
    <div class="serendipity_admin_title serendipity_center"><?php echo HAVE_TO_BE_LOGGED_ON ?></div>
    <div class="serendipity_admin">
<?php
    if ( isset($serendipity['POST']['action']) && !serendipity_userLoggedIn() ) {
?>
        <div class="serendipity_center serendipity_msg_important"><?php echo WRONG_USERNAME_OR_PASSWORD; ?></div>
<?php
    }
?>
            <form action="?" method="post">
                <input type="hidden"   name="serendipity[action]" value="admin" />
                <table cellspacing="3" cellpadding="0" border="0" align="center" width="300">
                    <tr>
                        <td><?php echo USERNAME ?></td>
                        <td><input type="text" name="serendipity[user]" /></td>
                    </tr>
                    <tr>
                        <td><?php echo PASSWORD ?></td><td><input type="password" name="serendipity[pass]" /></td>
                    </tr>
                    <tr>
                        <td colspan="2"><input id="autologin" type="checkbox" name="serendipity[auto]" /><label for="autologin"> <?php echo AUTOMATIC_LOGIN ?></label></td>
                    </tr>
                    <tr>
                        <td colspan="2" align="right"><input type="submit" name="submit" value="<?php echo LOGIN ?> &gt;" /></td>
                    </tr>
                </table>
            </form>
    </div>
    <a href="<?php echo $serendipity['serendipityHTTPPath']; ?>"><?php echo BACK_TO_BLOG;?></a>
<?php
}

function serendipity_fetchTemplates() {
    global $serendipity;
    $dir = opendir($serendipity['serendipityPath'] . $serendipity['templatePath']);
    while (($file = readdir($dir)) !== false) {
        if (is_dir($serendipity['serendipityPath'] . $serendipity['templatePath'] . $file) && !ereg('^(\.|CVS)', $file) && !file_exists($serendipity['serendipityPath'] . $serendipity['templatePath'] . $file . '/inactive.txt') && file_exists($serendipity['serendipityPath'] . $serendipity['templatePath'] . $file . '/info.txt')) {
            $rv[] = $file;
        }
    }
    natcasesort($rv);
    return $rv;
}

function serendipity_fetchTemplateInfo($theme) {
    global $serendipity;
    /* Blame jannis */
    $lines = file($serendipity['serendipityPath'] . $serendipity['templatePath'] . $theme . '/info.txt');

    for($x=0; $x<count($lines); $x++) {
        $j = preg_split('/([^\:]+)\:/', $lines[$x], -1, PREG_SPLIT_DELIM_CAPTURE);
        if ($j[2]) {
            $currSec = $j[1];
            $data[strtolower($currSec)][] = trim($j[2]);
        } else {
            $data[strtolower($currSec)][] = trim($j[0]);
        }
    }

    foreach ($data as $k => $v) {
        $data[$k] = implode("\n", $v);
    }

    return $data;
}

function serendipity_saveTemplateSelection($theme) {
    serendipity_set_config_var('template', $theme);
}

function serendipity_printTemplates($themelist) {
    global $serendipity;
?>
<div>
    <form method="post" action="<?php echo $serendipity['serendipityHTTPPath']; ?>serendipity_admin.php?serendipity[adminModule]=templates&amp;serendipity[adminAction]=save">
<?php
    foreach ($themelist as $theme) {
        $info = serendipity_fetchTemplateInfo($theme);
        if (file_exists($serendipity['serendipityPath'] . $serendipity['templatePath'] . $theme . '/preview.png')) {
            $preview = '<img src="templates/' . $theme . '/preview.png" width="100" style="border: 1px #000000 solid" />';
        } else {
            $preview = '&nbsp;';
        }

        if (serendipity_get_config_var('template', $serendipity['defaultTemplate']) == $theme) {
            $is_active = 'checked="checked"';
        } else {
            $is_active = '';
        }

        $jsLine  = " onmousedown=\"document.getElementById('serendipity_theme_radio_". $theme ."').checked = true;\"";
        $jsLine .= " onmouseout=\"document.getElementById('serendipity_theme_". $theme ."').className='';\"";
        $jsLine .= " onmouseover=\"document.getElementById('serendipity_theme_". $theme ."').className='serendipity_admin_list_item_uneven'; style.cursor = 'pointer';\"";
?>
    <table width="100%" id="serendipity_theme_<?php echo $theme; ?>">
        <tr>
            <td colspan="3" <?php echo $jsLine ?>><strong><?php echo $info['name']; ?></strong></td>
        </tr>

        <tr>
            <td width="100" <?php echo $jsLine ?> style="padding-left: 10px"><?php echo $preview; ?></td>

            <td valign="top" <?php echo $jsLine ?>>
                <?php echo AUTHOR; ?>      : <?php echo $info['author'];?><br />
                <?php echo LAST_UPDATED; ?>: <?php echo $info['date'];  ?>
            </td>

            <td valign="middle" align="center" width="70" <?php echo $jsLine ?>>
                <div><input type="radio" name="serendipity[theme]" value="<?php echo $theme; ?>" id="serendipity_theme_radio_<?php echo $theme; ?>" <?php echo $is_active; ?> /></div>
            </td>
        </tr>
    </table>
    <br />
<?php
    }
?>
        <div align="right"><input type="submit" name="submit" value="<?php echo SET_AS_TEMPLATE; ?>" /></div>
    </form>
</div>
<?php
}

function serendipity_displayCommentForm($id, $url = '', $comments = NULL, $data = NULL, $showToolbar = true, $moderate_comments = true) {
    global $serendipity;

    if ( $comments == NULL ) {
        $comments = serendipity_fetchComments($id);
    }

?>
<div class="serendipityCommentForm">
    <a <?php echo ($serendipity['XHTML11'] ? 'id' : 'name'); ?>="serendipity_CommentForm"></a>
    <form <?php echo ($serendipity['XHTML11'] ? 'id' : 'name'); ?>="serendipity_comment" action="<?php echo $url; ?>" method="post">
    <div><input type="hidden" name="serendipity[entry_id]" value="<?php echo $id; ?>" /></div>
    <table border="0" width="100%" cellpadding="3">
        <tr>
            <td class="serendipity_commentsLabel"><?php echo NAME; ?></td>
            <td class="serendipity_commentsValue"><input type="text" name="serendipity[name]" value="<?php echo (isset($data['name']) ? $data['name'] : (isset($serendipity['COOKIE']['name']) ? $serendipity['COOKIE']['name'] : '')); ?>" size="30" /></td>
        </tr>

        <tr>
            <td class="serendipity_commentsLabel"><?php echo EMAIL; ?></td>
            <td class="serendipity_commentsValue"><input type="text" name="serendipity[email]" value="<?php echo (isset($data['email']) ? $data['email'] : (isset($serendipity['COOKIE']['email']) ? $serendipity['COOKIE']['email'] : '')); ?>" /></td>
        </tr>

        <tr>
            <td class="serendipity_commentsLabel"><?php echo HOMEPAGE; ?></td>
            <td class="serendipity_commentsValue"><input type="text" name="serendipity[url]" value="<?php echo (isset($data['url']) ? $data['url'] : (isset($serendipity['COOKIE']['url']) ? $serendipity['COOKIE']['url'] : '')); ?>" /></td>
        </tr>

        <tr>
            <td class="serendipity_commentsLabel"><?php echo IN_REPLY_TO; ?></td>
            <td class="serendipity_commentsValue"><?php echo serendipity_generateCommentList($id, $comments, ((isset($data['replyTo']) && ($data['replyTo'])) ? $data['replyTo'] : 0)); ?></td>
        </tr>

        <tr>
            <td class="serendipity_commentsLabel"><?php echo COMMENT; ?></td>
            <td class="serendipity_commentsValue">
                <textarea rows="10" cols="40" name="serendipity[comment]"><?php echo (isset($data['comment']) ? $data['comment'] : ''); ?></textarea><br />
                <?php serendipity_plugin_api::hook_event('frontend_comment', $nullParam); ?>
            </td>
        </tr>
<?php if ( $showToolbar ) { ?>
        <tr>
            <td>&nbsp;</td>
            <td class="serendipity_commentsLabel">
                <input id="checkbox_remember" type="checkbox" name="serendipity[remember]" <?php echo (isset($data['remember']) ? 'checked="checked"' : isset($serendipity['COOKIE']['remember']) ? $serendipity['COOKIE']['remember'] : '') ; ?> /><label for="checkbox_remember"> <?php echo REMEMBER_INFO; ?></label>
<?php
        if ($serendipity['allowSubscriptions']) {
?>
                <br />
                <input id="checkbox_subscribe" type="checkbox" name="serendipity[subscribe]" <?php echo (isset($data['subscribe']) ? 'checked="checked"' : ''); ?> /><label for="checkbox_subscribe"> <?php echo SUBSCRIBE_TO_THIS_ENTRY; ?></label>
<?php
        }
?>
<?php } ?>
            </td>
       </tr>
<?php
        if ($moderate_comments==true) {
?>
       <tr>
            <td class="serendipity_commentsValue serendipity_msg_important" colspan="2"><?php echo COMMENTS_WILL_BE_MODERATED ?></td>
       </tr>
<?php
        }
?>
       <tr>
            <td>&nbsp;</td>
            <td><input type="submit" name="serendipity[submit]" value="<?php echo SUBMIT_COMMENT; ?>" /> <input type="submit" name="serendipity[preview]" value="<?php echo PREVIEW; ?>" /></td>
        </tr>
    </table>
    </form>
</div>
<?php
}

function serendipity_setCookie($name,$value) {
    global $serendipity;

    setcookie("serendipity[$name]", $value, time()+60*60*24*30, $serendipity['serendipityHTTPPath']);
    $_COOKIE[$name] = $value;
    $serendipity['COOKIE'][$name] = $value;
}

function serendipity_deleteCookie($name) {
    global $serendipity;

    setcookie("serendipity[$name]", '', time()-4000);
    unset($_COOKIE[$name]);
    unset($serendipity['COOKIE'][$name]);
}

function serendipity_rememberComment() {
    global $serendipity;

    if (isset($serendipity['POST']['remember'])) {
        serendipity_rememberCommentDetails(
          array(
            'url'      => $serendipity['POST']['url'],
            'name'     => $serendipity['POST']['name'],
            'email'    => $serendipity['POST']['email'],
            'remember' => 'checked="checked"'
          )
        );
    } elseif (isset($serendipity['POST']['comment'])) {
        serendipity_forgetCommentDetails(array('url', 'name', 'email', 'remember'));
    }
}

function serendipity_rememberCommentDetails($details) {
    global $serendipity;

    foreach ($details as $n => $v) {
        serendipity_setCookie($n, $v);
    }
}
function serendipity_forgetCommentDetails($keys) {
    global $serendipity;
    if (!$serendipity['COOKIE']) {
        return;
    }

    foreach ($keys AS $n) {
        serendipity_deleteCookie($n);
    }
}

// Draws a little calendar in HTML
function serendipity_drawCalendar($month, $year, $bow=1) {
    global $serendipity;

    // Check for faulty input, is so - run the default
    if (!is_numeric($bow) || (int)$bow>6) {
        $bow = 1;
    }

    $bow = (int)$bow;

    // Catch faulty month
    if ($month<1) {
        $month = 1;
    }
    $month = sprintf('%d', $month);

    // How many days does the month have?
    $ts              = strtotime($year . '-' . sprintf('%02d', $month) . '-01');
    $nrOfDays        = date('t', $ts);
    $firstDayWeekDay = date('w', $ts);

    // Calculate the first day of the week, based on the beginning of the week ($bow)
    if ( $bow > $firstDayWeekDay ) {
        $firstDayWeekDay = $firstDayWeekDay+7-$bow;
    } elseif ( $bow < $firstDayWeekDay ) {
        $firstDayWeekDay = $firstDayWeekDay-$bow;
    } else {
        $firstDayWeekDay = 0;
    }

    // Calculate the number of next/previous month
    if ($month > 1) {
        $previousMonth = $month-1;
        $previousYear  = $year;
    } else {
        $previousMonth = 12;
        $previousYear  = $year-1;
    }

    if ($month <12) {
        $nextMonth = $month+1;
        $nextYear  = $year;
    } else {
        $nextMonth = 1;
        $nextYear  = $year+1;
    }

    $endts = mktime(0, 0, 0, $month + 1, 1, $year);

    // Get first and last entry
    $minmax = serendipity_db_query("SELECT MAX(timestamp) AS max, MIN(timestamp) AS min FROM {$serendipity['dbPrefix']}entries");
    if (!is_array($minmax) || !is_array($minmax[0]) || $minmax[0]['min'] < 1 || $minmax[0]['max'] < 1) {
        // If no entry is available yet, allow scrolling a year back and forth
        $minmax = array(
                    '0' => array(
                             'min' => mktime(0, 0, 0, 1, 1, date('Y')-1),
                             'max' => mktime(0, 0, 0, 1, 1, date('Y')+1)
                           )
                  );
    }

    // Find out about diary entries
    $add_query   = '';
    $base_query  = '';
    if (isset($serendipity['GET']['category'])) {
        $categoryid  = serendipity_db_escape_string($serendipity['GET']['category']);

        if (is_numeric($categoryid)) {
            $base_query   = 'serendipity[category]=' . $categoryid;
            $add_query    = '&amp;' . $base_query;
            $querystring = "SELECT timestamp
                              FROM {$serendipity['dbPrefix']}entries e,
                                   {$serendipity['dbPrefix']}category c,
                                   {$serendipity['dbPrefix']}entrycat ec
                             WHERE e.timestamp  >= $ts
                               AND e.timestamp  <= $endts
                               AND e.isdraft     = 'false'
                               AND e.id          = ec.entryid
                               AND c.categoryid  = ec.categoryid
                               AND c.category_left BETWEEN " . implode(' AND ', serendipity_fetchCategoryRange($categoryid));
        }
    }

    if (!isset($querystring)) {
        $querystring = "SELECT timestamp
                          FROM {$serendipity['dbPrefix']}entries e
                         WHERE e.timestamp >= $ts and e.timestamp <= $endts AND e.isdraft = 'false'";
    }

    $rows = serendipity_db_query($querystring);
    $activeDays = array();
    if (is_array($rows)) {
        foreach ($rows as $row) {
            $activeDays[date('j', $row['timestamp'])] = $row['timestamp'];
        }
    }

    // Prepare the table
    $link = serendipity_archiveDateUrl($year . sprintf('%02d', $month)) . $base_query;
?>
<table width="100%" class="serendipity_calendar" cellspacing="0" cellpadding="0">
    <tr>
        <td align="left" class="serendipity_calendarHeader">
<?php
    // Only allow to scroll to the previous month if the first entry is from the month before
    if ($ts > ($minmax[0]['min'] - 2678400)) {
?>
            <a title="<?php echo BACK; ?>" href="<?php echo $serendipity['serendipityHTTPPath'] . $serendipity['indexFile']; ?>?serendipity[calendarZoom]=<?php echo $previousYear . sprintf('%02d',$previousMonth) . $add_query; ?>"><img alt="<?php echo BACK; ?>" src="<?php echo serendipity_getTemplateFile('img/back.png'); ?>" <?php echo ($serendipity['XHTML11'] ? 'style="border: 0px"' : 'border="0"'); ?> /></a>
<?php
    }
?>
        </td>

        <td colspan="5" align="center" valign="bottom" class="serendipity_calendarHeader">
            <b><?php echo ($serendipity['XHTML11'] ? '<span style="white-space: nowrap">' : '<nobr>'); ?><a href="<?php echo $link; ?>"><?php echo serendipity_formatTime("%B '%y", mktime(0,0,0,$month, 1, $year)) ?></a><?php echo ($serendipity['XHTML11'] ? '</span>' : '</nobr>'); ?></b>
        </td>

        <td align="right" class="serendipity_calendarHeader">
<?php
    // Only allow to scroll to the next month if the last entry is from the month before
    if ($endts < ($minmax[0]['max'] + 2678400)) {
?>
            <a title="<?php echo FORWARD; ?>" href="<?php echo $serendipity['serendipityHTTPPath'] . $serendipity['indexFile']; ?>?serendipity[calendarZoom]=<?php echo $nextYear . sprintf('%02d', $nextMonth) . $add_query; ?>"><img alt="<?php echo FORWARD; ?>" src="<?php echo serendipity_getTemplateFile('img/forward.png'); ?>" <?php echo ($serendipity['XHTML11'] ? 'style="border: 0px"' : 'border="0"'); ?> /></a>
<?php
    }
?>
        </td>
    </tr>

    <tr>
<?php
    for ($i = 1; $i <= 7; $i++) {
        $date = mktime(0,0,0,3,$bow+$i-1,2004);
?>
        <td scope="col" abbr="<?php echo serendipity_formatTime("%A", $date) ?>" title="<?php echo serendipity_formatTime("%A", $date) ?>" class="serendipity_weekDayName" align="center"><?php echo substr(serendipity_formatTime("%a", $date),0,2); ?></td>
<?php
    }
?>
    </tr>

<?php
    // Print the calendar
    $currDay     = 1;
    $nrOfRows    = ceil(($nrOfDays+$firstDayWeekDay)/7);
    $today_day   = date('j');
    $today_month = date('m');
    $today_year  = date('Y');
    for ($x = 0; $x < 6; $x++) {
        // Break out if we are out of days
        if ($currDay > $nrOfDays) {
            break;
        }
?>
    <tr class="serendipity_calendar">
<?php
        // Prepare row
        for ($y = 0; $y < 7; $y++) {
            $cellProps = array();
            $link = '';

            if ($x == 0) {
                $cellProps[] = 'FirstRow';
            }
            if ($y == 0) {
                $cellProps[] = 'FirstInRow';
            }
            if ($y == 6) {
                $cellProps[] = 'LastInRow';
            }
            if ($x == $nrOfRows-1) {
                $cellProps[] = 'LastRow';
            }

            // If it's not a blank day, we print the day
            if (($x > 0 || $y >= $firstDayWeekDay) && $currDay <= $nrOfDays) {

                $printDay = $currDay;

                if ($today_year == $year && $today_month == $month && $today_day == $currDay) {
                    $cellProps[] = 'Today';
                }

                if (isset($activeDays[$currDay]) && $activeDays[$currDay] > 1) {
                    $cellProps[] = 'Active';
                }

                if (isset($activeDays[$currDay]) && $activeDays[$currDay] > 1) {
                    $printDay = '<a href="' . serendipity_archiveDateUrl(sprintf('%4d%02d%02d', $year, $month, $currDay)) . $base_query . '">'. $printDay .'</a>';
                }

                $currDay++;
?>
        <td class="serendipity_calendarDay <?php echo implode(' ', $cellProps); ?>"><?php echo $printDay ?></td>
<?php
            // If it's a blank day (a day outside the month)
            } else {
?>
        <td class="serendipity_calendarDay BlankDay <?php echo implode(' ', $cellProps); ?>">&nbsp;</td>
<?php
            } // end if (print day)
        } // end for-loop (inner: days)
?>
    </tr>
<?php
    } // end for-loop (outer: weeks)
?>
</table>
<?php
} // end function: serendipity_drawCalendar

function serendipity_fetchCategoryRange($categoryid) {
    global $serendipity;

    $res = serendipity_db_query("SELECT category_left, category_right FROM {$serendipity['dbPrefix']}category WHERE categoryid = '". (int)$categoryid ."'");
    return array('category_left' => $res[0]['category_left'], 'category_right' => $res[0]['category_right']);
}

function serendipity_fetchCategoryInfo($categoryid, $categoryname = '') {
    global $serendipity;

    if (!empty($categoryname)) {
        $query = "SELECT
                         c.categoryid,
                         c.category_name,
                         c.category_description,
                         c.category_icon,
                         c.parentid
                    FROM {$serendipity['dbPrefix']}category AS c
                   WHERE category_name = '" . serendipity_db_escape_string($categoryname) . "'";

        $ret = serendipity_db_query($query);
        return $ret[0];
    } else if (is_numeric($categoryid)) {
        $query = "SELECT
                         c.categoryid,
                         c.category_name,
                         c.category_description,
                         c.category_icon,
                         c.parentid
                    FROM {$serendipity['dbPrefix']}category AS c
                   WHERE categoryid = {$categoryid}";

        $ret = serendipity_db_query($query);
        return $ret[0];
    }
}

function serendipity_fetchEntryCategories($entryid) {
  global $serendipity;

    if (is_numeric($entryid)) {
        $query = "SELECT
                         c.categoryid,
                         c.category_name,
                         c.category_description,
                         c.category_icon,
                         c.parentid
                    FROM {$serendipity['dbPrefix']}category AS c
               LEFT JOIN {$serendipity['dbPrefix']}entrycat AS ec
                      ON ec.categoryid = c.categoryid
                   WHERE ec.entryid = {$entryid}";

        return serendipity_db_query($query);
    }
}


/**
* Give it a range in YYYYMMDD format to gather the desired entries
* (For february 2002 you would pass 200202 for all entries withing
* two timestamps you would pass array(timestamp1,timestamp2)
**/
function serendipity_fetchEntries($range = null, $full = true, $limit = '', $fetchDrafts = false, $modified_since = false, $orderby = 'timestamp DESC', $filter_sql = '') {
    global $serendipity;

    $and = '';

    if (isset($serendipity['short_archives']) && $serendipity['short_archives']) {
        // In the short listing of all titles for a month, we don't want to have a limit applied.
        $limit = '';
    }

    if ($full === true) {
        $body = ', e.body, e.extended';
    } else {
        $body = '';
    }

    if ($fetchDrafts === false) {
        $drafts = "isdraft = 'false'";
    }

    if ($limit != '') {
        $serendipity['fetchLimit'] = $limit;
    }

    if (is_numeric($range)) {
        $year = (int)substr($range, 0, 4);
        $month = (int)substr($range, 4, 2);
        $day = (int)substr($range, 6, 2);

        $startts = mktime(0, 0, 0, $month, ($day == 0 ? 1 : $day), $year);

        if ($day == 0) {
            $month++;
        } else {
            $day++;
        }

        $endts = mktime(0, 0, 0, $month, ($day == 0 ? 1 : $day), $year);

        $and = " WHERE timestamp >= $startts AND timestamp <= $endts";
        if ($drafts) {
            $and .= " AND $drafts";
        }
    }
    elseif (is_array($range) && count($range)==2) {
        $startts = (int)$range[0];
        $endts   = (int)$range[1];
        $and = " WHERE timestamp >= $startts AND timestamp <= $endts";
    }
     else {
        if ($modified_since) {
            $unix_modified = strtotime($modified_since);
            if ($unix_modified != -1) {
                $and = ' WHERE last_modified >= ' . (int)$unix_modified;
                if (!empty($limit)) {
                    $limit = ($limit > $serendipity['max_fetch_limit'] ? $limit : $serendipity['max_fetch_limit']);
                }
                $orderby = 'last_modified DESC';
            }
        }

        if (!empty($drafts)) {
            if (!empty($and)) {
                $and .= " AND $drafts";
            } else {
                $and = "WHERE $drafts";
            }
        }
    }

    if (isset($serendipity['GET']['category'])) {
        $_categoryid = explode('_', $serendipity['GET']['category']);
        $categoryid  = serendipity_db_escape_string($_categoryid[0]);

        if (is_numeric($categoryid)) {
            if (!empty($and)) {
                $and .= " AND c.category_left BETWEEN " . implode(' AND ', serendipity_fetchCategoryRange($categoryid));
            } else {
                $and = "WHERE c.category_left BETWEEN " . implode(' AND ', serendipity_fetchCategoryRange($categoryid));
            }
        }
    }

    if (!empty($limit)) {
        if (isset($serendipity['GET']['page']) && $serendipity['GET']['page'] > 1 && !strstr($limit, ',')) {
            $limit = serendipity_db_limit(($serendipity['GET']['page']-1) * $limit, $limit);
        }

        $limit = serendipity_db_limit_sql($limit);
    }

    if (isset($serendipity['GET']['adminModule']) && $serendipity['GET']['adminModule'] == 'entries' && $serendipity['serendipityUserlevel'] < USERLEVEL_CHIEF) {
        if (!empty($and)) {
            $and .= " AND e.authorid = '" . $serendipity['authorid'] . "'";
        } else {
            $and = "WHERE e.authorid = '" . $serendipity['authorid'] . "'";
        }
    }

    if (!isset($serendipity['GET']['adminModule'])) {
        if (!empty($and)) {
            $and .= " AND e.timestamp <= '" . time() . "'";
        } else {
            $and = "WHERE e.timestamp <= '" . time() . "'";
        }
    }

    if (!empty($filter_sql)) {
        if (!empty($and)) {
            $and .= ' AND ' . $filter_sql;
        } else {
            $and = 'WHERE ' . $filter_sql;
        }
    }

    if (strtolower($serendipity['dbType']) == 'postgres') {
        $group    = '';
        $distinct = 'DISTINCT';
    } else {
        $group    = 'GROUP BY e.id';
        $distinct = '';
    }

    // Store the unique query condition for entries for later reference, like getting the total article count.
    $serendipity['fullCountQuery'] = "
                FROM
                    {$serendipity['dbPrefix']}entries AS e
                    LEFT JOIN {$serendipity['dbPrefix']}authors a
                        ON e.authorid = a.authorid
                    LEFT JOIN {$serendipity['dbPrefix']}entrycat ec
                        ON e.id = ec.entryid
                    LEFT JOIN {$serendipity['dbPrefix']}category c
                        ON ec.categoryid = c.categoryid
                    $and";

    $query = "SELECT $distinct
                    e.id,
                    e.title,
                    e.timestamp,
                    e.comments,
                    e.exflag,
                    e.author,
                    e.authorid,
                    e.trackbacks,
                    e.isdraft,
                    e.allow_comments,
                    e.last_modified,

                    a.username,
                    a.email

                    $body
                    {$serendipity['fullCountQuery']}
                    $group
                    ORDER BY $orderby
                    $limit";

    $ret = serendipity_db_query($query);

    if (is_string($ret)) {
        die("Query failed: $ret");
    }

    if (is_array($ret)) {
        // The article's query LIMIT operates on a flattened entries layer so that
        // an article having 5 associated categories won't count as 5 entries.
        // But to store the expanded list of categories, we need to send a new
        // query once for all entries we have just fetched.
        // First code for this was sending 15 queries for 15 fetched entries,
        // this is now limited to just one query per fetched articles group

        $search_ids = array(); // An array to hold all ids of the entry we want to fetch.
        $assoc_ids  = array(); // A temporary key association container to not have to loop through the return array once again.

        foreach($ret AS $i => $entry) {
            $search_ids[]            = $entry['id'];
            $ret[$i]['categories']   = array();        // make sure every article gets its category association
            $assoc_ids[$entry['id']] = $i;             // store temporary reference
        }

        $query = "SELECT
                         ec.entryid,
                         c.categoryid,
                         c.category_name,
                         c.category_description,
                         c.category_icon,
                         c.parentid
                    FROM {$serendipity['dbPrefix']}category AS c
               LEFT JOIN {$serendipity['dbPrefix']}entrycat AS ec
                      ON ec.categoryid = c.categoryid
                   WHERE ec.entryid IN (" . implode(', ', $search_ids) . ")";

        $search_ret = serendipity_db_query($query);

        if (is_array($search_ret)) {
            foreach($search_ret AS $i => $entry) {
                $ret[$assoc_ids[$entry['entryid']]]['categories'][] = $entry;
            }
        }
    }

    return $ret;
}

/**
* Fetches a specific entry
**/
function serendipity_fetchEntry($key, $val, $full = true, $fetchDrafts = 'false') {
    global $serendipity;

    $drafts = '';
    if ($fetchDrafts == 'false') {
        $drafts = "AND isdraft = 'false'";
    }

    $admin = '';
    if (isset($serendipity['GET']['adminModule']) && $serendipity['GET']['adminModule'] == 'entries' && $serendipity['serendipityUserlevel'] < USERLEVEL_CHIEF) {
        $admin = " AND e.authorid = '" . $serendipity['authorid'] . "'";
    }

    $querystring = "SELECT
                            *,
                            a.username,
                            a.email
                    FROM
                            {$serendipity['dbPrefix']}entries e,
                            {$serendipity['dbPrefix']}authors a
                    WHERE
                            a.authorid = e.authorid
                            AND e.$key LIKE '" . serendipity_db_escape_string($val) . "'
                            $admin
                            $drafts
                    LIMIT 1";

    $ret = serendipity_db_query($querystring, true);
    $ret['categories'] = $ret[] = serendipity_fetchEntryCategories($ret['id']);
    return $ret;
}

/**
* Fetches a users categories
**/
function serendipity_fetchCategories($authorid = null, $name = '') {
    global $serendipity;

    if (!isset($authorid) || $authorid === null) {
        $authorid = ((isset($serendipity['authorid']) && !empty($serendipity['GET']['adminModule'])) ? $serendipity['authorid'] : 1);
    }

    if ($serendipity['serendipityUserlevel'] == USERLEVEL_ADMIN) {
        $authorid = 'all';
    }

    if ($authorid != 'all' && is_numeric($authorid)) {
        $where = " WHERE ((c.authorid = $authorid OR c.authorid = 0) " . (!empty($serendipity['serendipityUserlevel']) ? " OR a.userlevel < {$serendipity['serendipityUserlevel']}" : '') . ')';
    } else {
        $where = '';
    }

    if (!empty($name)) {
        if ($where == '') {
            $where = ' WHERE ';
        } else {
            $where = ' AND ';
        }

        $where .= " c.category_name = '" . serendipity_db_escape_string($name) . "'";
    }

    $querystring = "SELECT
                           c.*,
                           a.username
                      FROM {$serendipity['dbPrefix']}category AS c
           LEFT OUTER JOIN {$serendipity['dbPrefix']}authors AS a
                        ON c.authorid = a.authorid $where
                  ORDER BY category_name";

    return serendipity_db_query($querystring);
}

function serendipity_rebuildCategoryTree($parent = 0, $left = 0) {
    // Based on http://www.sitepoint.com/article/hierarchical-data-database/1
    global $serendipity;
    $right = $left + 1;

    $result = serendipity_db_query("SELECT categoryid FROM {$serendipity['dbPrefix']}category WHERE parentid = '" . (int)$parent . "'");
    if ( is_array($result) ) {
        foreach ( $result as $category ) {
            $right = serendipity_rebuildCategoryTree($category['categoryid'], $right);
        }
    }
    if ( $parent > 0 ) {
        serendipity_db_query("UPDATE {$serendipity['dbPrefix']}category SET category_left='{$left}', category_right='{$right}' WHERE categoryid='{$parent}'");
    }

    return $right + 1;
}

function serendipity_fetchUsers($user = '') {
    global $serendipity;

    $where = '';
    if (!empty($user)) {
        $where = "WHERE authorid = '" . (int)$user ."'";
    }

    $querystring = "SELECT * FROM {$serendipity['dbPrefix']}authors $where ORDER BY username ASC";

    return serendipity_db_query($querystring);
}

/**
* Give it a raw searchstring, it'll search
**/
function serendipity_searchEntries($term) {
    global $serendipity;

    $term = serendipity_db_escape_string($term);
    if (strtolower($serendipity['dbType']) == 'postgres') {
        $group     = '';
        $distinct  = 'DISTINCT';
        $find_part = "(title~'$term' OR body~'$term' OR extended~'$term')";
    } else {
        $group     = 'GROUP BY e.id';
        $distinct  = '';
        $find_part = "MATCH(title,body,extended) AGAINST('$term')";
    }

    $querystring = "SELECT $distinct
                            e.id,
                            e.author,
                            a.username,
                            a.email,
                            ec.categoryid,
                            e.timestamp,
                            e.comments,
                            e.title,
                            e.body,
                            e.extended,
                            e.trackbacks,
                            e.exflag
                    FROM
                            {$serendipity['dbPrefix']}entries e,
                            {$serendipity['dbPrefix']}authors a,
                            {$serendipity['dbPrefix']}entrycat ec
                    WHERE
                            a.authorid = e.authorid
                            AND e.id = ec.entryid
                            AND $find_part
                            AND isdraft = 'false'
                            AND timestamp <= " . time() . "
                    $group
                    ORDER BY
                            timestamp DESC";

    $serendipity['hidefooter'] = true;
    return serendipity_db_query($querystring);
}

/**
*  Creates a filename that consists of [a-zA-z0-9-] (with some custom adjustments (space -> _,  -> ae and such)
**/
function serendipity_makeFilename($str) {
    static $from = array(
                     ' ',

                     '',
                     '',

                     '',
                     '',

                     '',
                     '',

                     '',

                     '',
                     '',
                     '',

                     '',
                     '',
                     '',

                     '',
                     '',
                     '',
                     '',

                     '',
                     '',
                     '',
                     '',

                     '',
                     '',
                     '',

                     '',
                     '',

                     '',

                     '');

    static $to   = array(
                     '-',

                     'AE',
                     'ae',

                     'OE',
                     'oe',

                     'UE',
                     'ue',

                     'ss',

                     'e',
                     'e',
                     'e',

                     'i',
                     'i',
                     'i',

                     'a',
                     'a',
                     'a',
                     'a',

                     'o',
                     'o',
                     'o',
                     'o',

                     'u',
                     'u',
                     'u',

                     'c',
                     'C',

                     'n',

                     'y');

    // For pretty urls we want to have a '+' as word separator. But GUIDs need to stay used to using '_' to not break bc.
    // (For performance reasons this changes the static array instead of using a second str_replace call only for the ' ' case,
    // and to avoid a costy call to array_merge()
    if ($compat !== true) {
        $to[0] = '-';
    } else {
        $to[0] = '_';
    }

    // Replace international chars not detected by every locale
    $str = str_replace($from, $to, $str);

    // Nuke chars not allowed in our URI
    $str = preg_replace('#[^' . PAT_FILENAME . ']#i', '', $str);

    // Remove consecutive separators
    $str = preg_replace('#'. $to[0] .'{2,}#s', $to[0], $str);

    // Remove excess separators
    $str = trim($str, $to[0]);

    return $str;
}

/** Print a footer below the list of entries
 *
 **/
function serendipity_printEntryFooter($short_output = false) {
global $serendipity;

    if (!$short_output) {
        // build the query string with variables we want to carry from each page to page
        $add_query = '';
        if (is_array($serendipity['GET'])) {
            $page_get_array = $serendipity['GET'];
            if ((isset($serendipity['GET']['calendarZoom']) && isset($serendipity['GET']['range']) && $serendipity['GET']['calendarZoom'] == $serendipity['GET']['range'])
                 || (!isset($serendipity['GET']['calendarZoom']) && $serendipity['GET']['action'] != 'read')) {
                // The 'range' variable is always set by the layout.php, even if we didn't specify one. But to still be able to paginate through ALL entries, we need to not propagate this variable in special cases where s9y automatically sets the 'range' variable.
                unset($page_get_array['range']);
            }

            unset($page_get_array['page']);
            unset($page_get_array['action']);
            unset($page_get_array['adminAction']);

            foreach($page_get_array AS $skey => $sval) {
                $add_query .= '&amp;serendipity[' . urlencode($skey) . ']=' . urlencode($sval);
            }
        }

        // The unique query condition was built previously in serendipity_fetchEntries()
        if (strtolower($serendipity['dbType']) == 'sqlite') {
            $querystring  = "SELECT count(e.id) {$serendipity['fullCountQuery']} GROUP BY count(e.id)";
        } else {
            $querystring  = "SELECT count(distinct e.id) {$serendipity['fullCountQuery']}";
        }

        $query = serendipity_db_query($querystring);

        if (is_array($query) && isset($query[0])) {
            $totalEntries = $query[0][0];
        } else {
            $totalEntries = 0;
        }

        $totalPages   = ceil($totalEntries / (!empty($serendipity['fetchLimit']) ? $serendipity['fetchLimit'] : 15));

        if (!isset($serendipity['GET']['page'])) {
            $serendipity['GET']['page'] = 1;
        }
    }
?>
<div class='serendipity_entryFooter' style="text-align: center">
<?php
    if (!$short_output) {
        if ($serendipity['GET']['page'] > 1) {
?>
<a href="<?php echo $serendipity['baseURL'] . $serendipity['indexFile'] . '?serendipity[page]=' . ($serendipity['GET']['page'] - 1) . $add_query; ?>">&laquo; <?php echo PREVIOUS_PAGE; ?></a>&nbsp;&nbsp;
<?php
        }
?>
(<?php printf(PAGE_BROWSE_ENTRIES, $serendipity['GET']['page'], $totalPages, $totalEntries); ?>)
<?php
        if ($serendipity['GET']['page'] < $totalPages) {
?>
&nbsp;&nbsp;<a href="<?php echo $serendipity['baseURL'] . $serendipity['indexFile'] . '?serendipity[page]=' . ($serendipity['GET']['page'] + 1) . $add_query; ?>"><?php echo NEXT_PAGE; ?> &raquo;</a>
<?php
        }
    }

    serendipity_plugin_api::hook_event('entries_footer', $serendipity);
?>
</div>
<?php
}

/**
* Prints the entries you fetched with serendipity_fetchEntries/searchEntries in HTML.
**/
function serendipity_printEntries($entries, $extended = 0, $preview = false) {
    global $serendipity;

    $addData = array('extended' => $extended, 'preview' => $preview);
    serendipity_plugin_api::hook_event('entry_display', $entries, $addData);

    if (isset($entries['clean_page']) && $entries['clean_page'] === true) {
        return; // no display of this item
    }

    /* pre-walk the array to collect them keyed by date */
    $bydate = array();
    if (!is_array($entries) || $entries[0] == false || !isset($entries[0]['timestamp'])) {
        echo '<br />' . NO_ENTRIES_TO_PRINT . "\n";
        return;
    }

    $lastDate = '';
    for ($x = 0, $num_entries = count($entries); $x < $num_entries; $x++) {
        $d = serendipity_formatTime(DATE_FORMAT_ENTRY, $entries[$x]['timestamp']);
        $bydate[$d][] = $entries[$x];
    }

    if (!isset($serendipity['short_archives']) || !$serendipity['short_archives']) {
        foreach ($bydate as $date => $ents) {
?>

    <div class="serendipity_Entry_Date">
        <h3 class="serendipity_date"><?php echo $date; ?></h3>

<?php
            foreach ($ents as $x => $entry) {
                $entryLink = serendipity_archiveURL($entry['id'], $entry['title'], 'serendipityHTTPPath');
                serendipity_plugin_api::hook_event('frontend_display', $entry);

                $html_extended = '';
                $extended_css = 'serendipity_entry_body_folded';
                if ($extended && strlen($entry['extended'])) {
                    $html_extended = '<div class="serendipity_entry_extended"><a ' . ($serendipity['XHTML11'] ? 'id' : 'name') . '="extended"></a>';
                    $html_extended .= $entry['extended'] . '</div>';
                    $extended_css = 'serendipity_entry_body_unfolded';
                }

                if (isset($entry['exflag']) && $entry['exflag'] && !$extended) {
                    $html_extended = '<br /><a href="' . $entryLink . '#extended">' . sprintf(VIEW_EXTENDED_ENTRY, htmlspecialchars($entry['title'])) . '</a><br /><br />';
                }

?>
        <h4 class="serendipity_title"><a href="<?php echo $entryLink; ?>"><?php echo htmlspecialchars($entry['title']); ?></a></h4>

        <div class="serendipity_entry">
<?php
                if (is_array($entry['categories'])) {
                    $icon_string = '';
                    foreach ($entry['categories'] as $cat) {
                        if ($cat['category_icon'] != '') {
                            $icon_string .= '<a href="' . $serendipity['serendipityHTTPPath'] . ($serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : '') . PATH_CATEGORIES . '/' . $cat['categoryid'] . '-' . serendipity_makeFilename($cat['category_name']) . '"><img class="serendipity_entryIcon" title="' . htmlspecialchars($cat['category_name']) . (!empty($cat['category_description']) ? ': ' . htmlspecialchars($cat['category_description']) : '') . '" alt="' . htmlspecialchars($cat['category_name']) . '" src="' . htmlspecialchars($cat['category_icon']) . '"/></a>';
                        }
                    }
                    if ($icon_string != '') {
                        echo '<span class="serendipity_entryIcon">' . $icon_string . '</span>';
                    }
                }
?>
            <div class="<?php echo $extended_css; ?>"><?php echo $entry['body']; ?></div>
                <?php echo $html_extended; ?>

            <div class='serendipity_entryFooter'>
<?php
                echo ' ' . POSTED_BY . ' ' . htmlspecialchars($entry['username']);
                if (is_array($entry['categories']) && sizeof($entry['categories']) > 0) {
                    echo ' ' . IN . ' ';
                    $cats = array();
                    foreach ($entry['categories'] as $cat) {
                        $cats[] = '<a href="' . $serendipity['serendipityHTTPPath'] . ($serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : '') . PATH_CATEGORIES . '/' . $cat['categoryid'] . '-' . serendipity_makeFilename($cat['category_name']) . '">' . $cat['category_name'] . '</a>';
                    }
                    echo implode(', ', $cats);
                }

                echo ' ' . AT . ' <a href="' . $entryLink . '">' . date('H:i', $entry['timestamp']) . '</a>'. "\n";

                if (serendipity_db_bool($entry['allow_comments']) || !isset($entry['allow_comments']) || $entry['comments'] > 0) {
                    if (!isset($serendipity['GET']['id'])) {
                        $label = $entry['comments'] == 1 ? COMMENT : COMMENTS;
                        if ($serendipity['enablePopup']) {
                            $uriExtra = ' onclick="window.open(this.href, \'comments\', \'width=480,height=480,scrollbars=yes\'); return false;"';
                            $commentUri = $serendipity['serendipityHTTPPath'] . 'comment.php?serendipity[entry_id]=' . (int)$entry['id'] . '&amp;serendipity[type]=comments';
                        } else {
                            $uriExtra = '';
                            $commentUri = $entryLink .'#comments';
                        }
                        echo ' | <a href="' . $commentUri . '"' . $uriExtra . '>' . $label . ' (' . $entry['comments'] . ')</a>';
                    }
                }

                if (serendipity_db_bool($entry['allow_comments']) || !isset($entry['allow_comments']) || $entry['trackbacks'] > 0 ) {
                    if ( $serendipity['enablePopup'] || !isset($serendipity['GET']['id'])) {
                        $label = $entry['trackbacks'] == 1 ? TRACKBACK : TRACKBACKS;
                        if ($serendipity['enablePopup']) {
                            $uriExtra = ' onclick="window.open(this.href, \'comments\', \'width=480,height=480,scrollbars=yes\'); return false;"';
                            $trackbackUri = $serendipity['serendipityHTTPPath'] . 'comment.php?serendipity[entry_id]=' . (int)$entry['id'] . '&amp;serendipity[type]=trackbacks';
                        } else {
                            $uriExtra = '';
                            $trackbackUri = $entryLink .'#trackbacks';
                        }

                        echo ' | <a href="' . $trackbackUri .'"'. $uriExtra . '>' . $label . ' (' . $entry['trackbacks'] . ')</a>';
                     }
                }

                if ($_SESSION['serendipityAuthedUser'] === true && ($_SESSION['serendipityUserlevel'] >= USERLEVEL_CHIEF || $_SESSION['serendipityAuthorid'] == $entry['authorid'])) {
                    echo ' | <a href="' . $serendipity['baseURL'] . 'serendipity_entries.php?serendipity[action]=admin&amp;serendipity[adminModule]=entries&amp;serendipity[adminAction]=edit&amp;serendipity[id]=' . $entry['id'] . '">' . EDIT_ENTRY . '</a>';
                }

                if (!empty($entry['add_footer'])) {
                    echo $entry['add_footer'];
                }
?>
                </div>
            </div>
                <!--
                <rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
                         xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/"
                         xmlns:dc="http://purl.org/dc/elements/1.1/">
                <rdf:Description
                         rdf:about="<?php echo $serendipity['baseURL'] . ($serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : ''); ?>feeds/ei_<?php echo $entry['id']; ?>.rdf"
                         trackback:ping="<?php echo $serendipity['baseURL']; ?>comment.php?type=trackback&amp;entry_id=<?php echo (int)$entry['id']; ?>"
                         dc:title="<?php echo htmlspecialchars($entry['title']); ?>"
                         dc:identifier="<?php echo serendipity_archiveURL($entry['id'], $entry['title'], 'baseURL'); ?>" />
                </rdf:RDF>
                -->
<?php
                $eventData = array_merge(array('display_dat' => ''), $entry);
                serendipity_plugin_api::hook_event('frontend_display:html:per_entry', $eventData);
                echo $eventData['display_dat'];

                if (isset($serendipity['GET']['id'])) {
                    $comm_url = serendipity_archiveURL(
                                  $entry['id'],
                                  $entry['title'],
                                  'baseURL',
                                  false
                    );

                    /********** MESSAGES *********/
                    if (defined('DATA_UNSUBSCRIBED')) {
                        echo '<br /><div class="serendipity_center serendipity_msg_notice">'. sprintf(UNSUBSCRIBE_OK, DATA_UNSUBSCRIBED) .'</div><br />';
                    }

                    if (defined('DATA_TRACKBACK_DELETED')) {
                        echo '<br /><div class="serendipity_center serendipity_msg_notice">'. sprintf(TRACKBACK_DELETED, DATA_TRACKBACK_DELETED) .'</div><br />';
                    }

                    if (defined('DATA_TRACKBACK_APPROVED')) {
                        echo '<br /><div class="serendipity_center serendipity_msg_notice">'. sprintf(TRACKBACK_APPROVED, DATA_TRACKBACK_APPROVED) .'</div><br />';
                    }

                    if (defined('DATA_COMMENT_DELETED')) {
                        echo '<br /><div class="serendipity_center serendipity_msg_notice">'. sprintf(COMMENT_DELETED, DATA_COMMENT_DELETED) .'</div><br />';
                    }

                    if (defined('DATA_COMMENT_APPROVED')) {
                        echo '<br /><div class="serendipity_center serendipity_msg_notice">'. sprintf(COMMENT_APPROVED, DATA_COMMENT_APPROVED) .'</div><br />';
                    }


                    if (!$serendipity['enablePopup']) {
                        $tbu = $serendipity['baseURL'] . 'comment.php?type=trackback&amp;entry_id=' . (int)$entry['id'];
?>
            <div class="serendipity_comments">
            <br />
            <a id="trackbacks"></a>
             <div class="serendipity_commentsTitle"><?php echo TRACKBACKS; ?></div>
                <div class="serendipity_center"><a style="font-weight: normal" href="<?php echo $tbu; ?>" onclick="alert('<?php echo htmlentities(TRACKBACK_SPECIFIC_ON_CLICK) ?>'); return false;" title="<?php echo htmlentities(TRACKBACK_SPECIFIC_ON_CLICK) ?>"><?php echo TRACKBACK_SPECIFIC; ?></a></div><br />
<?php
                    serendipity_printTrackbacks(serendipity_fetchTrackbacks($entry['id']));
?>
            </div>
<?php               } ?>
            <div class="serendipity_comments">
            <br />
            <a id="comments"></a>
            <div class="serendipity_commentsTitle"><?php echo COMMENTS; ?></div>
                <?php
                    $comment_viewmode_url = $serendipity['serendipityHTTPPath'] . $serendipity['indexFile'] . '?url=' . $comm_url . '&amp;serendipity[cview]=';
                    if ( $serendipity['GET']['cview'] == VIEWMODE_LINEAR ) {
                        $linearLink = COMMENTS_VIEWMODE_LINEAR;
                        $threadLink = '<a href="'. $comment_viewmode_url . VIEWMODE_THREADED .'#comments">'. COMMENTS_VIEWMODE_THREADED .'</a>';
                        $viewmode = VIEWMODE_LINEAR;
                    } else {
                        $linearLink = '<a href="'. $comment_viewmode_url . VIEWMODE_LINEAR .'#comments">'. COMMENTS_VIEWMODE_LINEAR .'</a>';
                        $threadLink = COMMENTS_VIEWMODE_THREADED;
                        $viewmode = VIEWMODE_THREADED;
                    }

                ?>
                <div class="serendipity_center"><?php echo DISPLAY_COMMENTS_AS ?> (<?php echo $linearLink ?> | <?php echo $threadLink ?>)</div>
<?php
                    serendipity_printComments(
                      serendipity_fetchComments(
                        $entry['id']
                      ),
                      (isset($entry['allow_comments']) ? $entry['allow_comments'] : true),
                      true,
                      $viewmode
                    );

                    if (!empty($serendipity['POST']['preview'])) {
                        serendipity_printComments(
                          array(
                            array(
                              'email'     => $serendipity['POST']['email'],
                              'username'  => $serendipity['POST']['name'],
                              'body'      => $serendipity['POST']['comment'],
                              'url'       => $serendipity['POST']['url'],
                              'parent_id' => $serendipity['POST']['replyTo'],
                              'timestamp' => time()
                            )
                          ),
                          false,
                          false,
                          $serendipity['POST']['replyTo']
                        );
                    }

                    if (isset($serendipity['messagestack']['comments'])) {
                        foreach ((array)$serendipity['messagestack']['comments'] as $message ) {
?>
            <div class="serendipity_center serendipity_msg_important"><?php echo $message ?></div>
<?php
                        }
                    }

                    if (isset($serendipity['GET']['csuccess']) && $serendipity['GET']['csuccess'] == 'true') {
?>
            <br />
            <div class="serendipity_center serendipity_msg_notice"><?php echo COMMENT_ADDED; ?></div>
<?php
                    } elseif (!serendipity_db_bool($entry['allow_comments'])) {
?>
            <br />
            <div class="serendipity_center serendipity_msg_important"><?php echo COMMENTS_CLOSED; ?></div>
<?php
                    } else {
?>
            <br />
            <div class="serendipity_commentsTitle"><?php echo ADD_COMMENT; ?></div>
<?php
                        echo serendipity_displayCommentForm(
                               $entry['id'],
                               $serendipity['serendipityHTTPPath'] . $serendipity['indexFile'] . '?url=' . $comm_url,
                               true,
                               $serendipity['POST'],
                               true,
                               serendipity_db_bool($entry['moderate_comments'])
                        );
                    }
?>
            </div>
<?php
                }
?>
<?php
                if ($preview) {
                    serendipity_plugin_api::hook_event('backend_preview', $article);
                }
            } // end for-loop (entries)
?>
    </div>
<?php
        } // end for-loop (dates)

        if (!isset($serendipity['GET']['id']) &&
               (!isset($serendipity['hidefooter']) || $serendipity['hidefooter'] == false) &&
               (count($entries) <= (!empty($serendipity['fetchLimit']) ? $serendipity['fetchLimit'] : 15))) {
            serendipity_printEntryFooter();
        } else {
            serendipity_printEntryFooter(true);
        }
    } else { // else short mode
        $s = &$serendipity['GET']['range'];
?>
    <div class='serendipity_date'><?php echo TOPICS_OF . ' ' . date('m/Y', mktime(0, 0, 0, substr($s, 4, 2), 1, substr($s, 0, 4))); ?></div>
<?php
        foreach ($bydate as $date => $ents) {
            foreach ($ents as $x => $entry) {
                echo '<a href="' . serendipity_archiveURL($entry['id'], $entry['title'], 'serendipityHTTPPath') . '">' . $entry['title'] . '</a>' . "\n";
                echo '<br />' . "\n";
            }
        }
    } // end else short mode
} // end function serendipity_printEntries

function serendipity_deleteComment($id, $entry_id, $type='comments') {
    global $serendipity;

    if ($_SESSION['serendipityAuthedUser'] === true) {
        $admin = '';
        if ($_SESSION['serendipityUserlevel'] < USERLEVEL_CHIEF) {
            $admin = " AND authorid = " . (int)$_SESSION['serendipityAuthorid'] ."'";
        }

        /* We have to figure out if the comment we are about to delete, is awaiting approval,
           if so - we should *not* subtract it from the entries table */
        $sql = serendipity_db_query("SELECT status FROM {$serendipity['dbPrefix']}comments
                                            WHERE entry_id = '". (int)$entry_id ."'
                                                    AND id = '". (int)$id ."'
                                                    $admin");

        serendipity_db_query("DELETE FROM {$serendipity['dbPrefix']}comments
                                    WHERE entry_id = '". (int)$entry_id ."'
                                            AND id = '". (int)$id ."'
                                            $admin");

        if ( $sql['status'] !== 'pending' ) {
            serendipity_db_query("UPDATE {$serendipity['dbPrefix']}entries SET $type = $type-1 WHERE id = '". (int)$entry_id ."' $admin");
        }

        return true;
    } else {
        return false;
    }
}

function serendipity_allowCommentsToggle($entry_id, $switch = 'disable') {
    global $serendipity;

    if ($_SESSION['serendipityAuthedUser'] === true) {
        $admin = '';
        if ($_SESSION['serendipityUserlevel'] < USERLEVEL_CHIEF) {
            $admin = " AND authorid = '" . (int)$_SESSION['serendipityAuthorid'] ."'";
        }

        $query = "UPDATE {$serendipity['dbPrefix']}entries SET allow_comments = '" . ($switch == 'disable' ? 'false' : 'true') . "' WHERE id = '". (int)$entry_id ."' $admin";
        serendipity_db_query($query);
        header('Location: '. $_SERVER['HTTP_REFERER']);
    } else {
        die('What are you up to? You need to be an admin to close comments');
    }
}

function serendipity_fetchComments($id, $limit = null, $order = '', $showAll = false)
{
    global $serendipity;
    $and = '';

    if (!empty($limit)) {
        $limit = serendipity_db_limit_sql($limit);
    } else {
        $limit = '';
    }

    if (!empty($id)) {
        $and .= " AND co.entry_id = '" . (int)$id ."'";
    }

    if (!$showAll) {
        $and .= ' AND co.status = \'approved\'';
    }

    if (strtolower($serendipity['dbType']) == 'postgres') {
        $group    = '';
        $distinct = 'DISTINCT';
    } else {
        $group    = 'GROUP BY co.id';
        $distinct = '';
    }

    $query = "SELECT $distinct
                    co.id,
                    co.entry_id, co.timestamp, co.title, co.email, co.url, co.ip, co.body, co.type, co.subscribed,
                    co.author AS username,
                    e.title,
                    e.id AS entryid,
                    e.authorid,
                    co.id AS commentid,
                    co.parent_id AS parent_id,
                    c.category_name
              FROM
                    {$serendipity['dbPrefix']}comments co
                    LEFT JOIN {$serendipity['dbPrefix']}entries e ON (co.entry_id = e.id)
                    LEFT JOIN {$serendipity['dbPrefix']}entrycat ec ON (e.id = ec.entryid)
                    LEFT JOIN {$serendipity['dbPrefix']}category c ON (ec.categoryid = c.categoryid)
              WHERE co.type LIKE 'NORMAL' AND entry_id > 0 $and
              $group
              ORDER BY
                    co.id " . ($order != '' ? $order : '') . "
                    $limit";

    $comments = serendipity_db_query($query);

    if (!is_array($comments)) {
        return array();
    }

    return $comments;
}

function serendipity_fetchTrackbacks($id, $limit = null, $showAll = false)
{
    global $serendipity;

    if (!$showAll) {
        $and = "AND status = 'approved'";
    }

    $query = "SELECT * FROM {$serendipity['dbPrefix']}comments WHERE entry_id = '". (int)$id ."' AND type = 'TRACKBACK' $and ORDER BY id";
    if (isset($limit)) {
        $limit  = serendipity_db_limit_sql($limit);
        $query .= " $limit";
    }

    $comments = serendipity_db_query($query);
    if (!is_array($comments)) {
        return array();
    }

    return $comments;
}

function serendipity_generateCommentList($id, $comments = NULL, $selected = 0, $parent = 0, $level = 0, $indent = '') {
    global $serendipity;

    if ( !is_array($comments) ) {
        $comments = serendipity_fetchComments($id);
    }

    $retval = $parent ? '' : '<select id="serendipity_replyTo" name="serendipity[replyTo]"><option value="0">[ ' . TOP_LEVEL . ' ]</option>';
    $i = 0;
    foreach ($comments as $comment) {
        if ($comment['parent_id'] == $parent) {
            $i++;
            $retval .= '<option value="' . $comment['id'] . '"'. ($selected == $comment['id'] || (isset($serendipity['POST']['replyTo']) && $comment['id'] == $serendipity['POST']['replyTo']) ? ' selected="selected"' : '') .'>' . str_repeat('&nbsp;', $level * 2) . '#' . $indent . $i . ': ' . (empty($comment['username']) ? ANONYMOUS : htmlspecialchars($comment['username'])) . ' ' . ON . ' ' . ucfirst(strftime('%b %e %Y, %H:%M', $comment['timestamp'])) . "</option>\n";
            $retval .= serendipity_generateCommentList($id, $comments, $selected, $comment['id'], $level + 1, $indent . $i . '.');
        }
    }
    $retval .= $parent ? '' : '</select>';

    return $retval;
}

function serendipity_printComments($comments, $allow_comments = true, $show_admin = true, $parentid = 0, $indent = '')
{
    global $serendipity;

    if ($parentid === VIEWMODE_THREADED) {
        $parentid = 0;
    }

    if (!count($comments) && !$parentid) {
?>
            <div class="serendipity_center"><?php echo NO_COMMENTS; ?></div>
<?php
    }

    $i = 0;
    foreach ($comments as $comment) {

        if ($parentid === VIEWMODE_LINEAR || !isset($comment['parent_id']) || $comment['parent_id'] == $parentid) {
            $i++;

            $comment['comment'] = htmlspecialchars(strip_tags($comment['body']));
            $comment['url']     = strip_tags($comment['url']);
            if (!empty($comment['url']) && substr($comment['url'], 0, 7) != 'http://' && substr($comment['url'], 0, 8) != 'https://') {
                $comment['url'] = 'http://' . $comment['url'];
            }

            serendipity_plugin_api::hook_event('frontend_display', $comment);

            /* Protect submitted mails against spam, by replacing @ with [at]*/
            if (!empty($comment['email'])) {
                $comment['email'] = str_replace('@', '[at]', $comment['email']);
            }

            $name = empty($comment['username']) ? ANONYMOUS : $comment['username'];
            $body = $comment['comment'];
?>
    <div class="serendipity_comment">
            <a <?php echo ($serendipity['XHTML11'] ? 'id' : 'name'); ?>="c<?php echo $comment['id']; ?>"></a>
            <div class="serendipity_commentBody"><?php echo $body; ?></div>

            <div class="serendipity_comment_source">
                <a href="#c<?php echo $comment['id']; ?>" title="<?php echo LINK_TO_COMMENT . $indent . $i; ?>">#<?php echo $indent . $i; ?></a>
<?php
        /* Link to the user's email */
            if (!empty($comment['email'])) {
                echo  '<a href="mailto:' . htmlspecialchars($comment['email']) . '"  title="' . SEND_MAIL_TO . ' ' . htmlspecialchars($name) . ' (' . htmlspecialchars(strip_tags($comment['email'])) . ')">' . htmlspecialchars($name) . '</a>';
            } else {
                echo htmlspecialchars($name);
            }

            /* Create a link or plain text depending on spam control settings */
            $showlink = serendipity_get_config_var('top_as_links', true);
            if ($showlink === true) {
                $linktext = ' (<a href="' . str_replace('"', '&quot;', $comment['url']) . '" ' . serendipity_xhtml_target('_blank') . ' title="' . htmlspecialchars($comment['url']) . '">Link</a>)';
            } else {
                $linktext = ' (' . htmlspecialchars($comment['url']) . ") ";
            }

            /* Link to the user's website only if the URL is valid */
            if ((!isset($comment['type']) || $comment['type'] != 'trackback') && !empty($comment['url']) && $comment['url'] != 'http://' && eregi('^https?://', $comment['url'])) {
                echo $linktext;
            }

            /* Show when the entry was made */
            echo ' ' . ON . ' ' . ucfirst(strftime('%b %e %Y, %H:%M', $comment['timestamp']));

            if ($show_admin && $_SESSION['serendipityAuthedUser'] === true && ($_SESSION['serendipityUserlevel'] >= USERLEVEL_CHIEF || $_SESSION['serendipityAuthorid'] == $comment['authorid'])) {
                echo ' (<a href="' . $serendipity['baseURL'] . 'comment.php?serendipity[delete]=' . $comment['id'] . '&amp;serendipity[entry]=' . $comment['entry_id'] . '&amp;serendipity[type]=comments" onclick="return confirm(\''. sprintf(COMMENT_DELETE_CONFIRM, $comment['id'], htmlspecialchars($name)) .'\')">' . DELETE . '</a>)';
            }

            /* Allow people to easily reply to this comment */
            echo ' <a href="#serendipity_CommentForm" onclick="document.getElementById(\'serendipity_replyTo\').value=\'' . $comment['id'] . '\';">' . REPLY . '</a>';
?>
            </div>
<?php
                if ($comment['id'] && $parentid !== VIEWMODE_LINEAR ) {
                    serendipity_printComments($comments, $allow_comments, $show_admin, $comment['id'], $indent . $i . '.');
                }
?>
        </div>
<?php
        }
    }

    if ($parentid != 0 && $parentid !== VIEWMODE_LINEAR) {
        return true;
    }

    if ($show_admin && $_SESSION['serendipityAuthedUser'] === true && ($_SESSION['serendipityUserlevel'] >= USERLEVEL_CHIEF || $_SESSION['serendipityAuthorid'] == $comment['authorid'])) {
        if (!isset($comment['entry_id'])) {
            $comment = array('entry_id' => (isset($serendipity['GET']['id']) ? $serendipity['GET']['id'] : $serendipity['GET']['entry_id']));
        }

        if (serendipity_db_bool($allow_comments)) {
            echo '<div class="serendipity_center">(<a href="' . $serendipity['baseURL'] . 'comment.php?serendipity[switch]=disable&amp;serendipity[entry]=' . $comment['entry_id'] . '">' . COMMENTS_DISABLE . '</a>)</div>';
        } else {
            echo '<div class="serendipity_center">(<a href="' . $serendipity['baseURL'] . 'comment.php?serendipity[switch]=enable&amp;serendipity[entry]=' . $comment['entry_id'] . '">' . COMMENTS_ENABLE . '</a>)</div>';
        }
        echo '<br />';
    }
}

function serendipity_printTrackbacks($comments)
{
    global $serendipity;

    if (!count($comments)) {
?>
            <div class="serendipity_center"><?php echo NO_TRACKBACKS; ?></div>
<?php
    }

    foreach ($comments as $comment) {
        $link = empty($comment['url']) ? $comment['email'] : $comment['url'];
        $name = empty($comment['author']) ? 'Anonymous' : $comment['author'];
        $title= strip_tags($comment['title']);
?>
        <div class="serendipity_comment">
            <a href="<?php echo strip_tags($link); ?>" <?php echo serendipity_xhtml_target('_blank'); ?>><?php echo $title; ?></a><br />
            <b><?php echo EXCERPT; ?>: </b>
            <?php echo htmlspecialchars(strip_tags($comment['body'])); ?><br />
            <div class="serendipity_comment_source">
                <b>Weblog: </b> <?php echo strip_tags($name); ?><br />
                <b><?php echo TRACKED; ?>: </b> <?php echo date('M d, h:i', $comment['timestamp']); ?>
<?php
        if ($_SESSION["serendipityAuthedUser"] === true && ($_SESSION['serendipityUserlevel'] >= USERLEVEL_CHIEF || $_SESSION['serendipityAuthorid'] == $comment['authorid'])) {
            echo '                (<a href="' . $serendipity['baseURL'] . 'comment.php?serendipity[delete]=' . $comment['id'] . '&amp;serendipity[entry]=' . $comment['entry_id'] . '&amp;serendipity[type]=trackbacks">' . DELETE . '</a>)';
        }
?>
            </div>
        </div>
        <br />
<?php
    }
}


function serendipity_approveComment($cid, $entry_id, $force = false) {
    global $serendipity;

    /* Get data about the comment, we need this query because this function can be called from anywhere */
    /* This also makes sure we are either the author of the comment, or a USERLEVEL_ADMIN */
    $sql = "SELECT c.*, e.title, a.email as authoremail, a.mail_comments, e.timestamp AS entry_timestamp, e.last_modified AS entry_last_modified
                FROM {$serendipity['dbPrefix']}comments c
                LEFT JOIN {$serendipity['dbPrefix']}entries e ON (e.id = c.entry_id)
                LEFT JOIN {$serendipity['dbPrefix']}authors a ON (e.authorid = a.authorid)
                WHERE c.id = '". (int)$cid ."'
                    ". (($serendipity['serendipityUserlevel'] != USERLEVEL_ADMIN && $force !== true) ? "AND e.authorid = '". (int)$serendipity['authorId'] ."'" : '') ."
                    ". (($force === true) ? "" : "AND status = 'pending'");
    $rs  = serendipity_db_query($sql, true);

    /* It's already approved, don't spam people */
    if ( $rs === false ) {
        return false;
    }

    $sql = "UPDATE {$serendipity['dbPrefix']}comments SET status = 'approved' WHERE id = ". $cid;
    serendipity_db_query($sql);

    $field = ($rs['type'] == 'NORMAL' ? 'comments' : 'trackbacks');
    // Check when the entry was published. If it is older than max_last_modified allows, the last_modified date of that entry
    // will not be pushed. With this we make sure that an RSS feed will not be updated on a client's reader and marked as new
    // only because someone made an comment to an old entry.
    if ($rs['entry_timestamp'] > time() - $serendipity['max_last_modified']) {
        $lm = time();
    } else {
        $lm = (int)$rs['entry_last_modified'];
    }

    $query = "UPDATE {$serendipity['dbPrefix']}entries SET $field=$field+1, last_modified=". $lm ." WHERE id='". (int)$entry_id ."'";
    serendipity_db_query($query);

    if ($serendipity['allowSubscriptions']) {
        serendipity_mailSubscribers($entry_id, $rs['author'], $rs['email'], $rs['title'], $rs['authoremail']);
    }
    return true;
}

function serendipity_saveComment($id, $commentInfo, $type = 'NORMAL') {
    global $serendipity;

    $query = "SELECT allow_comments, moderate_comments, last_modified, timestamp FROM {$serendipity['dbPrefix']}entries WHERE id = '". (int)$id ."'";
    $ca    = serendipity_db_query($query, true);

    serendipity_plugin_api::hook_event('frontend_saveComment', $ca, $commentInfo);
    if (!is_array($ca) || serendipity_db_bool($ca['allow_comments'])) {
        $title         = serendipity_db_escape_string(isset($commentInfo['title']) ? $commentInfo['title'] : '');
        $comments      = $commentInfo['comment'];
        $ip            = $_SERVER['REMOTE_ADDR'];
        $commentsFixed = serendipity_db_escape_string($commentInfo['comment']);
        $name          = serendipity_db_escape_string($commentInfo['name']);
        $url           = serendipity_db_escape_string($commentInfo['url']);
        $email         = serendipity_db_escape_string($commentInfo['email']);
        $parentid      = (isset($commentInfo['parent_id']) && is_numeric($commentInfo['parent_id'])) ? $commentInfo['parent_id'] : 0;
        $status        = (serendipity_db_bool($ca['moderate_comments'])) ? 'pending' : 'approved';

        if (isset($commentInfo['subscribe'])) {
            $subscribe = 'true';
        } else {
            $subscribe = 'false';
        }

        $t      = time();
        $query  = "INSERT INTO {$serendipity['dbPrefix']}comments (entry_id, parent_id, ip, author, email, url, body, type, timestamp, title, subscribed, status)";
        $query .= " VALUES ('$id', '$parentid', '$ip', '$name', '$email', '$url', '$commentsFixed', '$type', '$t', '$title', '$subscribe', '$status')";

        serendipity_db_query($query);
        $cid = serendipity_db_insert_id('comments', 'id');

        $query = "SELECT a.email, e.title, a.mail_comments, a.mail_trackbacks, e.moderate_comments
                 FROM {$serendipity['dbPrefix']}entries e, {$serendipity['dbPrefix']}authors a
                 WHERE e.id  = '". (int)$id ."'
                 AND e.authorid = a.authorid";
        $row = serendipity_db_query($query, true); // Get info on author/entry

        // Send mail to the author if he chose to receive these mails, or if the comment is awaiting moderation
        if (serendipity_db_bool($ca['moderate_comments'])
            || ($type == 'NORMAL' && serendipity_db_bool($row['mail_comments']))
            || ($type == 'TRACKBACK' && serendipity_db_bool($row['mail_trackbacks']))) {
            serendipity_sendComment($cid, $row['email'], $name, $email, $url, $id, $row['title'], $comments, $type, serendipity_db_bool($row['moderate_comments']));
        }

        // Approve with force, if moderation is disabled
        if (empty($ca['moderate_comments']) || serendipity_db_bool($ca['moderate_comments']) == false) {
            serendipity_approveComment($cid, $id, true);
        }
        serendipity_purgeEntry($id, $t);
        return true;
    } else {
        return false;
    }
}

function serendipity_mailSubscribers($entry_id, $poster, $posterMail, $title, $fromEmail = 'none@example.com') {
    global $serendipity;

    $entryURI = serendipity_archiveURL($entry_id, $title, 'baseURL');
    $subject =  '[' . $serendipity['blogTitle'] . '] ' . sprintf(NEW_COMMENT_TO_SUBSCRIBED_ENTRY, $title);

    $pgsql_insert = '';
    $mysql_insert = '';
    if (strtolower($serendipity['dbType']) == 'postgres') {
        $pgsql_insert = 'DISTINCT ON (email)';
    } else {
        $mysql_insert = 'GROUP BY email';
    }

    $sql = "SELECT $pgsql_insert author, email, type
            FROM {$serendipity['dbPrefix']}comments
            WHERE entry_id = '". (int)$entry_id ."'
              AND email <> '" . serendipity_db_escape_string($posterMail) . "'
              AND subscribed = 'true' $mysql_insert";
    $subscribers = serendipity_db_query($sql);

    if (!is_array($subscribers)) {
        return;
    }

    foreach ($subscribers as $subscriber) {
        if ($subscriber['type'] == 'TRACKBACK') {
            $text = sprintf(
                      SUBSCRIPTION_TRACKBACK_MAIL,

                      $subscriber['author'],
                      $serendipity['blogTitle'],
                      $title,
                      $poster,
                      $entryURI,
                      $serendipity['baseURL'] . ($serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : '') . 'unsubscribe/' . urlencode($subscriber['email']) . '/' . (int)$entry_id
            );
        } else {
            $text = sprintf(
                      SUBSCRIPTION_MAIL,

                      $subscriber['author'],
                      $serendipity['blogTitle'],
                      $title,
                      $poster,
                      $entryURI,
                      $serendipity['baseURL'] . ($serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : '') . 'unsubscribe/' . urlencode($subscriber['email']) . '/' . (int)$entry_id
            );
        }

        mail($subscriber['email'], $subject,  $text . $serendipity['signature'], "From: {$serendipity['blogTitle']} <$fromEmail>\r\n". $serendipity['mailheaders']);
    }
}

function serendipity_cancelSubscription($email, $entry_id) {
    global $serendipity;
    $sql = "UPDATE {$serendipity['dbPrefix']}comments
                SET subscribed = 'false'
            WHERE entry_id = '". (int)$entry_id ."'
                AND email = '" . serendipity_db_escape_string($email) . "'";
    serendipity_db_query($sql);

    return serendipity_db_affected_rows();
}

function serendipity_sendComment($comment_id, $to, $fromName, $fromEmail, $fromUrl, $id, $title, $comment, $type = 'NORMAL', $moderate_comment = false) {
    global $serendipity;

    if (empty($fromName)) {
        $fromName = ANONYMOUS;
    }

    $entryURI = serendipity_archiveURL($id, $title, 'baseURL');
    $path = ($type == 'TRACKBACK') ? 'trackback' : 'comment';
    $deleteURI = $serendipity['baseURL'] . ($serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : '') . PATH_DELETE . '/'. $path .'/' . $comment_id . '/'. $id .'_' . serendipity_makeFilename($title)  . '.html';
    $approveURI = $serendipity['baseURL'] . ($serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : '') . PATH_APPROVE . '/'. $path .'/' . $comment_id . '/'. $id .'_' . serendipity_makeFilename($title)  . '.html';

    if ($type == 'TRACKBACK') {

        /******************* TRACKBACKS *******************/
        $subject =  '[' . $serendipity['blogTitle'] . '] ' . NEW_TRACKBACK_TO . ' ' . $title;
        $text = sprintf(A_NEW_TRACKBACK_BLAHBLAH, $title)
              . "\n"
              . "\n" . REQUIRES_REVIEW          . ': ' . (($moderate_comment) ? YES : NO)
              . "\n" . LINK_TO_ENTRY            . ': ' . $entryURI
              . "\n" . 'Weblog ' . NAME         . ': ' . stripslashes($fromName)
              . "\n" . LINK_TO_REMOTE_ENTRY     . ': ' . $fromUrl
              . "\n"
              . "\n" . EXCERPT . ':'
              . "\n" . strip_tags($comment)
              . "\n"
              . "\n" . '----'
              . "\n" . YOU_HAVE_THESE_OPTIONS
              . (($moderate_comment) ? "\n" . str_repeat(' ', 2) . THIS_TRACKBACK_NEEDS_REVIEW : '')
              . "\n" . str_repeat(' ', 3) . str_pad(VIEW_ENTRY,  15) . ' -- '. $entryURI
              . "\n" . str_repeat(' ', 3) . str_pad(DELETE_TRACKBACK,  15) . ' -- '. $deleteURI
              . (($moderate_comment) ? "\n" . str_repeat(' ', 3) . str_pad(APPROVE_TRACKBACK, 15) . ' -- '. $approveURI : '');

    } else {

        /******************* COMMENTS *********************/
        $subject = '[' . $serendipity['blogTitle'] . '] ' . NEW_COMMENT_TO . ' ' . $title;
        $text = sprintf(A_NEW_COMMENT_BLAHBLAH, $serendipity['blogTitle'], $title)
              . "\n" . LINK_TO_ENTRY . ': ' . $entryURI
              . "\n"
              . "\n" . REQUIRES_REVIEW         . ': ' . (($moderate_comment) ? YES : NO)
              . "\n" . USER . ' ' . IP_ADDRESS . ': ' . $_SERVER['REMOTE_ADDR']
              . "\n" . USER . ' ' . NAME       . ': ' . $fromName
              . "\n" . USER . ' ' . EMAIL      . ': ' . $fromEmail
              . "\n" . USER . ' website: '            . $fromUrl
              . "\n"
              . "\n" . COMMENTS                . ': '
              . "\n" . strip_tags($comment)
              . "\n"
              . "\n" . '----'
              . "\n" . YOU_HAVE_THESE_OPTIONS
              . (($moderate_comment) ? "\n" . str_repeat(' ', 2) . THIS_COMMENT_NEEDS_REVIEW : '')
              . "\n" . str_repeat(' ', 3) . str_pad(VIEW_COMMENT,  15) . ' -- '. $entryURI .'#c'. $comment_id
              . "\n" . str_repeat(' ', 3) . str_pad(DELETE_COMMENT,  15) . ' -- '. $deleteURI
              . (($moderate_comment) ? "\n" . str_repeat(' ', 3) . str_pad(APPROVE_COMMENT, 15) . ' -- '. $approveURI : '');
    }

    return mail($to, $subject,  $text . $serendipity['signature'], "From: {$serendipity['blogTitle']} - $fromName <$to>". (!empty($fromEmail) ? "\r\nReply-To: $fromEmail" : ''). "\r\n". $serendipity['mailheaders']);
}

function serendipity_fetchReferences($id)
{
    global $serendipity;

    $query = "SELECT name,link FROM {$serendipity['dbPrefix']}references WHERE entry_id = '" . (int)$id . "'";

    return serendipity_db_query($query);
}


function serendipity_utf8_encode($string) {
    if (strtolower(LANG_CHARSET) != 'utf-8') {
        if (function_exists('iconv')) {
            return iconv(LANG_CHARSET, 'UTF-8', $string);
        } else {
            return utf8_encode($string);
        }
    } else {
        return $string;
    }
}

function serendipity_rss_getguid($entry, $comments = false) {
    $guid = serendipity_archiveURL((isset($entry['entryid']) && $entry['entryid'] != '' ? $entry['entryid'] : $entry['id']), 'guid');
    if ($comments == true) {
        $guid .= '#c' . $entry['commentid'];
    }

    return $guid;
}

// jbalcorn: starter function to clean up xhtml for atom feed.  Add things to this as we find common
//      mistakes, unless someone finds a better way to do this.
//      DONE:
//          since someone encoded all the urls, we can now assume any amp followed by
//              whitespace or a HTML tag (i.e. &<br /> )should be
//              encoded and most not with a space are intentional
//      TODO:
//          check ALL ampersands, find out if it's a valid code, and encode if not
function xhtml_cleanup($html) {
    static $p = array(
        '/\&([\s\<])/',       // ampersand followed by whitespace or tag
        '/\&$/',              // ampersand at end of body
        '/<(br|hr|img)([^\/>]*)>/i',    // unclosed br tag - attributes included
    );

    static $r = array(
        '&amp;\1',
        '&amp;',
        '<\1\2 />'
    );

    return preg_replace($p, $r, $html);
}

function serendipity_printEntries_rss($entries, $version, $comments = false) {
    global $serendipity;

    if (is_array($entries)) {
        foreach ($entries as $entry) {
            $guid = serendipity_rss_getguid($entry, $comments);
            $entryLink = serendipity_archiveURL($entry['id'], $entry['title']);
            if ($comments == true) {
                // Display username as part of the title for easier feed-readability
                $entry['title'] = $entry['username'] . ': ' . $entry['title'];
            }

            // Embed a link to extended entry, if existing
            if ($entry['exflag']) {
                $ext = '<br /><a href="' . $guid . '#extended">' . sprintf(VIEW_EXTENDED_ENTRY, htmlspecialchars($entry['title'])) . '</a>';
            } else {
                $ext = '';
            }

            serendipity_plugin_api::hook_event('frontend_display', $entry);
            // Do some relative -> absolute URI replacing magic. Replaces all HREF/SRC (<a>, <img>, ...) references to only the serendipitypath with the full baseURL URI
            // garvin: Could impose some problems. Closely watch this one.
            $entry['body'] = preg_replace('@(href|src)=("|\')(' . preg_quote($serendipity['serendipityHTTPPath']) . ')(.*)("|\')(.*)>@imsU', '\1=\2' . $serendipity['baseURL'] . '\4\2\6>', $entry['body']);
            // jbalcorn: clean up body for XML compliance as best we can.
            $entry['body'] = xhtml_cleanup($entry['body']);

            // extract author information
            if (empty($entry['email'])) {
                $query = "select email FROM {$serendipity['dbPrefix']}authors WHERE username = '". serendipity_db_escape_string($entry['username']) ."'";
                $results = serendipity_db_query($query);
                $entry['email'] = $results[0]['email'];
            }

            if (!is_array($entry['categories'])) {
                $entry['categories'] = array(0 => array('category_name' => $entry['category_name']));
            }

            if ($version == 'atom0.3') {
                /*********** ATOM 0.3 FEED *************/
?>
<entry>
    <link href="<?php echo $entryLink; ?>" rel="alternate" title="<?php echo serendipity_utf8_encode(htmlspecialchars($entry['title'])); ?>" type="text/html" />
    <author>
        <name><?php echo serendipity_utf8_encode(htmlspecialchars($entry['username'])); ?></name>
        <email><?php echo serendipity_utf8_encode(htmlspecialchars($entry['email'])); ?></email>
    </author>

    <issued><?php echo gmdate('Y-m-d\TH:i:s\Z', $entry['timestamp']); ?></issued>
    <created><?php echo gmdate('Y-m-d\TH:i:s\Z', $entry['timestamp']); ?></created>
    <modified><?php echo gmdate('Y-m-d\TH:i:s\Z', $entry['last_modified']); ?></modified>
    <wfw:comment><?php echo $serendipity['baseURL']; ?>wfwcomment.php?cid=<?php echo (isset($entry['entryid']) && $entry['entryid'] != '' ? $entry['entryid'] : $entry['id']); ?></wfw:comment>

<?php
                    if ($comments === false) {
?>
    <slash:comments><?php echo $entry['comments']; ?></slash:comments>
    <wfw:commentRss><?php echo $serendipity['baseURL']; ?>rss.php?version=<?php echo $version; ?>&amp;type=comments&amp;cid=<?php echo (isset($entry['entryid']) && $entry['entryid'] != '' ? $entry['entryid'] : $entry['id']); ?></wfw:commentRss>
<?php
                    }
?>

    <id><?php echo $guid; ?></id>
    <title mode="escaped" type="text/html"><?php echo serendipity_utf8_encode(htmlspecialchars($entry['title'])); ?></title>
    <content type="application/xhtml+xml" xml:base="<?php echo $serendipity['baseURL']; ?>">
        <div xmlns="http://www.w3.org/1999/xhtml">
<?php
                    echo serendipity_utf8_encode($entry['body'].$ext);
?>
        </div>
    </content>
</entry>
<?php
            } elseif ($version == '0.91' || $version == '2.0') {
                /*********** BEGIN RSS 0.91/2.0 FEED *************/
?>
<item>
    <title><?php echo serendipity_utf8_encode(htmlspecialchars($entry['title'])); ?></title>
    <link><?php echo $entryLink; ?></link>
<?php
                /*********** END RSS 0.91/2.0 FEED *************/

                if ($version == '2.0') {
                    /*********** RSS 2.0 FEED EXTRAS *************/
                    foreach ($entry['categories'] AS $idx => $cat) {
                        ?><category><?php echo utf8_encode(htmlspecialchars($cat['category_name'])); ?></category><?php
                    }
?>
    <comments><?php echo $entryLink; ?>#comments</comments>
    <wfw:comment><?php echo $serendipity['baseURL']; ?>wfwcomment.php?cid=<?php echo (isset($entry['entryid']) && $entry['entryid'] != '' ? $entry['entryid'] : $entry['id']); ?></wfw:comment>
<?php
                    if ($comments === false) {
?>
    <slash:comments><?php echo $entry['comments']; ?></slash:comments>
    <wfw:commentRss><?php echo $serendipity['baseURL']; ?>rss.php?version=<?php echo $version; ?>&amp;type=comments&amp;cid=<?php echo (isset($entry['entryid']) && $entry['entryid'] != '' ? $entry['entryid'] : $entry['id']); ?></wfw:commentRss>
<?php
                    }
?>
    <author><?php echo serendipity_utf8_encode(htmlspecialchars($entry['email'])) . ' (' . serendipity_utf8_encode(htmlspecialchars($entry['username'])) . ')'; ?></author>
    <content:encoded>
<?php
                    echo serendipity_utf8_encode(htmlspecialchars($entry['body'].$ext));
?>
    </content:encoded>
    <pubDate><?php echo date('r', $entry['timestamp']); ?></pubDate>
    <guid><?php echo $guid; ?></guid>
    <?php
      $eventData = array_merge(array('display_dat' => ''), $entry);
      serendipity_plugin_api::hook_event('frontend_display:rss-2.0:per_entry', $eventData);
      echo $eventData['display_dat'];
    ?>
</item>
<?php
                    /*********** END 2.0 FEED EXTRAS *************/
                } else {
                    /*********** BEGIN RSS 0.91 FEED EXTRAS *************/
?>
    <description>
        <?php echo serendipity_utf8_encode(htmlspecialchars($entry['body'] . $ext)); ?>
    </description>
</item>
<?php
                    /*********** END RSS 0.91 FEED EXTRAS *************/
                }
            } else if ($version == '1.0') {
                $categories = array();
                foreach ($entry['categories'] AS $idx => $cat) {
                    $categories[] = $cat['category_name'];
                }

?>
<item rdf:about="<?php echo $guid; ?>">
    <title><?php echo serendipity_utf8_encode(htmlspecialchars($entry['title'])); ?></title>
    <link><?php echo $entryLink; ?></link>
    <description>
<?php
                echo serendipity_utf8_encode(htmlspecialchars($entry['body'].$ext));
?>
    </description>
    <?php
      $eventData = array_merge(array('display_dat' => ''), $entry);
      serendipity_plugin_api::hook_event('frontend_display:rss-1.0:per_entry', $eventData);
      echo $eventData['display_dat'];
    ?>
    <dc:publisher><?php echo serendipity_utf8_encode(htmlspecialchars($serendipity['blogTitle'])); ?></dc:publisher>
    <dc:creator><?php echo serendipity_utf8_encode(htmlspecialchars($entry['email'])) . ' (' . serendipity_utf8_encode(htmlspecialchars($entry['username'])) . ')'; ?></dc:creator>
    <dc:subject><?php echo serendipity_utf8_encode(htmlspecialchars(implode(', ', $categories))); ?></dc:subject>
    <dc:date><?php echo date('Y-m-d\TH:i:s\Z', $entry['timestamp']); ?></dc:date>
    <wfw:comment><?php echo $serendipity['baseURL']; ?>wfwcomment.php?cid=<?php echo (isset($entry['entryid']) && $entry['entryid'] != '' ? $entry['entryid'] : $entry['id']); ?></wfw:comment>
<?php
                    if ($comments === false) {
?>
    <slash:comments><?php echo $entry['comments']; ?></slash:comments>
    <wfw:commentRss><?php echo $serendipity['baseURL']; ?>rss.php?version=<?php echo $version; ?>&amp;type=comments&amp;cid=<?php echo (isset($entry['entryid']) && $entry['entryid'] != '' ? $entry['entryid'] : $entry['id']); ?></wfw:commentRss>
<?php
                    }
?>
</item>
<?php
            } elseif ($version == 'opml1.0') {
?>
    <outline text="<?php echo serendipity_utf8_encode(htmlspecialchars($entry['title'])); ?>" type="url" htmlUrl="<?php echo $entryLink; ?>" urlHTTP="<?php echo $entryLink; ?>" />
<?php
            }
        }
    }
}


/**
/**
 * purge a statically pregenerated entry
 */
function serendipity_purgeEntry($id, $timestamp = null)
{
    global $serendipity;

    // If pregenerate is not set, short circuit all this logic
    // and remove nothing.
    if(!isset($serendipity['pregenerate'])) {
        return;
    }

    if (isset($timestamp)) {
        $dated = date('Ymd', $timestamp);
        $datem = date('Ym',  $timestamp);

        @unlink("{$serendipity['serendipityPath']}/".PATH_ARCHIVES."/{$dated}.html");
        @unlink("{$serendipity['serendipityPath']}/".PATH_ARCHIVES."/{$datem}.html");
    }

    // Fixme (the _* part) !
    @unlink("{$serendipity['serendipityPath']}/".PATH_ARCHIVES."/{$id}_*.html");
    @unlink("{$serendipity['serendipityPath']}/".PATH_FEEDS."/index.rss");
    @unlink("{$serendipity['serendipityPath']}/".PATH_FEEDS."/index.rss2");
    @unlink("{$serendipity['serendipityPath']}/index.html");
}


/**
 * validate trackback response
 */
function serendipity_trackback_is_success($resp)
{
    if (preg_match('@<error>(\d+)</error>@', $resp, $matches)) {
        if ((int) $matches[1] === 0) {
            return true;
        } else {
            if (preg_match('@<message>([^<]+)</message>@', $resp, $matches)) {
                return $matches[1];
            }
            else {
                return 'unknown error';
            }
        }
    }
    return true;
}

function serendipity_pingback_autodiscover($loc, $body) {
    if (!empty($_SERVER['X-PINGBACK'])) {
        $pingback = $_SERVER['X-PINGBACK'];
    } elseif (preg_match('@<link rel="pingback" href="([^"]+)" ?/?>@i', $body, $matches)) {
        $pingback = $matches[1];
    } else {
        return;
    }

    // xml-rpc hack
    $query = "
<?xml version=\"1.0\"?>
<methodCall>
  <methodName>pingback.ping</methodName>
  <params>
    <param>
      <name>sourceURI</name>
      <value><string>{$serendipity['baseURL']}</string></value>
    </param>
      <name>targetURI</name>
      <value><string>$loc</string></value>
    </param>
  </params>
</methodCall>";
        _serendipity_send($pingback, $query);
        return;
}

/**
 * Send a trackback ping
 */
function _serendipity_send($loc, $data) {
    global $serendipity;

    $target = parse_url($loc);
    if ($target['query'] != '') {
        $target['query'] = '?' . str_replace('&amp;', '&', $target['query']);
    }

    if (!is_numeric($target['port'])) {
       $target['port'] = 80;
    }

    $sock = @fsockopen($target['host'], $target['port']);
    if (!is_resource($sock)) {
        return "Couldn't connect to $loc";
    }

    $headers = "POST {$target['path']}{$target['query']} HTTP/1.1\r\n";
    $headers .= "Host: {$target['host']}\r\n";
    $headers .= "User-Agent: Serendipity/{$serendipity['version']}\r\n";
    $headers .= "Content-Type: application/x-www-form-urlencoded; charset=" . LANG_CHARSET . "\r\n";
    $headers .= "Content-Length: " . strlen($data) . "\r\n";
    $headers .= "Connection: close\r\n";
    $headers .= "\r\n";
    $headers .= $data;

    fwrite($sock, $headers);

    $res = '';
    while (!feof($sock)) {
        $res .= fgets($sock, 1024);
    }

    fclose($sock);
    return $res;
}

function serendipity_trackback_autodiscover($res, $loc, $url, $author, $title, $text)
{
    if (!preg_match('@trackback:ping(\s*rdf:resource)?\s*=\s*"(http:[^"]+)"@i', $res, $matches)) {
        echo '<div>&#8226; ' . sprintf(TRACKBACK_FAILED, TRACKBACK_NOT_FOUND) . '</div>';
        return false;
    }

    $trackURI = trim($matches[2]);

    if (preg_match('@dc:identifier\s*=\s*"(http:[^"]+)"@i', $res, $test)) {
        if ($loc != $test[1]) {
            echo '<div>&#8226; ' . sprintf(TRACKBACK_FAILED, TRACKBACK_URI_MISMATCH) . '</div>';
            return false;
        }
    }

    $data = 'url='        . rawurlencode($url)
          . '&title='     . rawurlencode($title)
          . '&blog_name=' . rawurlencode($author)
          . '&excerpt='   . rawurlencode(strip_tags($text));

    printf(TRACKBACK_SENDING, htmlspecialchars($trackURI));
    flush();

    $response = serendipity_trackback_is_success(_serendipity_send($trackURI, $data));

    if ($response === true) {
        echo '<div>&#8226; ' . TRACKBACK_SENT .'</div>';
    } else {
        echo '<div>&#8226; ' . sprintf(TRACKBACK_FAILED, $response) . '</div>';
    }

    return $response;
}

function serendipity_reference_autodiscover($loc, $url, $author, $title, $text) {
global $serendipity;
    $timeout   = 30;

    $u = parse_url($loc);

    if ($u['scheme'] != 'http') {
        return;
    }

    echo '<div>&#8226; '. sprintf(TRACKBACK_CHECKING, $loc) .'</div>';
    flush();

    if (empty($u['port'])) {
        $u['port'] = 80;
        $port      = '';
    } else {
        $port      = ':' . $u['port'];
    }

    if (!empty($u['query'])) {
        $u['path'] .= '?' . $u['query'];
    }

    $parsed_loc = $u['scheme'] . '://' . $u['host'] . $port . $u['path'];
    $res = '';

    $fp  = @fsockopen($u['host'], $u['port'], $err, $timeout);
    if (!$fp) {
        echo '<div>&#8226; ' . sprintf(TRACKBACK_COULD_NOT_CONNECT, $u['host'], $u['port']) .'</div>';
        return;
    } else {
        fputs($fp, "GET {$u['path']} HTTP/1.0\r\n");
        fputs($fp, "Host: {$u['host']}\r\n");
        fputs($fp, "User-Agent: Serendipity/{$serendipity['version']}\r\n");
        fputs($fp, "Connection: close\r\n\r\n");

        while ($fp && !feof($fp) && strlen($res) < $serendipity['trackback_filelimit']) {
            $res .= fgets($fp, 4096);
        }
        fclose($fp);

        if (strlen($res) >= $serendipity['trackback_filelimit']) {
            echo '<div>&#8226; ' . sprintf(TRACKBACK_SIZE, $serendipity['trackback_filelimit']) .'</div>';
            return;
        }
    }

    if (strlen($res) != 0) {
        serendipity_trackback_autodiscover($res, $parsed_loc, $url, $author, $title, $text);
        serendipity_pingback_autodiscover($loc, $res);
    } else {
        echo '<div>&#8226; ' . TRACKBACK_NO_DATA . '</div>';
    }
    echo '<hr noshade="noshade" />';
}

/**
 *
 */
function add_trackback ($id, $title, $url, $name, $excerpt)
{
    global $serendipity;

    // We can't accept a trackback if we don't get any URL
    // This is a protocol rule.
    if ( empty($url) ) {
        return 0;
    }

    // If title is not provided, the value for url will be set as the title
    // This is a protocol rule.
    if ( empty($title) ) {
        $title = $url;
    }
    $comment['title']   = $title;
    $comment['url']     = $url;
    $comment['name']    = $name;
    $comment['comment'] = $excerpt;

    serendipity_saveComment($id, $comment, 'TRACKBACK');

    return 1;
}

function add_pingback ($id, $postdata)
{
    global $serendipity;

    if(preg_match('@<methodcall>\s*<methodName>\s*pingback.ping\s*</methodName>\s*<params>\s*<param>\s*<value>\s*<string>([^<])*</string>\s*</value>\s*</param>\s*<param>\s*<value>\s*<string>([^<])*</string>\s*</value>\s*</param>\s*</params>\s*</methodCall>@i', $postdata, $matches)) {
        $remote             = $matches[1];
        $local              = $matches[2];
        $comment['title']   = '';
        $comment['url']     = $remote;
        $comment['comment'] = '';
        $comment['name']    = '';

        serendipity_saveComment($id, $comment, 'PINGBACK');
        return 1;
    }
    return 0;
}

/**
 * Cut text
 */
function serendipity_trackback_excerpt($text)
{
    return substr(strip_tags($text), 0, 255);
}

function report_trackback_success ()
{
print '<?xml version="1.0" encoding="iso-8859-1"?>' . "\n";
print <<<SUCCESS
<response>
    <error>0</error>
</response>
SUCCESS;
}

function report_trackback_failure ()
{
print '<?xml version="1.0" encoding="iso-8859-1"?>' . "\n";
print <<<FAILURE
<response>
    <error>1</error>
    <message>Danger Will Robinson, trackback failed.</message>
</response>
FAILURE;
}

function report_pingback_success ()
{
print '<?xml version="1.0"?>' . "\n";
print <<<SUCCESS
<methodResponse>
   <params>
      <param>
         <value><string>success</string></value>
         </param>
      </params>
   </methodResponse>
SUCCESS;
}

function report_pingback_failure ()
{
print '<?xml version="1.0"?>' . "\n";
print <<<FAILURE
<methodResponse>
    <fault>
    <value><i4>0</i4></value>
    </fault>
</methodResponse>
FAILURE;
}

/**
 * return a fully qualified URL
 */
function serendipity_archiveURL($id, $title, $key = 'baseURL', $checkrewrite = true) {
global $serendipity;

    return $serendipity[$key] . ($checkrewrite && $serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : '') . PATH_ARCHIVES . '/' . (int)$id . '-' . serendipity_makeFilename($title) . '.html';
}

/**
 * return URL for a date archive
 */
function serendipity_archiveDateUrl($range, $short=false, $key='baseURL') {
    global $serendipity;

    return $serendipity[$key]. ($serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : '') . PATH_ARCHIVES . '/' . $range . ($short ? '-short' : '') . '.html';
}

/**
 * search through link body, and automatically send a trackback ping.
 */
function serendipity_handle_references($id, $author, $title, $text)
{
    global $serendipity;

    if (!preg_match_all('@<a[^>]+?href\s*=\s*["\']?([^\'" >]+?)[ \'"][^>]*>([^<]*)</a>@i', $text, $matches)) {
        return;
    }

    // remove full matches
    array_shift($matches);

    // Make trackback URL
    $url = serendipity_archiveURL($id, $title, 'baseURL');

    // Add URL references
    $locations = $matches[0];
    $names = $matches[1];
    $tmpid = serendipity_db_escape_string($id);


    for ($i = 0, $j = count($locations); $i < $j; ++$i) {
        if($locations[$i][0] == '/') {
            $locations[$i] = 'http' . (!empty($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS']) != 'off' ? 's' : '') . '://' . $_SERVER['HTTP_HOST'] . $locations[$i];
        }

        $query = "SELECT COUNT(id) FROM {$serendipity['dbPrefix']}references
                            WHERE entry_id = '". (int)$tmpid ."'
                                  AND link = '" . serendipity_db_escape_string($locations[$i]) . "'";

        $row = serendipity_db_query($query, true, 'num');
        if ($row[0] > 0) {
            continue;
        }
        if (!isset($serendipity['noautodiscovery']) || !$serendipity['noautodiscovery']) {
            serendipity_reference_autodiscover($locations[$i], $url, $author, $title, serendipity_trackback_excerpt($text));
        }
    }
    serendipity_db_query("DELETE FROM {$serendipity['dbPrefix']}references WHERE entry_id='$tmpid'");

    for ($i = 0; $i < $j; ++$i) {
        $query = "INSERT INTO {$serendipity['dbPrefix']}references (entry_id, name, link) VALUES(";
        $query .= "'$tmpid', '" . serendipity_db_escape_string($names[$i]) . "', '";
        $query .= serendipity_db_escape_string($locations[$i]) . "')";

        serendipity_db_query($query);
    }

    // Add citations
    preg_match_all('@<cite[^>]*>([^<]+)</cite>@i', $text, $matches);

    foreach ($matches[1] as $citation) {
        $query = "INSERT INTO {$serendipity['dbPrefix']}references (entry_id, name) VALUES(";
        $query .= "'$tmpid', '" . serendipity_db_escape_string($citation) . "')";

        serendipity_db_query($query);
    }
}

/**
* Inserts a new entry into the database or updates an existing
**/
function serendipity_updertEntry($entry) {
    global $serendipity;

    $categories = $entry['categories'];
    unset($entry['categories']);

    $newEntry = 0;
    $exflag = 0;

    if (!is_numeric($entry['timestamp'])) {
        $entry['timestamp'] = time();
    }

    if (!isset($entry['last_modified']) || !is_numeric($entry['last_modified'])) {
        $entry['last_modified'] = time();
    }

    /* WYSIWYG-editor inserts empty '<br />' for extended body; this is reversed here */
    if (isset($entry['extended']) && trim($entry['extended']) == '<br />') {
        $entry['extended'] = '';
    }

    if (strlen($entry['extended'])) {
        $exflag = 1;
    }

    $entry['exflag']   = $exflag;

    if (!is_numeric($entry['id'])) {
        /* we need to insert */

        unset($entry['id']);
        $entry['comments'] = 0;

        // New entries need an author
        $entry['author']   = $serendipity['user'];
        if (!isset($entry['authorid']) || empty($entry['authorid'])) {
            $entry['authorid'] = $serendipity['authorid'];
        }

        if (!$_SESSION['serendipityRightPublish']) {
            $entry['isdraft'] = 'true';
        }

        if(!isset($entry['allow_comments'])){
            $entry['allow_comments']='false';
        }
        if(!isset($entry['moderate_comments'])){
            $entry['moderate_comments']='false';
        }

        $res = serendipity_db_insert('entries', $entry);

        if ($res) {
            $entry['id'] = serendipity_db_insert_id('entries', 'id');
            if (is_array($categories)) {
                foreach ($categories as $cat) {
                  if (is_numeric($cat))
                      serendipity_db_query("INSERT INTO {$serendipity['dbPrefix']}entrycat (entryid, categoryid) VALUES ({$entry['id']}, {$cat})");
                }
            }
        }
        else {
            //Some error message here
            return ENTRIES_NOT_SUCCESSFULLY_INSERTED;
        }
        $newEntry    = 1;
    } else {
        /* we need to update */

        // Get settings from entry if already in DB, which should not be alterable with POST methods
        $_entry            = serendipity_fetchEntry('id', $entry['id'], 1, 1);
        $entry['authorid'] = $_entry['authorid'];

        if (isset($serendipity['GET']['adminModule']) && $serendipity['GET']['adminModule'] == 'entries' && $serendipity['serendipityUserlevel'] < USERLEVEL_CHIEF && $entry['authorid'] != $serendipity['authorid']) {
            // Only chiefs and admins can change other's entry. Else update fails.
            return;
        }

        if (!$_SESSION['serendipityRightPublish']) {
            unset($entry['isdraft']);
        }

        if (is_array($categories)) {
            serendipity_db_query("DELETE FROM {$serendipity['dbPrefix']}entrycat WHERE entryid={$entry['id']}");
            foreach ($categories as $cat) {
                serendipity_db_query("INSERT INTO {$serendipity['dbPrefix']}entrycat (entryid, categoryid) VALUES ({$entry['id']}, {$cat})");
            }
        }

        $res = serendipity_db_update('entries', array('id' => $entry['id']), $entry);
        $newEntry = 0;
    }

    if (is_string($res)) {
        return $res;
    }

    if ($entry['isdraft'] == 'false') {
        serendipity_plugin_api::hook_event('frontend_display', $entry, array('no_scramble' => true));
        serendipity_handle_references($entry['id'], $serendipity['blogTitle'], $entry['title'], $entry['body'] . $entry['extended'], $newEntry);
    }

    serendipity_purgeEntry($entry['id'], $entry['timestamp']);

    // Send publish tags if either a new article has been inserted from scratch, or if the entry was previously
    // stored as draft and is now published
    if ($entry['isdraft'] == 'false' && ($newEntry || $_entry['isdraft'] == 'true')) {
        serendipity_plugin_api::hook_event('backend_publish', $entry);
    }

    return (int)$entry['id'];
}

/**
* Deletes an entry and everything that belongs to it (comments, etc...) from
* the database
**/
function serendipity_deleteEntry($id) {
    global $serendipity;

    if (!is_numeric($id)) {
        return false;
    }

    // Purge the daily/monthly entries so they can be rebuilt
    $result = serendipity_db_query("SELECT timestamp, authorid FROM {$serendipity['dbPrefix']}entries WHERE id = '". (int)$id ."'", true);

    if ($serendipity['serendipityUserlevel'] < USERLEVEL_CHIEF && $result[1] != $serendipity['authorid']) {
        // Only admins and chief users can delete entries which do not belong to the author
        return;
    }

    serendipity_purgeEntry($id, $result[0]);

    serendipity_db_query("DELETE FROM {$serendipity["dbPrefix"]}entries WHERE id=$id");
    serendipity_db_query("DELETE FROM {$serendipity["dbPrefix"]}comments WHERE entry_id=$id");
    serendipity_db_query("DELETE FROM {$serendipity['dbPrefix']}references WHERE entry_id='$id'");
}


/**
* Split up a filename
**/
function serendipity_parseFileName($file) {
    $x = explode('.', $file);
    $suf = array_pop($x);
    $f   = @implode('.', $x);
    return array($f, $suf);
}

/**
* Print a list of categories
*
* Prints a list of categories for use in forms, the sidebar, or whereever...
* @param array  An array of categories, typically gathered by serendipity_fetchCategories()
* @param array  Select
* @param int    Type
* @param int    ID
* @param int    Level
* @param string Tells the function, whether or not to display the XML button for each category.
*               If empty, no links to the xml feeds will be displayed; If you want to, you can
*               pass an image here (this setting is only used, when type==3).
* @see serendipity_fetchCategories()
*/
function serendipity_generateCategoryList($cats, $select = array(0), $type = 0, $id = 0, $level = 0, $xmlImg = '') {
    global $serendipity;

    if ( !is_array($cats) || !count($cats) )
        return;

    $ret = '';
    foreach ($cats as $cat) {
        if ($cat['parentid'] == $id) {
            switch ($type) {
                case 0:
                    $ret .= str_repeat('&nbsp;', $level * 2).'&bull;&nbsp;<span id="catItem_' . $cat['categoryid'] . '"' . (($cat['categoryid'] && in_array($cat['categoryid'], $select)) ? ' selected="selected"' : '') . '><a href="?serendipity[adminModule]=category&amp;serendipity[cat][catid]=' . $cat['categoryid'] . '">' . (!empty($cat['category_icon']) ? '<img style="vertical-align: middle;" src="' . $cat['category_icon'] . '" border="0" alt="' . $cat['category_name'] . '"/> ' : '') . htmlspecialchars($cat['category_name']) . (!empty($cat['category_description']) ? ' - ' . htmlspecialchars($cat['category_description']) : '') . '</a></span><br/>' . "\n";
                    break;
                case 1:
                case 2:
                   $ret .= '<option value="' . $cat['categoryid'] . '"' . (($cat['categoryid'] && in_array($cat['categoryid'], $select)) ? ' selected="selected"' : '') . '>';
                   $ret .= str_repeat('&nbsp;', $level * 2) . htmlspecialchars($cat['category_name']) . ($type == 1 && !empty($cat['category_description']) ? (' - ' . htmlspecialchars($cat['category_description'])) : '');
                   $ret .= '</option>';
                   break;
                case 3:
                    $category_id = serendipity_makeFilename($cat['category_name']);
                    if (!empty($xmlImg)) {
                        $ret .= sprintf(
                          '<a href="%s" title="%s"><img alt="xml" %s src="%s" /></a>&nbsp;%s' .
                          '<a href="%s" title="%s">%s</a><br />',
                          $serendipity['serendipityHTTPPath'] . 'rss.php?category=' . $cat['categoryid'] . '_' . $category_id,
                          htmlspecialchars($cat['category_description']),
                          ($serendipity['XHTML11'] ? 'style="display: inline; border: 0px"' : 'border="0"'),
                          $xmlImg,
                          str_repeat('&nbsp;', $level * 3),
                          $serendipity['serendipityHTTPPath'] . ($serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : '') . PATH_CATEGORIES . '/' . $cat['categoryid'] . '-' . $category_id,
                          htmlspecialchars($cat['category_description']),
                          htmlspecialchars($cat['category_name']));
                    } else {
                        $ret .= sprintf(
                          '%s<a href="%s" title="%s">%s</a><br />',
                          str_repeat('&nbsp;', $level * 3),
                          $serendipity['serendipityHTTPPath'] . ($serendipity['rewrite'] == 'none' ? $serendipity['indexFile'] . '?/' : '') . PATH_CATEGORIES . '/' . $cat['categoryid'] . '-' . $category_id,
                          htmlspecialchars($cat['category_description']),
                          htmlspecialchars($cat['category_name']));
                    }
                    break;
            }
            $ret .= serendipity_generateCategoryList($cats, $select, $type, $cat['categoryid'], $level + 1, $xmlImg);
        }
    }
    return $ret;
}

/**
* Prints a form to enter new diary entries
**/
function serendipity_printEntryForm($targetURL, $hiddens = array(), $entry = array(), $errMsg = "") {
    global $serendipity;

    $serendipity['EditorBrowsers'] = '(IE|Mozilla)';

    $draftD = '';
    $draftP = '';
    $categoryselector_expanded = false;

    if (isset($entry['isdraft']) && $entry['isdraft'] == 'true') {
        $draftD = ' selected="selected"';
    } else {
        $draftP = ' selected="selected"';
    }

    if (isset($entry['moderate_comments']) && (serendipity_db_bool($entry['moderate_comments']))) {
        $moderate_comments = ' checked="checked"';
    } elseif (!isset($entry['moderate_comments']) && ($serendipity['moderateCommentsDefault'] == 'true' || $serendipity['moderateCommentsDefault'] === true)) {
        // This is the default on creation of a new entry and depends on the "moderateCommentsDefault" variable of the configuration.
        $moderate_comments = ' checked="checked"';
    } else {
        $moderate_comments = '';
    }


    if (isset($entry['allow_comments']) && (serendipity_db_bool($entry['allow_comments']))) {
        $allow_comments = ' checked="checked"';
    } elseif ((!isset($entry['allow_comments']) || $entry['allow_comments'] !== 'false') && ($serendipity['allowCommentsDefault'] == 'true' || $serendipity['allowCommentsDefault'] === true)) {
        // This is the default on creation of a new entry and depends on the "allowCommentsDefault" variable of the configuration.
        $allow_comments = ' checked="checked"';
    } else {
        $allow_comments = '';
    }

    $n = "\n";
    $cat_list = '<select id="categoryselector" name="serendipity[categories][]" style="vertical-align: middle;" multiple="multiple">' . $n;
    $cat_list .= '    <option value="0">[' . NO_CATEGORY . ']</option>' . $n;
    $selected = array();
    if (is_array($entry['categories'])) {
        if (count($entry['categories']) > 1) {
            $categoryselector_expanded = true;
        }

        foreach ($entry['categories'] as $cat) {
            $selected[] = $cat['categoryid'];
        }
    }

    if (count($selected) > 1 ||
          (isset($serendipity['POST']['categories']) && is_array($serendipity['POST']['categories']) && sizeof($serendipity['POST']['categories']) > 1)) {
        $categoryselector_expanded = true;
    }

    if (is_array($cats = serendipity_fetchCategories())) {
        $cat_list .= serendipity_generateCategoryList($cats, ($selected == array() ? array(0) : $selected), 1);
    }
    $cat_list .= '</select>' . $n;

    $hidden = '';
    foreach($hiddens as $key => $value) {
        $hidden .= '        <input type="hidden" name="' . $key . '" value="' . $value . '" />' . $n;
    }
    $hidden .= '        <input type="hidden" name="serendipity[id]" value="' . (isset($entry['id']) ? $entry['id'] : '') . '" />' . $n;
    $hidden .= '        <input type="hidden" name="serendipity[timestamp]" value="' . (isset($entry['timestamp']) ? $entry['timestamp'] : '') . '" />' . $n;
    $hidden .= '        <input type="hidden" name="serendipity[preview]" value="false" />';

    if (!empty($errMsg)) {
?>
        <span class="serendipity_msg_important"><?php echo $errMsg; ?></span>
<?php } ?>
        <form action="<?php echo $targetURL; ?>" method="post" <?php echo ($serendipity['XHTML11'] ? 'id' : 'name'); ?>="serendipityEntry" style="margin-top: 0px; margin-bottom: 0px; padding-top: 0px; padding-bottom: 0px">
        <?php echo $hidden; ?>

        <table class="serendipityEntryEdit" border="0">
            <tr>
                <td>
                   <b><?php echo TITLE; ?>:</b>
                </td>
                <td colspan="2">
                    <table width="100%" cellspacing="0" cellpadding="0" border="0">
                        <tr>
                            <td><input type="text" name="serendipity[title]" value="<?php echo isset($entry['title']) ? htmlspecialchars($entry['title']) : ''; ?>" size="72" /></td>
                            <td align="right"><select name="serendipity[isdraft]">
                                <?php if ($_SESSION['serendipityRightPublish']) { ?><option  value="false" <?php echo $draftP; ?>><?php echo PUBLISH; ?></option><?php } ?>
                                <option  value="true"  <?php echo $draftD; ?>><?php echo DRAFT; ?></option>
                                </select>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
<?php
        if (isset($serendipity['allowDateManipulation']) && $serendipity['allowDateManipulation']) {
?>
                <td>
                    <b><?php echo DATE; ?>:</b>
                </td>
                <td>
                    <input type="hidden" name="serendipity[chk_timestamp]" value="<?php echo (isset($entry['timestamp']) && $entry['timestamp'] > 0 ? $entry['timestamp'] : time()); ?>" />
                    <input type="text" name="serendipity[new_timestamp]" value="<?php echo date(DATE_FORMAT_2, (isset($entry['timestamp']) && $entry['timestamp'] > 0 ? $entry['timestamp'] : time())); ?>" />
                </td>
                <td align="right">
<?php
        } else {
?>
                <td align="right" colspan="3">
<?php
        }
?>
                    <a style="border:0; text-decoration: none" href="#" onclick="showItem('categoryselector'); return false" title="<?php echo TOGGLE_OPTION; ?>"><img src="<?php echo serendipity_getTemplateFile('img/plus.png') ?>" id="option_categoryselector" alt="+/-" border="0" /></a> <b><?php echo CATEGORY; ?>:</b> <?php echo $cat_list ; ?>
                    <script type="text/javascript" language="JavaScript">

                    function toggle_extended(setCookie) {
                        var textarea = document.getElementById('serendipity[extended]');
                        var button   = document.getElementById('option_extended');
                        var tools    = document.getElementById('tools_extended');
                        if ( textarea.style.display == 'none' ) {
                            textarea.style.display = '';
                            tools.style.display = '';
                            button.src = '<?php echo serendipity_getTemplateFile('img/minus.png') ?>';
                            if (setCookie == true) {
                                document.cookie = 'serendipity[toggle_extended]=true;';
                            }
                        } else {
                            textarea.style.display = 'none';
                            tools.style.display = 'none';
                            button.src = '<?php echo serendipity_getTemplateFile('img/plus.png') ?>';
                            if (setCookie == true) {
                                document.cookie = 'serendipity[toggle_extended]=;';
                            }
                        }
                    }

                    var selector_toggle  = new Array();
                    var selector_store   = new Array();
                    var selector_restore = new Array();

                    function showItem(id) {
                        var selected = 0;
                        if (document.getElementById) {
                            el = document.getElementById(id);
                            if (selector_toggle[id] && selector_toggle[id] == 'off') {
                                selector_restore[id] = new Array();
                                if (selector_store[id] > 0) {
                                    el.size = selector_store[id];
                                } else {
                                    el.size = 1
                                }

                                selector_toggle[id] = 'on';

                                /* Show a normal dropdown */
                                if (el.multiple) {
                                    el.multiple = false;
                                }

                                /* Hack to make sure that when the single dropdown is shown, don't have multiple selections */
                                last = 0;
                                for (i=0; i< el.options.length; i++) {
                                    if (el.options[i].selected == true) selected++;

                                    if (selected > 1) {
                                        /* If there is more than one selected, we reset all those to false
                                           This is because otherwise the label will say 'No Category', but the categories will still be selected */
                                        for (j=0; j < el.options.length; j++) {
                                            /* Save selection in array to later restore them */
                                            if (el.options[j].selected == true) {
                                                el.options[j].selected = false;
                                                selector_restore[id][j] = 'on';
                                                last = j;
                                            } else {
                                                selector_restore[id][j] = false;
                                            }
                                        }

                                        el.selectedIndex = last;
                                        break;
                                    }
                                }

                                if (el.selectedIndex == -1) el.selectedIndex = 0;

                                document.getElementById('option_' + id).src = '<?php echo serendipity_getTemplateFile('img/plus.png') ?>';
                            } else {
                                selector_store[id] = el.size;
                                el.size = <?php echo count($cats)+1; ?>;
                                selector_toggle[id] = 'off';

                                /* Show multiple items */
                                el.multiple = true;

                                /* Restore previously selected items? */
                                for (i = 0; i < el.options.length; i++) {
                                    if (selector_restore && selector_restore[id] && selector_restore[id][i] && selector_restore[id][i] == 'on') {
                                        val = el.options[i].value;
                                        if (el.options[i].selected != true) {
                                            el.options[i].selected = true;
                                            // [TODO] IE Bug: Don't ask me why, but this restoring only works in Internet Explorer if you put this:
                                            // alert('it doesnt matter what, just the alert is important');
                                        }
                                    }
                                }

                                document.getElementById('option_' + id).src = '<?php echo serendipity_getTemplateFile('img/minus.png') ?>';
                            }
                        }
                    }

                    selector_toggle['categoryselector'] = '<?php echo ($categoryselector_expanded ? 'on' : 'off'); ?>';
                    showItem('categoryselector');
                    </script>
                    </td>
            </tr>
            <tr>
<?php
    if (!$serendipity['wysiwyg']) {
?>
                <td colspan="2"><b><?php echo ENTRY_BODY; ?></b></td>
                <td align="right">
<?php
        /* Since the user has WYSIWYG editor disabled, we want to check if we should use the "better" non-WYSIWYG editor */
        if (!$serendipity['wysiwyg'] && eregi($serendipity['EditorBrowsers'], $_SERVER['HTTP_USER_AGENT']) ) {
?>
                        <input type="button" name="insI" value="I" accesskey="i" style="font-style: italic" onclick="wrapSelection(document.forms['serendipityEntry']['serendipity[body]'],'<i>','</i>')" />
                        <input type="button" name="insB" value="B" accesskey="i" style="font-weight: bold" onclick="wrapSelection(document.forms['serendipityEntry']['serendipity[body]'],'<b>','</b>')" />
                        <input type="button" name="insU" value="U" accesskey="u" style="text-decoration: underline;" onclick="wrapSelection(document.forms['serendipityEntry']['serendipity[body]'],'<u>','</u>')" />
                        <input type="button" name="insJ" value="img" accesskey="j" onclick="wrapInsImage(document.forms['serendipityEntry']['serendipity[body]'])" />
                        <input type="button" name="insImage" value="<?php echo MEDIA ; ?>" style="" onclick="window.open('serendipity_admin_image_selector.php?serendipity[textarea]=body', 'ImageSel', 'width=800,height=600,toolbar=no,scrollbars=1,scrollbars,resize=1,resizable=1');" />
                        <input type="button" name="insU" value="URL" accesskey="l" style="color: blue; text-decoration: underline;" onclick="wrapSelectionWithLink(document.forms['serendipityEntry']['serendipity[body]'])" />
<?php
        /* Do the "old" non-WYSIWYG editor */
        } elseif (!$serendipity['wysiwyg']) { ?>
                        <input type="button" value=" B " onclick="serendipity_insBasic(document.forms['serendipityEntry']['serendipity[body]'], 'b')">
                        <input type="button" value=" U " onclick="serendipity_insBasic(document.forms['serendipityEntry']['serendipity[body]'], 'u')">
                        <input type="button" value=" I " onclick="serendipity_insBasic(document.forms['serendipityEntry']['serendipity[body]'], 'i')">
                        <input type="button" value="<img>" onclick="serendipity_insImage(document.forms['serendipityEntry']['serendipity[body]'])">
                        <input type="button" value="<?php echo MEDIA; ?>" onclick="window.open('serendipity_admin_image_selector.php'?serendipity[textarea]=body, 'ImageSel', 'width=800,height=600,toolbar=no');">
                        <input type="button" value="Link" onclick="serendipity_insLink(document.forms['serendipityEntry']['serendipity[body]'])">
<?php   }
    } else {
?>
            <td colspan="3"><b><?php echo ENTRY_BODY; ?></b>

<?php } ?>
                </td>
            </tr>

            <tr>
                <td colspan="3">
                    <textarea style="width: 100%" name="serendipity[body]" id="serendipity[body]" cols="80" rows="20"><?php echo isset($entry['body']) ? htmlspecialchars($entry['body']) : ''; ?></textarea>
                </td>
            </tr>

            <tr>
                <td colspan="3">
                    <table width="100%" cellpadding="0" cellspacing="0">
                        <tr>
                            <td align="left">
                                <input id="checkbox_allow_comments" type="checkbox" name="serendipity[allow_comments]" value="true" <?php echo $allow_comments; ?> /><label for="checkbox_allow_comments"><?php echo COMMENTS_ENABLE; ?></label>
                            </td>
                            <td align="right" rowspan="2" valign="middle">
                                <input type="submit" value="- <?php echo PREVIEW; ?> -" style="font-weight: bold;" onclick="document.forms['serendipityEntry'].elements['serendipity[preview]'].value='true';" />
                                <input type="submit" value="- <?php echo SAVE; ?> -" style="font-weight: bold;" />
                            </td>

                        </tr>
                        <tr>
                            <td align="left">
                                <input id="checkbox_moderate_comments" type="checkbox" name="serendipity[moderate_comments]" value="true" <?php echo $moderate_comments; ?> /><label for="checkbox_moderate_comments"><?php echo COMMENTS_MODERATE; ?></label>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>

            <tr>
                <td colspan="2">
<?php if (!$serendipity['wysiwyg']) { ?>
                    <a style="border:0; text-decoration: none" href="#" onclick="toggle_extended(true); return false;" title="<?php echo TOGGLE_OPTION; ?>"><img src="<?php echo serendipity_getTemplateFile('img/plus.png') ?>" id="option_extended" alt="+/-" border="0" /></a>
<?php } ?> <b><?php echo EXTENDED_BODY; ?></b></td>
                <td align="right">
                <?php
if (!$serendipity['wysiwyg']) {
?>
                    <div id="tools_extended" style="display: none">
<?php
        /* Since the user has WYSIWYG editor disabled, we want to check if we should use the "better" non-WYSIWYG editor */
        if (eregi($serendipity['EditorBrowsers'], $_SERVER['HTTP_USER_AGENT']) ) {
?>
                        <input type="button" name="insI" value="I" accesskey="i" style="font-style: italic" onclick="wrapSelection(document.forms['serendipityEntry']['serendipity[extended]'],'<i>','</i>')" />
                        <input type="button" name="insB" value="B" accesskey="i" style="font-weight: bold" onclick="wrapSelection(document.forms['serendipityEntry']['serendipity[extended]'],'<b>','</b>')" />
                        <input type="button" name="insU" value="U" accesskey="u" style="text-decoration: underline;" onclick="wrapSelection(document.forms['serendipityEntry']['serendipity[extended]'],'<u>','</u>')" />
                        <input type="button" name="insJ" value="img" accesskey="j" onclick="wrapInsImage(document.forms['serendipityEntry']['serendipity[extended]'])" />
                        <input type="button" name="insImage" value="<?php echo IMAGE ; ?>" style="" onclick="window.open('serendipity_admin_image_selector.php?serendipity[textarea]=extended', 'ImageSel', 'width=800,height=600,toolbar=no,scrollbars=1,scrollbars,resize=1,resizable=1');" />
                        <input type="button" name="insU" value="URL" accesskey="l" style="color: blue; text-decoration: underline;" onclick="wrapSelectionWithLink(document.forms['serendipityEntry']['serendipity[extended]'])" />
<?php
        /* Do the "old" non-WYSIWYG editor */
        } else { ?>
                        <input type="button" value=" B " onclick="serendipity_insBasic(document.forms['serendipityEntry']['serendipity[extended]'], 'b')">
                        <input type="button" value=" U " onclick="serendipity_insBasic(document.forms['serendipityEntry']['serendipity[extended]'], 'u')">
                        <input type="button" value=" I " onclick="serendipity_insBasic(document.forms['serendipityEntry']['serendipity[extended]'], 'i')">
                        <input type="button" value="<img>" onclick="serendipity_insImage(document.forms['serendipityEntry']['serendipity[extended]'])">
                        <input type="button" value="<?php echo IMAGE; ?>" onclick="window.open('serendipity_admin_image_selector.php?serendipity[textarea]=extended', 'ImageSel', 'width=800,height=600,toolbar=no');">
                        <input type="button" value="Link" onclick="serendipity_insLink(document.forms['serendipityEntry']['serendipity[extended]'])">
<?php
        }
?>
                    </div>
<?php } ?>
               </td>
            </tr>

            <tr>
                <td colspan="3">
                    <textarea style="width: 100%;<?php echo (!$serendipity['wysiwyg']) ? 'display: none;' : '' ?>" name="serendipity[extended]" id="serendipity[extended]" cols="80" rows="20"><?php echo isset($entry['extended']) ? htmlspecialchars($entry['extended']) : ''; ?></textarea>
                </td>
            </tr>

            <tr>
                <td colspan="3">
                    <br />
                    <fieldset>
                        <legend><b><?php echo ADVANCED_OPTIONS; ?></b></legend>
<?php
    serendipity_plugin_api::hook_event('backend_display', $entry);
?>
                    </fieldset>
                </td>
            </tr>
        </table>
    </form>
<?php
    if ((!empty($entry['extended']) || !empty($serendipity['COOKIE']['toggle_extended'])) && !$serendipity['wysiwyg']) {
?>
    <script type="text/javascript" language="JavaScript">
                    toggle_extended();
    </script>
<?php } ?>
<?php
    if ($serendipity['wysiwyg']) {
        serendipity_emit_htmlarea_code('serendipity[body]', 'body');
        serendipity_emit_htmlarea_code('serendipity[extended]', 'extended');
    }

    echo '    <script type="text/javascript" language="JavaScript" src="serendipity_define.js.php"></script>';
    echo '    <script type="text/javascript" language="JavaScript" src="serendipity_editor.js"></script>';
}

function serendipity_authenticate_author($username = '', $password = '', $is_md5 = false) {
    global $serendipity;

    if (isset($_SESSION['serendipityUser']) && isset($_SESSION['serendipityPassword']) && isset($_SESSION['serendipityAuthedUser']) && $_SESSION['serendipityAuthedUser'] == true) {
        $username = $_SESSION['serendipityUser'];
        $password = $_SESSION['serendipityPassword'];
        // For safety reasons when multiple blogs are installed on the same host, we need to check the current author each time to not let him log into a different blog with the same sessiondata
        $is_md5 = true;
    }

    if ($username != '') {
        if ($is_md5 === false && !empty($password)) {
            $password = md5($password);
        }

        $query = "SELECT DISTINCT
                    email, authorid, userlevel, right_publish
                  FROM
                    $serendipity[dbPrefix]authors
                  WHERE
                    username   = '" . serendipity_db_escape_string($username) . "'
                  AND password = '" . serendipity_db_escape_string($password) . "'";
        $row = serendipity_db_query($query, true, 'assoc');

        if (is_array($row)) {
            $_SESSION['serendipityUser']        = $serendipity['serendipityUser']         = $username;
            $_SESSION['serendipityPassword']    = $serendipity['serendipityPassword']     = $password;
            $_SESSION['serendipityEmail']       = $serendipity['serendipityEmail']        = $row['email'];
            $_SESSION['serendipityAuthorid']    = $serendipity['authorid']                = $row['authorid'];
            $_SESSION['serendipityUserlevel']   = $serendipity['serendipityUserlevel']    = $row['userlevel'];
            $_SESSION['serendipityAuthedUser']  = $serendipity['serendipityAuthedUser']   = true;
            $_SESSION['serendipityRightPublish']= $serendipity['serendipityRightPublish'] = $row['right_publish'];
            serendipity_load_configuration($serendipity['authorid']);
            return true;
        } else {
            $_SESSION['serendipityAuthedUser'] = false;
            @session_destroy();
        }
    }

    return false;
}

function serendipity_track_referrer($entry = 0) {
    global $serendipity;

    if (isset($_SERVER['HTTP_REFERER'])) {
        if (stristr($_SERVER['HTTP_REFERER'], $serendipity['baseURL']) !== false) {
            return;
        }

        if (!isset($serendipity['_blockReferer']) || !is_array($serendipity['_blockReferer'])) {
            // Only generate an array once per call
            $serendipity['_blockReferer'] = array();
            $serendipity['_blockReferer'] = @explode(';', $serendipity['blockReferer']);
        }

        $url_parts  = parse_url($_SERVER['HTTP_REFERER']);
        $host_parts = explode('.', $url_parts['host']);
        if (!$url_parts['host'] ||
            strstr($url_parts['host'], $_SERVER['SERVER_NAME'])) {
            return;
        }

        foreach($serendipity['_blockReferer'] AS $idx => $hostname) {
            if (@strstr($url_parts['host'], $hostname)) {
                return;
            }
        }

        if (rand(0, 100) < 1) {
            serendipity_track_referrer_gc();
        }

        if(preg_match('/^mysqli?/', $serendipity['dbType'])) {
            $interval = 900;
        } else {
            $interval = "interval '900'";
        }

        $suppressq = "SELECT count(1)
                      FROM $serendipity[dbPrefix]suppress
                      WHERE ip = '" . serendipity_db_escape_string($_SERVER['REMOTE_ADDR']) . "'
                      AND scheme = '" . serendipity_db_escape_string($url_parts['scheme']) . "'
                      AND port = '" . serendipity_db_escape_string($url_parts['port']) . "'
                      AND host = '" . serendipity_db_escape_string($url_parts['host']) . "'
                      AND path = '" . serendipity_db_escape_string($url_parts['path']) . "'
                      AND query = '" . serendipity_db_escape_string($url_parts['query']) . "'
                      AND last > now() - $interval";

        $suppressp = "DELETE FROM $serendipity[dbPrefix]suppress
                      WHERE ip = '" . serendipity_db_escape_string($_SERVER['REMOTE_ADDR']) . "'
                      AND scheme = '" . serendipity_db_escape_string($url_parts['scheme']) . "'
                      AND host = '" . serendipity_db_escape_string($url_parts['host']) . "'
                      AND port = '" . serendipity_db_escape_string($url_parts['port']) . "'
                      AND query = '" . serendipity_db_escape_string($url_parts['query']) . "'
                      AND path = '" . serendipity_db_escape_string($url_parts['path']) . "'";
        $suppressu = "INSERT INTO $serendipity[dbPrefix]suppress
                      (ip, last, scheme, host, port, path, query)
                      VALUES (
                      '" . serendipity_db_escape_string($_SERVER['REMOTE_ADDR']) . "',
                      now(),
                      '" . serendipity_db_escape_string($url_parts['scheme']) . "',
                      '" . serendipity_db_escape_string($url_parts['host']) . "',
                      '" . serendipity_db_escape_string($url_parts['port']) . "',
                      '" . serendipity_db_escape_string($url_parts['path']) . "',
                      '" . serendipity_db_escape_string($url_parts['query']) . "'
                      )";

        $count = serendipity_db_query($suppressq, true);

        if ($count[0] == 0) {
            serendipity_db_query($suppressu);
            return;
        }

        serendipity_db_query($suppressp);
        serendipity_db_query($suppressu);

        serendipity_track_url('referrers', $_SERVER['HTTP_REFERER'], $entry);
    }
}

function serendipity_track_referrer_gc() {
    global $serendipity;

    if (preg_match('/^mysqli?/', $serendipity['dbType'])) {
        $interval = 900;
    } else {
        $interval = "interval '900'";
    }

    $gc = "DELETE FROM $serendipity[dbPrefix]suppress where last < now() - $interval";
    serendipity_db_query($gc);
}

function serendipity_track_url($list, $url, $entry_id = 0) {
    global $serendipity;

    $url_parts = parse_url($url);

    serendipity_db_query(
      @sprintf(
        "UPDATE %s%s
            SET count = count + 1
          WHERE scheme = '%s'
            AND host   = '%s'
            AND port   = '%s'
            AND path   = '%s'
            AND query  = '%s'
            AND day    = '%s'
            %s",

        $serendipity['dbPrefix'],
        $list,
        serendipity_db_escape_string($url_parts['scheme']),
        serendipity_db_escape_string($url_parts['host']),
        serendipity_db_escape_string($url_parts['port']),
        serendipity_db_escape_string($url_parts['path']),
        serendipity_db_escape_string($url_parts['query']),
        date('Y-m-d'),
        ($entry_id != 0) ? "AND entry_id = '". (int)$entry_id ."'" : ''
      )
    );

    if (serendipity_db_affected_rows() == 0) {
        serendipity_db_query(
          sprintf(
            "INSERT INTO %s%s
                    (entry_id, day, count, scheme, host, port, path, query)
             VALUES (%d, '%s', 1, '%s', '%s', '%s', '%s', '%s')",

            $serendipity['dbPrefix'],
            $list,
            (int)$entry_id,
            date('Y-m-d'),
            serendipity_db_escape_string($url_parts['scheme']),
            serendipity_db_escape_string($url_parts['host']),
            serendipity_db_escape_string($url_parts['port']),
            serendipity_db_escape_string($url_parts['path']),
            serendipity_db_escape_string($url_parts['query'])
          )
        );
    }
}

function serendipity_displayTopReferrers($limit = 10, $use_links = true) {
    serendipity_displayTopUrlList('referrers', $limit, $use_links);
}

function serendipity_displayTopExits($limit = 10, $use_links = true) {
    serendipity_displayTopUrlList('exits', $limit, $use_links);
}

function serendipity_displayTopUrlList($list, $limit, $use_links = true) {
    global $serendipity;

    if ($limit){
        $limit = serendipity_db_limit_sql($limit);
    }

    /* HACK */
    if (preg_match('/^mysqli?/', $serendipity['dbType'])) {
        /* Nonportable SQL due to MySQL date functions,
         * but produces rolling 7 day totals, which is more
         * interesting
         */
        $query = "SELECT scheme, host, SUM(count) AS total
                  FROM {$serendipity['dbPrefix']}$list
                  WHERE day > date_sub(current_date, interval 7 day)
                  GROUP BY host
                  ORDER BY total DESC, host
                  $limit";
    } else {
        /* Portable version of the same query */
        $query = "SELECT scheme, host, SUM(count) AS total
                  FROM {$serendipity['dbPrefix']}$list
                  GROUP BY scheme, host
                  ORDER BY total DESC, host
                  $limit";
    }

    $rows = serendipity_db_query($query);
    echo "<span class='serendipityReferer'>";
    if (is_array($rows)) {
        foreach ($rows as $row) {
            if ($use_links) {
                printf(
                    '<a href="%1$s://%2$s" title="%2$s" >%2$s</a> (%3$s)<br />',
                    $row['scheme'],
                    $row['host'],
                    $row['total']
                );
            } else {
                printf(
                    '%1$s (%2$s)<br />',
                    $row['host'],
                    $row['total']
                );
            }
        }
    }
    echo "</span>";
}

function serendipity_emit_htmlarea_code($item, $jsname)
{
    static $init = false;
    global $serendipity;

    if (isset ($serendipity['wysiwyg']) && $serendipity['wysiwyg']) {

        if (!$init) {
?>
    <script type="text/javascript">
        _editor_url = "<?php echo $serendipity['serendipityHTTPPath'] . 'htmlarea/'; ?>";
        _editor_lang = "<?php echo WYSIWYG_LANG; ?>";
        var editorref = '';
    </script>
    <script type="text/javascript" src="htmlarea/htmlarea.js"></script>
    <script type="text/javascript" src="htmlarea/dialog.js"></script>
    <style  type="text/css">@import url(htmlarea/htmlarea.css);</style>
<?php
        }

    $csscode = str_replace(
                 array(
                   "\n",
                   "'",
                   "\r"
                 ),

                 array(
                   '\n',
                   "\'",
                   ""
                 ),

                 file_get_contents(serendipity_getTemplateFile('htmlarea.css', 'serendipityPath'))
    );
?>
    <script type="text/javascript">
    // IF you want to enable HTMLArea's spellchecker, download the SpellChecker plugin from the HTMLArea homepage
    // (http://www.sourceforge.net/projects/itools-htmlarea) and uncomment the lines suffixed with ' // [SPELLCHECK]'
    // Note that the SpellChecker is a CGI-based application which needs setup in your Apache host ("Options +CGIExec")
    // Thanks to Randall for pointing this out!

    // HTMLArea.loadPlugin("SpellChecker"); // [SPELLCHECK]
    var editor<?php echo $jsname; ?> = null; var config<?php echo $jsname; ?> = null;
    function Spawn<?php echo $jsname; ?>() {
        var editor<?php echo $jsname; ?>    = new HTMLArea("<?php echo $item; ?>");
        var config<?php echo $jsname; ?>    = editor<?php echo $jsname; ?>.config;
        config<?php echo $jsname; ?>.registerButton('image_selector', '<?PHP echo MANAGE_IMAGES; ?>', 'htmlarea/images/ed_s9yimage.gif', false,
            function(editor, id) {
                window.open('serendipity_admin_image_selector.php?serendipity[textarea]=<?php echo $jsname; ?>', 'ImageSel', 'width=800,height=600,toolbar=no,scrollbars=1,scrollbars,resize=1,resizable=1');
                editorref = editor<?php echo $jsname; ?>;
            }
        );
        config<?php echo $jsname; ?>.toolbar.push([ "image_selector"]);
        config<?php echo $jsname; ?>.cssFile = '<?php echo $csscode; ?>';
        config<?php echo $jsname; ?>.toolbar = [
            [ "fontname", "space",
              "fontsize", "space",
              "formatblock", "space",
              "bold", "italic", "underline", "strikethrough", "separator",
              "subscript", "superscript", "separator",
              "copy", "cut", "paste", "space", "undo", "redo" ],

            [ "justifyleft", "justifycenter", "justifyright", "justifyfull", "separator",
              "lefttoright", "righttoleft", "separator",
              "insertorderedlist", "insertunorderedlist", "outdent", "indent", "separator",
              "forecolor", "hilitecolor", "separator",
              "inserthorizontalrule", "createlink", "insertimage", "image_selector", "inserttable", "htmlmode", "separator",
              "popupeditor", "separator", "showhelp", "about" ]
        ];
        // editor<?php echo $jsname; ?>.registerPlugin(SpellChecker);  // [SPELLCHECK]
        editor<?php echo $jsname; ?>.generate();
        editor<?php echo $jsname; ?>._textArea.className = 'serendipity_entry';
    }
    </script>
<?php
    }

    $init = true;
}

function serendipity_updateEntryCategories($postid, $categories) {
    global $serendipity;

    if (!$postid || !$categories) {
        return;
    }

    $query = "DELETE FROM $serendipity[dbPrefix]entrycat WHERE entryid = " . (int)$postid;
    serendipity_db_query($query);

    if (!is_array($categories)) {
        $categories = array(0 => $categories);
    }

    foreach($categories AS $idx => $cat) {
        $query = "INSERT INTO $serendipity[dbPrefix]entrycat (categoryid, entryid) VALUES (" . (int)$cat . ", " . (int)$postid . ")";
        serendipity_db_query($query);
    }
}

/*
* Amount of posts for given year & month
*/
function serendipity_postAmount($year, $month) {
    global $serendipity;

    $s = mktime(0, 0, 0, $month, 1, $year);
    $e = mktime(23, 59, 59, $month, date('t', $s), $year);
    $querystring = "SELECT count(id) FROM {$serendipity['dbPrefix']}entries WHERE isdraft = 'false'  AND timestamp >= $s AND timestamp <= $e";
    $query = serendipity_db_query($querystring);

    return $query[0][0];
}

/*
* Print the archive
*/
function serendipity_printArchives() {
    global $serendipity;

    echo '<div class="serendipity_date">' . ARCHIVES . '</div>';

    $f = serendipity_db_query("SELECT timestamp FROM {$serendipity['dbPrefix']}entries ORDER BY timestamp ASC LIMIT 1");
    $lastYear = date('Y', $f[0][0]);
    $lastMonth= date('m', $f[0]);
    $currYear = date('Y');
    $max = 0;

    while($currYear >= $lastYear) {
         // echo "<h2>$currYear</h2><div class='serendipity_entry'>";
         for($x=1; $x<13; $x++) {
            $entries = serendipity_postAmount($currYear, $x);
            if ($entries > 0) {
                    $a = "<a href='". serendipity_archiveDateUrl($currYear . sprintf('%02s', $x)) . '\'>';
                    $b = '</a>';
                    $c = "<a href='". serendipity_archiveDateUrl($currYear . sprintf('%02s', $x), true) . '\'>';
                    $d = "<a href='". serendipity_archiveDateUrl($currYear . sprintf('%02s', $x)) . '\'>';
            } else {
                $a = $c = '<span style="color: #CDCDCD">';
                $b = $d = '</span>';
            }

            if ($x <= date('m') || $currYear < date('Y')) {
                $out[$currYear][$x] = array($entries, $a, $b, $c, $d);
            }

            if ($entries > $max) {
                $max = $entries;
            }
         }
         // echo "</div>";
         $currYear--;
    }

    if (!$max) {
        return;
    }

    $barwidth = 40;
    $fac = $barwidth/$max;
?>
<table cellspacing="0" width="500">
<?php
    foreach($out as $year => $months) {
?>
    <tr>
        <td colspan="6"><h2><?php echo $year; ?></h2></td>
    </tr>
<?php
        for($y=12; $y>0; $y--) {
            if (isset($months[$y]) && $months[$y]) {
                $time = mktime(0,0,0, $y+1, 0, $year);
?>
    <tr>
        <td>
            <img src="<?php echo serendipity_getTemplateFile('img/graph_bar_horisontal.png') ?>"  height="10" width="<?php echo ceil($months[$y][0]*$fac); ?>"             hspace="0" vspace="0" alt="" /><img src="<?php echo serendipity_getTemplateFile('img/blank.png') ?>" height="10" width="<?php echo ($barwidth-ceil($months[$y][0]*$fac)); ?>" hspace="0" vspace="0" alt="" />
        </td>
        <td>
            <?php echo $months[$y][1] . serendipity_formatTime('%B', $time) . $months[$y][2]; ?>
        </td>
        <td>
            <?php echo $months[$y][0] . ' ' . ENTRIES; ?>
        </td>

        <td>
                (<?php echo $months[$y][1] . VIEW_FULL . $months[$y][2]; ?>)
        </td>

        <td>
            (<?php echo $months[$y][3] . VIEW_TOPICS . $months[$y][4]; ?>)
        </td>
    </tr>
<?php
            }
        }
    }
?>
</table>
<?php
}

function serendipity_xhtml_target($target)
{
    global $serendipity;

    if ($serendipity['enablePopup'] != true)
        return "";

    if ($serendipity['XHTML11']) {
        return ' onclick="window.open(this.href, \'target' . time() . '\'); return false;" ';
    } else {
        return ' target="' . $target . '" ';
    }
}

function serendipity_discover_rss($name, $ext, $default = '2.0') {
    if ($name == 'atom') {
        $ver = 'atom0.3';
    } else {
        switch ($ext) {
        case 'rss':
            $ver = '0.91';
            break;
        case 'rss2':
        default:
            $ver = $default;
            break;
        }
    }

    return $ver;
}

function serendipity_load_configuration($author = null) {
    global $serendipity;

    if (!empty($author)) {
        // Replace default configuration directives with user-relevant data
        $rows = serendipity_db_query("SELECT name,value
                                        FROM {$serendipity['dbPrefix']}config
                                        WHERE authorid = '". (int)$author ."'");
    } else {
        // Only get default variables, user-independent (frontend)
        $rows = serendipity_db_query("SELECT name,value
                                        FROM {$serendipity['dbPrefix']}config
                                        WHERE authorid = 0");
    }

    if (is_array($rows)) {
        foreach ($rows as $row) {
            // Convert 'true' and 'false' into booleans
            $serendipity[$row['name']] = serendipity_get_bool($row['value']);
        }
    }
}

define("serendipity_FUNCTIONS_LOADED", true);
/* vim: set sts=4 ts=4 expandtab : */
?>
