<?php # $Id: serendipity_functions_config.inc.php,v 1.11 2004/09/14 12:56:08 garvinhicking Exp $

function serendipity_set_config_var($name, $val, $authorid = 0) {
    global $serendipity;

        serendipity_db_query("DELETE FROM {$serendipity['dbPrefix']}config where name='" . serendipity_db_escape_string($name) . "' AND authorid = " . (int)$authorid);
        $r = serendipity_db_insert('config', array('name' => $name, 'value' => $val, 'authorid' => $authorid));
        $serendipity[$name] = $val;
        if (is_string($r)) {
            echo $r;
        }
}

function serendipity_get_config_var($name, $defval = false, $empty = false) {
    global $serendipity;
        if (isset($serendipity[$name])) {
            if ($empty && gettype($serendipity[$name]) == 'string' && $serendipity[$name] === '') {
                return $defval;
            } else {
                return $serendipity[$name];
            }
        } else {
            return $defval;
        }
}

function serendipity_get_user_var($name, $authorid, $default) {
    global $serendipity;

    $r = serendipity_db_query("SELECT $name FROM {$serendipity['dbPrefix']}authors WHERE authorid = " . (int)$authorid, true);

    if (is_array($r)) {
        return $r[0];
    } else {
        return $default;
    }
}

function serendipity_set_user_var($name, $val, $authorid, $copy_to_s9y = true) {
    global $serendipity;

    // When inserting a DB value, this array maps the new values to the corresponding s9y variables
    static $user_map_array = array(
        'username'  => 'serendipityUser',
        'email'     => 'serendipityEmail',
        'userlevel' => 'serendipityUserlevel'
    );

    // Special case for inserting a password
    switch($name) {
        case 'password':
            if (empty($val)) {
                return;
            }

            $val = md5($val);
            $copy_to_s9y = false;
            break;

        case 'right_publish':
        case 'mail_comments':
        case 'mail_trackbacks':
            $val = (serendipity_db_bool($val) ? 1 : '0');
            break;
    }

    serendipity_db_query("UPDATE {$serendipity['dbPrefix']}authors SET $name = '" . serendipity_db_escape_string($val) . "' WHERE authorid = " . (int)$authorid);

    if ($copy_to_s9y) {
        if (isset($user_map_array[$name])) {
            $key = $user_map_array[$name];
        } else {
            $key = 'serendipity' . ucfirst($name);
        }

        $_SESSION[$key] = $serendipity[$key] = $val;
    }
}

function serendipity_getTemplateFile($file, $key = 'serendipityHTTPPath') {
    global $serendipity;

    $directories = array(
      (isset($serendipity['template']) ? $serendipity['template'] . '/' : ''),
      $serendipity['defaultTemplate'] .'/',
      'default/'
    );

    foreach ($directories as $directory) {
        $templateFile = $serendipity['templatePath'] . $directory . $file;

        if (file_exists($serendipity['serendipityPath'] . $templateFile)) {
            return $serendipity[$key] . $templateFile;
        }
    }
    return false;
}

/* vim: set sts=4 ts=4 expandtab : */
?>
