<?php # $Id: serendipity_functions_images.inc.php,v 1.37 2004/09/14 12:56:08 garvinhicking Exp $

/**
* Get a list of images
**/
function serendipity_fetchImagesFromDatabase($start=0, $limit=0, &$total, $order = false, $ordermode = false, $directory = '') {
    global $serendipity;

    $orderfields = serendipity_getImageFields();
    if (empty($order) || !isset($orderfields[$order])) {
        $order = 'date';
    }

    if (empty($ordermode) || ($ordermode != 'DESC' && $ordermode != 'ASC')) {
        $ordermode = 'DESC';
    }

    if ($limit != 0) {
        $limitsql = serendipity_db_limit_sql(serendipity_db_limit($start, $limit));
    }

    if (!empty($directory)) {
        $directorysql = ' WHERE path LIKE \'' . serendipity_db_escape_string($directory) . '%\' ';
    }

    $query = "SELECT i.*, a.username AS authorname FROM {$serendipity['dbPrefix']}images AS i LEFT OUTER JOIN {$serendipity['dbPrefix']}authors AS a ON i.authorid = a.authorid $directorysql ORDER BY $order $ordermode $limitsql";
    $rs = serendipity_db_query($query, false, 'assoc');
    if (!is_array($rs)) {
        return array();
    }

    $total_query = "SELECT count(i.id) FROM {$serendipity['dbPrefix']}images AS i LEFT OUTER JOIN {$serendipity['dbPrefix']}authors AS a on i.authorid = a.authorid";
    $total_rs = serendipity_db_query($total_query, true, 'num');
    if (is_array($total_rs)) {
        $total = $total_rs[0];
    }

    return $rs;
}

function serendipity_fetchImageFromDatabase($id) {
    global $serendipity;
    $rs = serendipity_db_query("SELECT * FROM {$serendipity['dbPrefix']}images WHERE id = ". (int)$id, true, 'assoc');
    return $rs;
}

function serendipity_updateImageInDatabase($updates, $id) {
    global $serendipity;

    $admin = '';
    if ($serendipity['serendipityUserlevel'] < USERLEVEL_CHIEF) {
        $admin = ' AND (authorid = ' . $serendipity['authorid'] . ' OR authorid = 0)';
    }

    $i=0;
    if (sizeof($updates) > 0) {
        foreach ($updates as $k => $v) {
            $q[] = $k ." = '" . serendipity_db_escape_string($v) . "'";
        }
        serendipity_db_query("UPDATE {$serendipity['dbPrefix']}images SET ". implode($q, ',') ." WHERE id = " . (int)$id . " $admin");
        $i++;
    }
    return $i;
}

function serendipity_deleteImage($id) {
    global $serendipity;
    $file   = serendipity_fetchImageFromDatabase($id);
    $dFile  = $file['path'] . $file['name'] .'.'. $file['extension'];
    $dThumb = $file['path'] . $file['name'] .'.'. $file['thumbnail_name'] .'.'. $file['extension'];

    $admin = '';
    if ($serendipity['serendipityUserlevel'] < USERLEVEL_CHIEF && $file['authorid'] != '0' && $file['authorid'] != $serendipity['authorid']) {
        // A non-admin user may not delete private files from other users.
        return;
    }

    if (file_exists($serendipity['serendipityPath'] . $serendipity['uploadPath'] . $dFile)) {
        if (@unlink($serendipity['serendipityPath'] . $serendipity['uploadPath'] . $dFile)) {
            printf(DELETE_FILE . '<br />', $dFile);
        } else {
            printf(DELETE_FILE_FAIL . '<br />', $dFile);
        }

        if (@unlink($serendipity['serendipityPath'] . $serendipity['uploadPath'] . $dThumb)) {
            printf(DELETE_THUMBNAIL . '<br />', $dThumb);
        }
    } else {
        printf(FILE_NOT_FOUND . '<br />', $dFile);
    }
    serendipity_db_query("DELETE FROM {$serendipity['dbPrefix']}images WHERE id = ". (int)$id);
}

/**
* Get a list of images
**/
function serendipity_fetchImages($group = false, $start = 0, $end = 20, $images = '', $odir = '') {
    global $serendipity;

    // Open directory
    $basedir = $serendipity['serendipityPath'] . $serendipity['uploadPath'];
    $images = array();
    if ($dir = @opendir($basedir . $odir)) {
        while(false !== ($f = readdir($dir))) {
            if ($f != '.' && $f != '..' && strpos($f, $serendipity['thumbSuffix']) === false) {
                $cdir = ($odir != '' ? $odir . DIRECTORY_SEPARATOR : '');
                if (is_dir($basedir . $odir . DIRECTORY_SEPARATOR . $f)) {
                    $temp = serendipity_fetchImages($group, $start, $end, $images, $cdir . $f);
                    foreach($temp AS $tkey => $tval) {
                        array_push($images, $tval);
                    }
                } else {
                    array_push($images, $cdir . $f);
                }
            }
        }
    }
    natsort($images);

    /* BC */
    $serendipity['imageList'] = $images;
    return $images;
}

function serendipity_insertImageInDatabase($filename, $extension, $mimetype, $filesize, $width, $height, $thumbnail, $date, $authorid, $directory) {
    global $serendipity;

    if (empty($width)) {
        $width = 0;
    }

    if (empty($height)) {
        $height = 0;
    }

    $query = sprintf(
      "INSERT INTO {$serendipity['dbPrefix']}images (
                    name,
                    extension,
                    mime,
                    size,
                    dimensions_width,
                    dimensions_height,
                    thumbnail_name,
                    date,
                    authorid,
                    path
                   ) VALUES (
                    '%s',
                    '%s',
                    '%s',
                    %s,
                    %s,
                    %s,
                    '%s',
                    %s,
                    %s,
                    '%s'
                   )",
      serendipity_db_escape_string($filename),
      serendipity_db_escape_string($extension),
      serendipity_db_escape_string($mimetype),
      (int)$filesize,
      (int)$width,
      (int)$height,
      serendipity_db_escape_string($thumbnail),
      (int)$date,
      (int)$authorid,
      serendipity_db_escape_string($directory)
    );

    $sql = serendipity_db_query($query);
    if (is_string($sql)) {
        echo $query . '<br />';
        echo $sql . '<br />';
    }
    return true;
}


/**
* Generate a thumbnail
**/
function serendipity_makeThumbnail($file, $size = false, $authorid = '0', $directory = '', $insertMode = true) {
    global $serendipity;

    if ($size === false) {
        $size = $serendipity['thumbSize'];
    }

    // Calculate name of thumbnail
    $t       = serendipity_parseFileName($file);
    $f       = $t[0];
    $suf     = $t[1];
    $ft_mime = serendipity_guessMime($suf);

    $infile  = $serendipity['serendipityPath'] . $serendipity['uploadPath'] . $directory . $file;
    $outfile = $serendipity['serendipityPath'] . $serendipity['uploadPath'] . $directory . $f . '.' . $serendipity['thumbSuffix'] . '.' . $suf;
    $fdim    = @serendipity_getimagesize($infile, $ft_mime);

    if (isset($fdim['noimage'])) {
        $r = array(0, 0);
    } else {
        if ($serendipity['magick'] !== true) {
            $r = serendipity_resize_image_gd($infile, $outfile, $size);
        } else {
                /*if ($serendipity["dim"] == "height") $newSize = "*x".$serendipity["thumbSize"];
                else $newSize = $serendipity["thumbSize"]."x*"; */
            $newSize = $size . 'x' . $size;
            $r = array($size, $size);
            $cmd     = $serendipity['convert'] . " -antialias -scale $newSize $infile $outfile  2>&1";
            $res     = `$cmd`;
        }
    }

    /* Lets assume we are all done, now we add the image to the image database */
    if ($insertMode) {
        serendipity_insertImageInDatabase($f, $suf, $fdim['mime'], filesize($infile), $fdim[0], $fdim[1], $serendipity['thumbSuffix'], time(), $authorid, $directory);
    }

    return $r;
}

/**
*  Scale an image (ignoring proportions)
**/
function serendipity_scaleImg($id, $width, $height) {
    global $serendipity;

    $file = serendipity_fetchImageFromDatabase($id);

    $admin = '';
    if ($serendipity['serendipityUserlevel'] < USERLEVEL_CHIEF && $file['authorid'] != '0' && $file['authorid'] != $serendipity['authorid']) {
        // A non-admin user may not delete private files from other users.
        return;
    }

    $infile = $outfile = $serendipity['serendipityPath'] . $serendipity['uploadPath'] . $file['path'] . $file['name'] . '.' . $file['extension'];

    if ($serendipity['magick'] !== true) {
        serendipity_resize_image_gd($infile, $outfile, $width, $height);
    }

    $cmd = $serendipity['convert'] . ' -scale ' .  $width . 'x' . $height . ' ' . $infile . ' ' . $outfile;
    $res = `$cmd`;

    serendipity_updateImageInDatabase(array('dimensions_width' => $width, 'dimensions_height' => $height), $id);
    return;
}

/**
* Creates thumbnails for all images in the upload dir
**/
function serendipity_generateThumbs() {
    global $serendipity;

    $i=0;
    $serendipity['imageList'] = serendipity_fetchImagesFromDatabase(0, 0, $total);

    foreach ($serendipity['imageList'] as $k => $file) {
        $is_image = (0 === strpos(strtolower($file['mime']), "image/"));

        if ($is_image) {
            $update   = false;
            $filename = $file['path'] . $file['name'] .'.'. $file['extension'];
            $ffull    = $serendipity['serendipityPath'] . $serendipity['uploadPath'] . $filename;

            if (!file_exists($ffull)) {
                serendipity_deleteImage($file['id']);
                continue;
            }

            if (empty($file['thumbnail_name'])) {
                $file['thumbnail_name'] = $serendipity['thumbSuffix'];
            }

            $oldThumb = $serendipity['serendipityPath'] . $serendipity['uploadPath'] . $file['path'] . $file['name'] . '.' . $file['thumbnail_name'] . '.' . $file['extension'];
            $newThumb = $serendipity['serendipityPath'] . $serendipity['uploadPath'] . $file['path'] . $file['name'] . '.' . $serendipity['thumbSuffix'] . '.' . $file['extension'];
            $fdim = @getimagesize($ffull);

            if (!file_exists($oldThumb) && !file_exists($newThumb) && ($fdim[0] > $serendipity['thumbSize'] || $fdim[1] > $serendipity['thumbSize'])) {
                $returnsize = serendipity_makeThumbnail($filename, false, $file['authorid'], '', false);
                printf(RESIZE_BLAHBLAH, $filename . ': ' . $returnsize[0] . 'x' . $returnsize[1]);
                if (!file_exists($newThumb)) {
                    printf('<span class="serendipity_msg_important">' . THUMBNAIL_FAILED_COPY . '</span><br />', $filename);
                } else {
                    $update = true;
                }
            } elseif (!file_exists($oldThumb) && !file_exists($newThumb) && $fdim[0] <= $serendipity['thumbSize'] && $fdim[1] <= $serendipity['thumbSize']) {
                $res = @copy($ffull, $newThumb);
                if (@$res === true) {
                    printf(THUMBNAIL_USING_OWN . '<br />', $filename);
                    $update = true;
                } else {
                    printf('<span class="serendipity_msg_important">' . THUMBNAIL_FAILED_COPY . '</span><br />', $filename);
                }
            }

            if ($update) {
                $i++;
                $updates  = array(
                  'thumbnail_name' => $serendipity['thumbSuffix']
                );
                serendipity_updateImageInDatabase($updates, $file['id']);
            }
        } else {
            // Currently, non-image files have no thumbnail.
        }
    }

    return $i;
}

function serendipity_guessMime($extension) {
    $mime = '';
    switch (strtolower($extension)) {
        case 'jpg':
        case 'jpeg':
            $mime = 'image/jpeg';
        break;

        case 'aiff':
        case 'aif':
            $mime = 'audio/x-aiff';
            break;

        case 'gif':
            $mime = 'image/gif';
        break;

        case 'png':
            $mime = 'image/png';
        break;

        case 'pdf':
            $mime = 'application/pdf';
            break;

        case 'doc':
            $mime = 'application/msword';
            break;

        case 'rtf':
            $mime = 'application/rtf';
            break;

        case 'wav':
        case 'wave':
            $mime = 'audio/x-wav';
            break;

        case 'mp2':
        case 'mpg':
        case 'mpeg':
            $mime = 'video/x-mpeg';
            break;

        case 'avi':
            $mime = 'video/x-msvideo';
            break;

        case 'mp3':
            $mime = 'audio/x-mpeg3';
            break;

        case 'xlm':
        case 'xlb':
        case 'xll':
        case 'xla':
        case 'xlw':
        case 'xlc':
        case 'xls':
        case 'xlt':
            $mime = 'application/vnd.ms-excel';
            break;

        case 'ppt':
        case 'pps':
            $mime = 'application/vnd.ms-powerpoint';
            break;

        case 'html':
        case 'htm':
            $mime = 'text/html';
            break;

        case 'xsl':
        case 'xslt':
        case 'xml':
        case 'wsdl':
        case 'xsd':
            $mime = 'text/xml';
            break;

        case 'zip':
            $mime = 'application/zip';
            break;

        case 'tar':
            $mime = 'application/x-tar';
            break;

        case 'tgz':
        case 'gz':
            $mime = 'application/x-gzip';
            break;

        case 'swf':
            $mime = 'application/x-shockwave-flash';
            break;

        case 'rm':
        case 'ra':
        case 'ram':
            $mime = 'application/vnd.rn-realaudio';
            break;

        case 'exe':
            $mime = 'application/octet-stream';
            break;

        case 'mov':
        case 'qt':
            $mime = 'video/x-quicktime';
            break;

        case 'midi':
        case 'mid':
            $mime = 'audio/x-midi';
            break;

        case 'txt':
            $mime = 'text/plain';
            break;

        case 'qcp':
            $mime = 'audio/vnd.qcelp';
            break;

        case 'emf':
            $mime = 'image/x-emf';
            break;

        case 'wmf':
            $mime = 'image/x-wmf';
            break;

        case 'snd':
            $mime = 'audio/basic';
            break;

        case 'pmd':
            $mime = 'application/x-pmd';
            break;

        case 'wbmp':
            $mime = 'image/vnd.wap.wbmp';
            break;

        case 'gcd':
            $mime = 'text/x-pcs-gcd';
            break;

        case 'mms':
            $mime = 'application/vnd.wap.mms-message';
            break;

        case 'ogg':
        case 'ogm':
            $mime = 'application/ogg';
            break;

        case 'rv':
            $mime = 'video/vnd.rn-realvideo';
            break;

        case 'wmv':
            $mime = 'video/x-ms-wmv';
            break;

        case 'wma':
            $mime = 'audio/x-ms-wma';
            break;

        case 'qcp':
            $mime = 'audio/vnd.qcelp';
            break;

        case 'jad':
            $mime = 'text/vnd.sun.j2me.app-descriptor';
            break;

        case '3g2':
        case '3gp':
            $mime = 'video/3gpp';
            break;

        case 'jar':
            $mime = 'application/java-archive';

        default:
            $mime = 'application/octet-stream';
            break;
    }

    return $mime;
}

/**
* Creates thumbnails for all images in the upload dir
**/
function serendipity_syncThumbs() {
    global $serendipity;

    $i=0;
    $files = serendipity_fetchImages();

    $fcount = count($files);
    for ($x = 0; $x < $fcount; $x++) {
        $update = $q = array();
        $f      = serendipity_parseFileName($files[$x]);
        if (empty($f[1]) || $f[1] == $files[$x]) {
            // No extension means bad file most probably. Skip it.
            printf(SKIPPING_FILE_EXTENSION . '<br />', $files[$x]);
            continue;
        }

        $ffull   = $serendipity['serendipityPath'] . $serendipity['uploadPath'] . $files[$x];
        $fthumb  = $serendipity['serendipityPath'] . $serendipity['uploadPath'] . $f[0] . '.' . $serendipity['thumbSuffix'] . '.' . $f[1];
        $fbase   = basename($f[0]);
        $fdir    = dirname($f[0]) . DIRECTORY_SEPARATOR;
        if ($fdir == '.' . DIRECTORY_SEPARATOR) {
            $fdir = '';
        }

        if (!is_readable($ffull) || filesize($ffull) == 0) {
            printf(SKIPPING_FILE_UNREADABLE . '<br />', $files[$x]);
            continue;
        }

        $ft_mime = serendipity_guessMime($f[1]);
        $fdim    = serendipity_getimagesize($ffull, $ft_mime);

        $rs = serendipity_db_query("SELECT * FROM {$serendipity['dbPrefix']}images
                                            WHERE name = '" . serendipity_db_escape_string($fbase) . "'
                                              " . ($fdir != '' ? "AND path = '" . serendipity_db_escape_string($fdir) . "'" : '') . "
                                              AND mime = '" . serendipity_db_escape_string($fdim['mime']) . "'", true, 'assoc');
        if (is_array($rs)) {
            $update    = array();
            $checkfile = $serendipity['serendipityPath'] . $serendipity['uploadPath'] . $rs['path'] . $rs['name'] . '.' . $rs['thumbnail_name'] . '.' . $rs['extension'];
            if (isset($fdim[0]) && $rs['dimensions_width'] != $fdim[0]) {
                $update['dimensions_width'] = $fdim[0];
            }

            if (isset($fdim[1]) && $rs['dimensions_height'] != $fdim[1]) {
                $update['dimensions_height'] = $fdim[1];
            }

            if ($rs['size'] != filesize($ffull)) {
                $update['size'] = filesize($ffull);
            }

            if (!file_exists($checkfile) && file_exists($fthumb)) {
                $update['thumbnail_name'] = $serendipity['thumbSuffix'];
            }

            /* Do the database update, if needed */
            if (sizeof($update) != 0) {
                printf(FOUND_FILE . '<br />', $files[$x]);
                serendipity_updateImageInDatabase($update, $rs['id']);
                $i++;
            }
        } else {
            if (file_exists($fthumb)) {
                $thumbnail = $serendipity['thumbSuffix'];
            }

            printf(FOUND_FILE . '<br />', $files[$x]);
            serendipity_insertImageInDatabase($fbase, $f[1], $fdim['mime'], filesize($ffull), $fdim[0], $fdim[1], $thumbnail, filemtime($ffull), '0', $fdir);
            $i++;
        }
    }
    return $i;
}

function serendipity_resize_image_gd($infilename, $outfilename, $newwidth, $newheight=null)
{
    if (!function_exists('imagecopyresampled')) {
        return false;
    }

    $inf = pathinfo(strtolower($infilename));
    switch ($inf['extension']) {
        case 'gif':
            $loadfn = 'imagecreatefromgif';
            $savefn = 'imagegif';
            break;

        case 'jpeg':
        case 'jpg':
        case 'jfif':
            $loadfn = 'imagecreatefromjpeg';
            $savefn = 'imagejpeg';
            break;

        case 'png':
            $loadfn = 'imagecreatefrompng';
            $savefn = 'imagepng';
            break;

        default:
            return false;
    }

    /* If our loader does not exist, we are doomed */
    if (!function_exists($loadfn)) {
        return false;
    }

    /* If the save function does not exist (i.e. read-only GIF), we want to output it as PNG */
    if (!function_exists($savefn)) {
        if (function_exists('imagepng')) {
            $savefn = 'imagepng';
        } else {
            return false;
        }
    }

    $in = $loadfn($infilename);
    $width = imagesx($in);
    $height = imagesy($in);

    if (is_null($newheight)) {
        // calculate aspect ratio
        $div_width  = $width  / $newwidth;
        $div_height = $height / $newwidth;

        if ($div_width <= 1 || $div_height <= 1) {
            // do not scale small images
            $newheight = $height;
            $newwidth  = $width;
        } elseif ($div_width >= $div_height) {
            // max width - calculate height, keep width as scaling base
            $newheight = round($height / $div_width);
        } else {
            // max height - calculate width, keep height as scaling base
            $newheight = $newwidth;
            $newwidth  = round($width / $div_height);
        }
    }

    $out = imagecreatetruecolor($newwidth, $newheight);
    imagecopyresampled($out, $in, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
    $savefn($out, $outfilename);
    $out = null;
    $in  = null;

    return array($newwidth, $newheight);
}

function serendipity_displayImageList($page = 0, $lineBreak = NULL, $manage = false, $url = NULL) {
    global $serendipity;
    $sort_row_interval = array(8, 16, 50, 100);

    $perPage = (isset($serendipity['GET']['sortorder']['perpage']) ? $serendipity['GET']['sortorder']['perpage'] : $sort_row_interval[0]);
    $start = ($page-1)*$perPage;

    $serendipity['imageList'] = serendipity_fetchImagesFromDatabase(
                                  $start,
                                  $perPage,
                                  $totalImages, // Passed by ref
                                  (isset($serendipity['GET']['sortorder']['order']) ? $serendipity['GET']['sortorder']['order'] : false),
                                  (isset($serendipity['GET']['sortorder']['ordermode']) ? $serendipity['GET']['sortorder']['ordermode'] : false),
                                  (isset($serendipity['GET']['only_path']) ? $serendipity['GET']['only_path'] : '')
    );

    $extraParems = '';

    $importParams = array('adminModule', 'htmltarget', 'filename_only', 'textarea');
    foreach($importParams AS $importParam) {
        if (isset($serendipity['GET'][$importParam])) {
            $extraParems .= 'serendipity[' . $importParam . ']='. $serendipity['GET'][$importParam] .'&amp;';
        }
    }

    if (isset($serendipity['GET']['only_path']) && !empty($serendipity['GET']['only_path']) ) {
        $extraParems .= 'serendipity[only_path]='. $serendipity['GET']['only_path'] .'&amp;';
        serendipity_uploadSecure($serendipity['GET']['only_path'], true);
    }

    foreach ( (array)$serendipity['GET']['sortorder'] as $k => $v ) {
        $extraParems .= 'serendipity[sortorder]['. $k .']='. $v .'&amp;';
    }

    $left  = '<input type="button" value="&lt;&lt;&lt;" onclick="location.href=\'?'. $extraParems .'serendipity[page]=' . ($page-1) . '\';" '. (($start <= 0) ? 'disabled' : '') .'>' . "\n";
    $right = '<input type="button" value="&gt;&gt;&gt;" onclick="location.href=\'?'. $extraParems .'serendipity[page]=' . ($page+1) . '\';" '. (($totalImages < $start+$perPage) ? 'disabled' : '') .'>' . "\n";

    $sort_order = serendipity_getImageFields();

    serendipity_traversePath(
      $paths,
      $serendipity['serendipityPath'] . $serendipity['uploadPath'],
      '',
      '',
      false,
      '',
      2,
      0,
      (isset($serendipity['GET']['only_path']) ? $serendipity['GET']['only_path'] : '')
    );


    if (is_null($lineBreak)) {
        $lineBreak = floor(750 / ($serendipity['thumbSize'] + 20));
    }
?>
<form style="display: inline; margin: 0px; padding: 0px;" method="get" action="?">
<?php
    foreach($serendipity['GET'] AS $g_key => $g_val) {
        if ( !is_array($g_val) && $g_key != 'page' ) {
            echo '<input type="hidden" name="serendipity[' . $g_key . ']" value="' . htmlspecialchars($g_val) . '" />';
        }
    }
?>
    <table class="serendipity_admin_filters" width="100%">
        <tr>
            <td class="serendipity_admin_filters_headline" colspan="6"><strong><?php echo FILTERS ?></strong> - <?php echo FIND_MEDIA ?></td>
        </tr>
        <tr>
            <td><?php echo FILTER_DIRECTORY ?></td>
            <td colspan="5"><select name="serendipity[only_path]">
                    <option value=""><?php echo ALL_DIRECTORIES ?></option>
                    <?php echo $paths ?>
                </select>
            </td>
        </tr>
        <tr>
            <td class="serendipity_admin_filters_headline" colspan="6"><strong><?php echo SORT_ORDER ?></strong></td>
        </tr>
        <tr>
            <td><?php echo SORT_BY ?></td>
            <td><select name="serendipity[sortorder][order]">
<?php
        foreach($sort_order AS $so_key => $so_val) {
            echo '<option value="' . $so_key . '" ' . (isset($serendipity['GET']['sortorder']['order']) && $serendipity['GET']['sortorder']['order'] == $so_key ? 'selected="selected"' : '') . '>' . $so_val . '</option>';
        }
?>              </select>
</td>
            <td><?php echo SORT_ORDER ?></td>
            <td><select name="serendipity[sortorder][ordermode]">
                    <option value="DESC" <?php echo (isset($serendipity['GET']['sortorder']['ordermode']) && $serendipity['GET']['sortorder']['ordermode'] == 'DESC' ? 'selected="selected"' : '') ?>><?php echo SORT_ORDER_DESC ?></option>
                    <option value="ASC"  <?php echo (isset($serendipity['GET']['sortorder']['ordermode']) && $serendipity['GET']['sortorder']['ordermode'] == 'ASC'  ? 'selected="selected"' : '') ?>><?php echo SORT_ORDER_ASC  ?></option>
                </select>
            </td>
            <td><?php echo FILES_PER_PAGE ?></td>
            <td><select name="serendipity[sortorder][perpage]">
<?php
        foreach($sort_row_interval AS $so_val) {
            echo '<option value="' . $so_val . '" ' . ($perPage == $so_val ? 'selected="selected"' : '') . '>' . $so_val . '</option>';
        }
?>              </select>
            </td>
        </tr>
        <tr>
            <td align="right" colspan="6">
                <input type="submit" name="go" value=" - <?php echo GO ?> - " />
            </td>
        </tr>
</table>
</form>
<table border="0" width="100%">
    <tr>
        <td colspan="<?php echo floor($lineBreak); ?>">
            <table width="100%">
                <tr>
                    <td><?php echo $left; ?></td>
                    <td align="right"><?php echo $right; ?></td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
<?php
        $x = 0;
        foreach ($serendipity['imageList'] as $k => $file) {
            ++$x; $preview = '';
            $i      = @getimagesize($serendipity['serendipityPath'] . $serendipity['uploadPath'] . $file['path'] . $file['name'] . '.' . $file['thumbnail_name'] . '.' . $file['extension']);
            $imgsrc = $serendipity['uploadHTTPPath'] . $file['path'] . $file['name'] . '.' . $file['thumbnail_name'] . '.' . $file['extension'];
            $is_image = ( 0 === strpos(strtolower($file['mime']), "image/") );

            if (file_exists($imgsrc)) {
                $preview .= '<img src="' . $imgsrc . '" border="0" alt="'. $file['name'] . '" />';
                if ($url) { $preview = '<a href="'. $url .'&amp;serendipity[image]='. $file['id'] .'">'. $preview .'</a>'; }
            }

            if (!$is_image) {
                $preview .= '<div class="serendipity_admin_mimetype" style="width: ' . $serendipity['thumbSize'] . 'px; height: ' . $serendipity['thumbSize'] . 'px; border: 1px solid; text-align: center;"><br /><br /><br />' . $file['mime'];
                if ($url) { $preview .= '<br /><a href="' . $url . '&amp;serendipity[image]=' . $file['id'] . '">' . $file['name'] . '.' . $file['extension'] . '</a>'; }
                $preview .= '</div>';
            }
?>
                <td nowrap="nowrap" align="center" valign="bottom" <?php echo ($manage) ? 'style="border-bottom: 1px solid #000000"' : '' ?>>
<?php
            echo $preview;
            if ($manage) {
?>
<div align="center"><?php echo $file['name'] . '.' . $file['extension']; ?> <sub>(<?php echo ($file['authorid'] == '0' ? ALL_AUTHORS : $file['authorname']); ?>)</sub></div>
<table border="0" width="300">
    <tr>
        <td valign="middle" style="font-size: x-small">
<?php
                if ($is_image) {
                    echo ORIGINAL_SHORT . ': ' . $file['dimensions_width'] . 'x' . $file['dimensions_height'] . '<br />';
                    echo THUMBNAIL_SHORT . ': ' . $i[0] . 'x' . $i[1];
                } else {
                    echo SORT_ORDER_SIZE . ': ' . number_format(round($file['size']/1024, 2), NUMBER_FORMAT_DECIMALS, NUMBER_FORMAT_DECPOINT, NUMBER_FORMAT_THOUSANDS) . 'kb';
                }
?>
        </td>
<?php
                if ($serendipity['authorid'] == $file['authorid'] || $file['authorid'] == '0' || $serendipity['serendipityUserlevel'] >= USERLEVEL_CHIEF) {
                    $popupWidth = ($is_image ? ($file['dimensions_width'] + 20) : 600);
                    $popupHeight = ($is_image ? ($file['dimensions_height'] + 20) : 500);
?>
        <td valign="middle" align="center"><img class="serendipityImageButton" title="<?php echo MEDIA_FULLSIZE; ?>" alt="<?php echo MEDIA_FULLSIZE; ?>" src="<?php echo serendipity_getTemplateFile('img/zoom.png') ?>"   border="0" onclick="F1 = window.open('<?php echo $serendipity['serendipityHTTPPath'] . $serendipity['uploadHTTPPath'] . $file['path'] . $file['name'] . '.'. $file['extension']; ?>','Zoom','height=<?php echo $popupHeight; ?>,width=<?php echo $popupWidth; ?>,top='+ (screen.height-<?php echo $popupHeight ?>)/2 +',left='+ (screen.width-<?php echo $popupWidth ?>)/2 +',toolbar=no,menubar=no,location=no,resize=1,resizable=1<?php echo ($is_image ? '' : ',scrollbars=yes'); ?>');" /></td>
        <td valign="middle" align="center"><img class="serendipityImageButton" title="<?php echo MEDIA_RENAME; ?>"   alt="<?php echo MEDIA_RENAME; ?>"   src="<?php echo serendipity_getTemplateFile('img/rename.png') ?>" border="0" onclick="rename('<?php echo $file['id']; ?>', '<?php echo addslashes($file['name']); ?>')" /></td>
        <?php if ($is_image) { ?><td valign="middle" align="center"><img class="serendipityImageButton" title="<?php echo IMAGE_RESIZE; ?>"   alt="<?php echo IMAGE_RESIZE; ?>"   src="<?php echo serendipity_getTemplateFile('img/scale.png') ?>" border="0" onclick="location.href='?serendipity[adminModule]=images&amp;serendipity[adminAction]=scaleSelect&amp;serendipity[fid]=<?php echo $file['id']; ?>';" /></td><?php } ?>
        <td valign="middle" align="center"><img class="serendipityImageButton" title="<?php echo MEDIA_DELETE; ?>"   alt="<?php echo MEDIA_DELETE; ?>"   src="<?php echo serendipity_getTemplateFile('img/delete.png') ?>" border="0" onclick="location.href='?serendipity[adminModule]=images&amp;serendipity[adminAction]=delete&amp;serendipity[fid]=<?php echo $file['id']; ?>';" /></td>
<?php
                }
?>
    </tr>
</table>
<?php } ?>
                </td>

<?php
        // Newline?
        if ($x % $lineBreak == 0) {
?>
    </tr>
    <tr>
<?php
        }
    }
?>
    </tr>

    <tr>
        <td colspan="<?php echo floor($lineBreak); ?>">
            <table width="100%">
                <tr>
                    <td><?php echo $left; ?></td>
                    <td align="right"><?php echo $right; ?></td>
                </tr>
            </table>
        </td>
    </tr>
</table>
<?php
}

function serendipity_killPath($basedir, $directory = '', $forceDelete = false) {
static $n = "<br />\n";
static $serious = true;

    if ($handle = @opendir($basedir . $directory)) {
        while (false !== ($file = @readdir($handle))) {
            if ($file != '.' && $file != '..') {
                if (is_dir($basedir . $directory . $file)) {
                    serendipity_killPath($basedir, $directory . $file . DIRECTORY_SEPARATOR, $forceDelete);
                } else {
                    $filestack[$file] = $directory . $file;
                }
            }
        }

        printf(CHECKING_DIRECTORY . "<br />\n", $directory);

        // No, we just don't kill files the easy way. We sort them out properly from the database
        // and preserve files not entered therein.
        $files = serendipity_fetchImagesFromDatabase(0, 0, $total, false, false, $directory);
        if (is_array($files)) {
            echo "<ul>\n";
            foreach($files AS $f => $file) {
                echo "<li>\n";
                if ($serious) {
                    serendipity_deleteImage($file['id']);
                } else {
                    echo $file['name'] . '.' . $file['extension'];
                }
                echo "</li>\n";

                unset($filestack[$file['name'] . '.' . $file['extension']]);
                unset($filestack[$file['name'] . '.' . $file['thumbnail_name'] . '.' . $file['extension']]);
            }
            echo "</ul>\n";
        }

        if (count($filestack) > 0) {
            if ($forceDelete) {
                echo "<ul>\n";
                foreach($filestack AS $f => $file) {
                    if ($serious && @unlink($basedir . $file)) {
                        printf('<li>' . DELETING_FILE . $n . DONE . "</li>\n", $file);
                    } else {
                        printf('<li>' . DELETING_FILE . $n . ERROR . "</li>\n", $file);
                    }
                }
                echo "</ul>\n";
            } else {
                echo ERROR_DIRECTORY_NOT_EMPTY . $n;
                echo "<ul>\n";
                foreach($filestack AS $f => $file) {
                    echo '<li>' . $file . "</li>\n";
                }
                echo "</ul>\n";
            }
        }

        echo '<strong>';
        if ($serious && !empty($directory) && !preg_match('@^.?/?$@', $directory) && @rmdir($basedir . $directory)) {
            printf(DIRECTORY_DELETE_SUCCESS . $n, $directory);
        } else {
            printf(DIRECTORY_DELETE_FAILED . $n, $directory);
        }
        echo '</strong>';
    }

    return true;
}

function serendipity_traversePath(&$out, $basedir, $jscode = '', $directory = '', $show_files = false, $pattern = '', $output_mode = 1, $level = 0, $selected = '') {
    if (empty($pattern)) {
        $pattern = '@.*@';
    }

    if ($handle = @opendir($basedir . DIRECTORY_SEPARATOR . $directory)) {
        if ($output_mode == 1) {
            $out .= '<ul>';
        }

        while (false !== ($file = @readdir($handle))) {
            if ($file != '.' && $file != '..' && preg_match($pattern, $file)) {
                if (is_dir($basedir . $directory . DIRECTORY_SEPARATOR . $file)) {
                    $cdir = (!empty($directory) ? $directory . DIRECTORY_SEPARATOR : '');
                    switch($output_mode) {
                        default:
                        case 1:
                            $out .= '<li><a href="#" onclick="' . $jscode . '" title="' . $cdir . $file . DIRECTORY_SEPARATOR . '">' . $file . DIRECTORY_SEPARATOR . '</a></li>' . "\n";
                            break;

                        case 2:
                            $value = $cdir . $file . DIRECTORY_SEPARATOR;
                            $out .= '<option ' . ($selected == $value ? 'selected="selected"' : '') . ' value="' . $value . '">' . str_repeat('&nbsp;', $level * 2) . $file . '</option>' . "\n";
                            break;
                    }

                    serendipity_traversePath($out, $basedir, $jscode, $cdir . $file, $show_files, $pattern, $output_mode, $level + 1, $selected);
                } elseif ($show_files) {
                    $out .= '<li>' . $file . '</li>' . "\n";
                }
            }
        }

        if ($output_mode == 1) {
            $out .= '</ul>';
        }

        closedir($handle);
    }
}

function serendipity_deletePath($dir) {
    $d = dir($dir);
    if ($d) {
        while ($f = $d->read() ){
            if ($f != '.' && $f != '..') {
                if (is_dir($dir . $f)){
                    serendipity_deletePath($dir . $f . DIRECTORY_SEPARATOR);
                    rmdir($dir . $f);
                }

                if (is_file($dir . $f)) {
                    unlink($dir . $f);
                }
            }
        }

        $d->close();
    }
}

function serendipity_uploadSecure(&$var, $strip_paths = false) {
    $var = preg_replace('@[^0-9a-z\._/-]@i', '', $var);
    if ($strip_paths) {
        $var = preg_replace('@(\.+[/\\\\]+)@', '/', $var);
    }

    return true;
}

function serendipity_getimagesize($file, $ft_mime = '', $suf = '') {
    if (empty($ft_mime) && !empty($suf)) {
        $ft_mime = serendipity_guessMime($suf);
    }

    $fdim = @getimagesize($file);

    if (is_array($fdim)) {
        if (empty($fdim['mime'])) {
            $fdim['mime'] = $ft_mime;
        }

        if ($fdim['mime'] == 'image/vnd.wap.wbmp' && $ft_mime == 'video/x-quicktime') {
            // PHP Versions prior to 4.3.9 reported .mov files wrongly as WAP. Fix this and mark the file as 'non-image' with 0x0 dimensions
            $fdim['mime'] = $ft_mime;
        }
    } else {
        // The file is no image. Return a fake array so that files are inserted (but without a thumb)
        $fdim = array(
            0         => 0,
            1         => 0,
            'mime'    => $ft_mime,
            'noimage' => true
        );
    }

    return $fdim;
}

function serendipity_getImageFields() {
    return array(
        'date'              => SORT_ORDER_DATE,
        'name'              => SORT_ORDER_NAME,
        'authorid'          => AUTHOR,
        'extension'         => SORT_ORDER_EXTENSION,
        'size'              => SORT_ORDER_SIZE,
        'dimensions_width'  => SORT_ORDER_WIDTH,
        'dimensions_height' => SORT_ORDER_HEIGHT
    );
}
?>