<?php # $Id: serendipity_functions_installer.inc.php,v 1.35 2004/08/30 09:29:23 garvinhicking Exp $
function serendipity_updateLocalConfig($dbName, $dbPrefix, $dbHost, $dbUser, $dbPass, $dbType, $file = 'serendipity_config_local.inc.php', $path = null, $privateVariables = null) {
    global $serendipity;
    umask(0000);
    if (is_null($path)) {
        $path = $serendipity['serendipityPath'];
    }
    $configfp = fopen($path . $file, 'w');

    if (!is_resource($configfp)) {
        $errs[] = sprintf(FILE_WRITE_ERROR, $file);
        $errs[] = sprintf(DIRECTORY_RUN_CMD, 'chown -R www:www', $path) . ' (' . WWW_USER . ')';
        $errs[] = sprintf(DIRECTORY_RUN_CMD, 'chmod 770'       , $path);
        $errs[] = BROWSER_RELOAD;

        return $errs;
    }

    if (isset($_POST['sqlitedbName']) && !empty($_POST['sqlitedbName'])) {
        $dbName = $_POST['sqlitedbName'];
    }

    fwrite($configfp, "<?php\n");

    fwrite($configfp, "\t/*\n");
    fwrite($configfp, "\t  Serendipity configuration file\n");
    fwrite($configfp, "\t  Written on ". date('r') ."\n");
    fwrite($configfp, "\t*/\n\n");

    fwrite($configfp, "\t\$serendipity['versionInstalled']  = '{$serendipity['version']}';\n");
    fwrite($configfp, "\t\$serendipity['dbName']            = '{$dbName}';\n");
    fwrite($configfp, "\t\$serendipity['dbPrefix']          = '{$dbPrefix}';\n");
    fwrite($configfp, "\t\$serendipity['dbHost']            = '{$dbHost}';\n");
    fwrite($configfp, "\t\$serendipity['dbUser']            = '{$dbUser}';\n");
    fwrite($configfp, "\t\$serendipity['dbPass']            = '{$dbPass}';\n");
    fwrite($configfp, "\t\$serendipity['dbType']            = '{$dbType}';\n");

    if (is_array($privateVariables) && count($privateVariables) > 0) {
        foreach($privateVariables AS $p_idx => $p_val) {
            fwrite($configfp, "\t\$serendipity['{$p_idx}']  = '{$p_val}';\n");
        }
    }

    fwrite($configfp, "?>\n");

    fclose($configfp);

    @chmod($path . $file, 0700);
    return true;
}

function serendipity_query_default($optname, $default, $usertemplate = false, $type = 'string') {
    global $serendipity;

    /* I won't tell you the password, it's MD5 anyway, you can't do anything with it */
    if ( $type == 'protected' && IS_installed === true ) {
        return '';
    }

    switch ($optname) {

        case 'dbType' :
            if ( extension_loaded('mysqli') ) {
                $type = 'mysqli';
            }
            if ( extension_loaded('postgres') ) {
                $type = 'postgres';
            }
            if ( extension_loaded('mysql') ) {
                $type = 'mysql';
            }
            return $type;

        case 'serendipityPath':
            $test_path1 = $_SERVER['DOCUMENT_ROOT'] . rtrim(dirname($_SERVER['PHP_SELF']), '/') . '/';
            $test_path2 = dirname(__FILE__) . '/';
            if (file_exists($test_path1 . 'serendipity_entries.php')) {
                return $test_path1;
            } else {
                return $test_path2;
            }

        case 'serendipityHTTPPath':
            return rtrim(dirname($_SERVER['PHP_SELF']), '/') .'/';

        case 'baseURL':
            $ssl  = isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on';
            $port = $_SERVER['SERVER_PORT'];

            return sprintf('http%s://%s%s%s',

                            $ssl ? 's' : '',
                            preg_replace('@^([^:]+):?.*$@', '\1', $_SERVER['HTTP_HOST']),
                            (($ssl && $port != 443) || (!$ssl && $port != 80)) ? (':' . $port) : '',
                            rtrim(dirname($_SERVER['PHP_SELF']), '/') .'/'
                   );

        case 'convert':
            if (isset($_EVN['PATH'])) {
                $path = explode(':', $_ENV['PATH']);
            } else {
                $path = '';
            }

            /* add some other possible locations to the path while we are at it,
             * as these are not always included in the apache path */
            $path[] = '/usr/X11R6/bin';
            $path[] = '/usr/bin';

            foreach ($path as $dir) {
                if (function_exists('is_executable') && @is_executable($dir . '/convert') || @is_file($dir . '/convert')) {
                    return $dir . '/convert';
                }
            }
            return $default;

        default:
            if ($usertemplate) {
                return serendipity_get_user_var($optname, $serendipity['authorid'], $default);
            }

            return $default;
    }
}

function serendipity_replaceEmbeddedConfigVars ($s) {
    return str_replace(
                  array(
                    '[USERLEVEL_ADMIN]',
                    '[USERLEVEL_CHIEF]',
                    '[USERLEVEL_EDITOR]',
                    '[LANGUAGE_LIST]'
                  ),

                  array(
                    USERLEVEL_ADMIN,
                    USERLEVEL_CHIEF,
                    USERLEVEL_EDITOR,
                    LANGUAGE_LIST
                  ), $s);
}

function serendipity_parseTemplate($n, $raw = false, $prepend_var = null, $get_defaults = true) {
    global $serendipity;

    if (is_array($prepend_var)) {
        $config = $configRaw = &$prepend_var;
        $usertemplate = true;
    } else {
        $config = $configRaw = array();
        $usertemplate = false;
    }

    $t = file($n, 1);

    $maxt = count($t);

    for ($x=0; $x<$maxt; $x++) {
        $l = $t[$x];
        $l = trim($l);

        if ($l != '') {
            switch ($l[0]) {

                // New Configure section
                case '/':
                    if ($l[1] == '/') {
                        $current = @constant(trim(substr($l, 2)));
                        $config['categories'][$current] = array();
                    }
                    break;

                case '#':
                    $config['descriptions'][$current] = @constant(trim(substr($l, 1)));
                    break;

                // A configure option
                case '$':
                    // Grep out the name, type and default
                    preg_match('#\{([^|]+\|[^|]+\|([^}]+)?)\}[^/]+/{2}(.+)#msi', $l, $match);

                    // Make vars containing the elements in the | list
                    list($constant, $name, $type, $distdefault, $permission, $flags) = explode('|', $match[1]);

                    // Only show directives which are destined for this user. On installation, show everyting.
                    if (IS_installed === false || $serendipity['serendipityUserlevel'] >= $permission) {
                        $cdef = ($get_defaults ? serendipity_query_default($name, $distdefault, $usertemplate, $type) : '');
                        $config['categories'][$current][] = $configRaw[] = array(
                                                'longname'    => @constant($constant),
                                                'name'        => $name,
                                                'type'        => $type,
                                                'default'     => $cdef,
                                                'distdefault' => serendipity_replaceEmbeddedConfigvars($distdefault),
                                                'desc'        => serendipity_replaceEmbeddedConfigVars(@constant(trim($match[3]))),
                                                'valid_for'   => $permission,
                                                'flags'       => explode(',', $flags)
                                              );
                    }
                    break;
            }
        }
    }

    if ($raw) {
        return $configRaw;
    } else {
        // Cleanup phase. Remove categories for which no variables can be defined
        if (isset($config['categories']) && is_array($config['categories'])) {
            foreach($config['categories'] AS $item => $itemarray) {
                if (count($itemarray) < 1) {
                    unset($config['categories'][$item]);
                }
            }
        }
        return $config;
    }
}

function serendipity_guessInput($type, $name, $value='', $default='') {
global $serendipity;

    if ($name == 'rewrite' && $default == $value && isset($serendipity['rewrite_default']) && $serendipity['rewrite_default'] != '') {
        $value = $serendipity['rewrite_default'];
    }

    switch ($type) {
        case 'bool' :
            $value = serendipity_get_bool($value);
            echo '<input id="radio_cfg_' . $name . '_yes" type="radio" name="' . $name . '" value="true" ';
            echo (($value == true) ? 'checked="checked"' : ''). ' /><label for="radio_cfg_' . $name . '_yes"> ' . YES . '</label>&nbsp;';
            echo '<input id="radio_cfg_' . $name . '_no" type="radio" name="' . $name . '" value="false" ';
            echo (($value == true) ? '' : 'checked="checked"'). ' /><label for="radio_cfg_' . $name . '_no"> ' . NO . '</label>';
            break;

        case 'protected' :
            echo '<input type="password" size="30" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
            break;
        case 'list' :
            preg_match_all("/([^\=]+)\=\>([^\,]+)\,?/i", $default, $res);
            echo '<select name="'. $name .'">';
            for ($x=0; $x<sizeof($res[1]); $x++) {
                printf('<option value="%s"%s>%s</option>'. "\n",
                      $res[1][$x],
                      (($res[1][$x] == $value) ? ' selected="selected"' : ''),
                      $res[2][$x]);
            }
            echo '</select>';
            break;
        default :
            echo '<input type="text" size="30" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
            break;
    }
}

function serendipity_printConfigTemplate($t, $from = false, $minimum = false, $folding = true, $_abort = true) {
    global $serendipity;

    if (!isset($serendipity['XHTML11'])) {
        $serendipity['XHTML11'] = FALSE;
    }

    if (IS_installed !== true) {
        $folding = false;
    }

    // If not yet installed, do some magic:
    $abort = false;
    if (IS_installed !== true && $_abort !== true) {
        $serendipity_root = dirname($_SERVER['PHP_SELF']) . '/';
        $serendipity_core = serendipity_httpCoreDir();
        $old_htaccess     = @file_get_contents($serendipity_core . '.htaccess');
        $fp               = @fopen($serendipity_core . '.htaccess', 'w');
        $serendipity_host = preg_replace('@^([^:]+):?.*$@', '\1', $_SERVER['HTTP_HOST']);

        if (!$fp) {
            printf(HTACCESS_ERROR,
              '<b>chmod go+rwx ' . getcwd() . '/</b>'
            );
            $abort = true;
        } else {
            fwrite($fp, 'ErrorDocument 404 ' . $serendipity_root . 'index.php');
            fclose($fp);

            // Do a request on a nonexistant file to see, if our htaccess allows ErrorDocument
            $sock = @fsockopen($serendipity_host, $_SERVER['SERVER_PORT'], $errorno, $errorstring, 10);
            $response = '';

            if ($sock) {
                fputs($sock, "GET {$_SERVER['PHP_SELF']}nonexistant HTTP/1.0\r\n");
                fputs($sock, "Host: $serendipity_host\r\n");
                fputs($sock, "User-Agent: Serendipity/{$serendipity['version']}\r\n");
                fputs($sock, "Connection: close\r\n\r\n");

                while (!feof($sock) && strlen($response) < 4096) {
                    $response .= fgets($sock, 400);
                }
                fclose($sock);
            }

            if (preg_match('@^HTTP/\d\.\d 200@', $response)) {
                $serendipity['rewrite_default'] = 'errordocs';
            } else {
                $serendipity['rewrite_default'] = 'none';
            }

            if (!empty($old_htaccess)) {
                $fp = @fopen($serendipity_core . '.htaccess', 'w');
                fwrite($fp, $old_htaccess);
                fclose($fp);
            } else {
                @unlink($serendipity_core . '.htaccess');
            }
        }
    }

    if ($abort === false) {
?>
<script type="text/javascript" language="JavaScript">
function showConfig(id) {
    if (document.getElementById) {
        el = document.getElementById(id);
        if (el.style.display == 'none') {
            document.getElementById('option' + id).src = '<?php echo serendipity_getTemplateFile('img/minus.png') ?>';
            el.style.display = '';
        } else {
            document.getElementById('option' + id).src = '<?php echo serendipity_getTemplateFile('img/plus.png') ?>';
            el.style.display = 'none';
        }
    }
}

var state='<?php echo ($folding === true ? '' : 'none'); ?>';
function showConfigAll(count) {
    if (document.getElementById) {
        for (i = 1; i <= count; i++) {
            document.getElementById('el' + i).style.display = state;
            document.getElementById('optionel' + i).src = (state == '' ? '<?php echo serendipity_getTemplateFile('img/minus.png') ?>' : '<?php echo serendipity_getTemplateFile('img/plus.png') ?>');
        }

        if (state == '') {
            document.getElementById('optionall').src = '<?php echo serendipity_getTemplateFile('img/minus.png') ?>';
            state = 'none';
        } else {
            document.getElementById('optionall').src = '<?php echo serendipity_getTemplateFile('img/plus.png') ?>';
            state = '';
        }
    }
}
</script>

<?php
        if (!$minimum) {
?>
<form action="?" method="POST">
    <div>
        <input type="hidden" name="serendipity[adminModule]" value="installer" />
        <input type="hidden" name="installAction" value="check" />
        <br />
<?php   }
        if ( sizeof($t['categories']) > 1 ) { ?>
        <div align="right">
            <a style="border:0; text-decoration: none" href="#" onclick="showConfigAll(<?php echo count($t['categories']); ?>)" title="<?php echo TOGGLE_ALL; ?>"><img src="<?php echo serendipity_getTemplateFile('img/'. ($folding === true ? 'plus' : 'minus') .'.png') ?>" id="optionall" alt="+/-" border="0" />&nbsp;<?php echo TOGGLE_ALL; ?></a></a><br />
        </div>
<?php
        }
        $el_count = 0;
        foreach ($t['categories'] as $key => $value) {
            $el_count++;
?>
        <table width="100%" cellspacing="2">
<?php
        if ( sizeof($t['categories']) > 1 ) {
?>
            <tr>
                <th align="left" colspan="2" style="padding-left: 15px;">
                    <a style="border:0; text-decoration: none" href="#" onclick="showConfig('el<?php echo $el_count; ?>'); return false" title="<?php echo TOGGLE_OPTION; ?>"><img src="<?php echo serendipity_getTemplateFile('img/'. ($folding === true ? 'plus' : 'minus') .'.png') ?>" id="optionel<?php echo $el_count; ?>" alt="+/-" border="0" />&nbsp;<?php echo $key; ?></a></th>
            </tr>
<?php   } ?>
            <tr>
                <td>
                    <table width="100%" cellspacing="0" cellpadding="3" style="<?php echo ($folding === true ? 'display: none;' : ''); ?>" id="el<?php echo $el_count; ?>">
                        <tr>
                            <td style="padding-left: 20px;" colspan="2">
                                <?php echo $t['descriptions'][$key] ?>
                            </td>
                        </tr>

<?php
            for ($x=0; $x<count($value); $x++) {

                /* Check for installOnly flag */
                if ( in_array('installOnly', $value[$x]['flags']) && IS_installed === true ) {
                    continue;
                }


                /* If we have a valuelist, then use the value from there */
                if (@is_array($from)) {
                    $value[$x]['value'] = $from[$value[$x]['name']];
                }

                /* If the value is never assigned in the valuelist, then use our default value */
                if (!isset($from[$value[$x]['name']])) {
                    $value[$x]['value'] = $value[$x]['default'];
                }
?>
                        <tr>
                            <td style="border-bottom: 1px #000000 solid" align="left" valign="top" width="75%">
                                <strong><?php echo $value[$x]['longname']; ?></strong>
                                <br />
                                <span style="color: #5E7A94; font-size: 8pt;"><?php echo '(' . $value[$x]['type'] . ') ' . $value[$x]['desc']; ?></span>
                            </td>
                            <td style="border-bottom: 1px #000000 solid; font-size: 8pt" align="left" valign="middle" width="25%">
                                <?php echo ($serendipity['XHTML11'] ? '<span style="white-space: nowrap">' : '<nobr>'); ?><?php echo serendipity_guessInput($value[$x]['type'], $value[$x]['name'], $value[$x]['value'], $value[$x]['distdefault']); ?><?php echo ($serendipity['XHTML11'] ? '</span>' : '</nobr>'); ?>
                            </td>
                        </tr>
<?php
            }
?>
                    </table><br /><br />
                </td>
            </tr>
        </table>
<?php
        }

        if (!$minimum) {
?>
        <input type="submit" value="<?php echo CHECK_N_SAVE; ?>" />
    </div>
</form>
<?php
        }
    }
}

function serendipity_parse_sql_tables($filename) {
    $in_table = 0;
    $queries = array();

    $fp = fopen($filename, 'r', 1);
    if ($fp) {
        while (!@feof($fp)) {
            $line = trim(fgets($fp, 4096));
            if ($in_table) {
                $def .= $line;
                if (preg_match('/^\)\s*(type\=\S+)?\s*\;$/i', $line)) {
                    $in_table = 0;
                    array_push($queries, $def);
                }
            } else {
                if (preg_match('#^create table \{PREFIX\}\S+\s*\(#i', $line)) {
                    $in_table = 1;
                    $def = $line;
                }

                if (preg_match('#^create\s*(\{fulltext\}|unique)\s*index#i', $line)) {
                    array_push($queries, $line);
                }
            }
        }
        fclose($fp);
    }

    return $queries;
}

function serendipity_checkInstallation() {
    global $serendipity, $umask;

    $errs = array();

    // Check dirs
    if (!is_dir($_POST['serendipityPath'])) {
        $errs[] = sprintf(DIRECTORY_NON_EXISTANT, $_POST['serendipityPath']);
    }
    elseif (!is_writable($_POST['serendipityPath']) ) {
        $errs[] = sprintf(DIRECTORY_WRITE_ERROR, $_POST['serendipityPath']);
    }
    elseif (!is_dir($_POST['serendipityPath'] . $_POST['uploadPath'] ) && @mkdir($_POST['serendipityPath'] . $_POST['uploadPath'], $umask) !== true) {
        $errs[] = sprintf(DIRECTORY_CREATE_ERROR, $_POST['serendipityPath'] . $_POST['uploadPath']);
    }
    elseif (!is_writable($_POST['serendipityPath'] . $_POST['uploadPath'])) {
        $errs[] = sprintf(DIRECTORY_WRITE_ERROR, $_POST['serendipityPath'] . $_POST['uploadPath']);
        $errs[] = sprintf(DIRECTORY_RUN_CMD    , 'chmod go+rws', $_POST['serendipityPath'] . $_POST['uploadPath']);
    }

    // Attempt to create the archives directory
    if (!is_dir($_POST['serendipityPath'] . PATH_ARCHIVES) && @mkdir($_POST['serendipityPath'] . PATH_ARCHIVES, $umask) !== true) {
        $errs[] = sprintf(DIRECTORY_CREATE_ERROR, $_POST['serendipityPath'] . PATH_ARCHIVES);
        $errs[] = sprintf(DIRECTORY_RUN_CMD     , 'mkdir'      , $_POST['serendipityPath'] . PATH_ARCHIVES);
        $errs[] = sprintf(DIRECTORY_RUN_CMD     , 'chmod go+rwx', $_POST['serendipityPath'] . PATH_ARCHIVES);
    }

    // plugins directory now part of basic CVS

    // Check imagick
    if ($_POST['magick'] == 'true' && !@is_executable($_POST['convert'])) {
        $errs[] = sprintf(CANT_EXECUTE_BINARY, 'convert imagemagick');
    }

    if ($_POST['dbType'] == 'sqlite') {
        // We don't want that our SQLite db file can be guessed from other applications on a server
        // and have access to our's. So we randomize the SQLite dbname.
        $_POST['sqlitedbName'] = $_POST['dbName'] . '_' . md5(time());
    }

    $serendipity['dbType'] = $_POST['dbType'];
    // Probe database
    // (do it after the dir stuff, as we need to be able to create the sqlite database)
    @include_once($_POST['serendipityPath'] . 'serendipity_db.inc.php');
    // For shared installations, probe the file on include path
    @include_once(S9Y_INCLUDE_PATH . 'serendipity_db.inc.php');

    if (S9Y_DB_INCLUDED) {
        serendipity_db_probe($_POST, $errs);
    }

    return (count($errs) > 0 ? $errs : '');
}

function serendipity_installDatabase() {
    global $serendipity;

    /* Try and check if the database/tables are already installed,
       if they are... exit the function */
    echo CHECK_DATABASE_EXISTS;
    $t = serendipity_db_query("SELECT * FROM {$_POST['dbPrefix']}authors", false, 'both', false);
    echo ' ' . DONE . '<br />';

    if (is_array($t)) {
        return false;
    }

    echo CREATE_DATABASE;
    // Create tables
    $queries = serendipity_parse_sql_tables($serendipity['serendipityPath'] . 'sql/db.sql');
    $queries = str_replace('{PREFIX}', $_POST['dbPrefix'], $queries);

    foreach ($queries as $query) {
        serendipity_db_schema_import($query);
    }

    if ($_POST['want_mail'] == true) {
        $mail_comments = 1;
    } else {
        $mail_comments = 0;
    }
    echo ' ' . DONE . '<br />';

    /*
        ------------- Install main author ------------
    */
    $enc_pass = md5($_POST['pass']);
    $query = "INSERT INTO {$_POST['dbPrefix']}authors (
                            username,
                            password,
                            email,
                            mail_comments,
                            mail_trackbacks,
                            userlevel
                          )
                  VALUES  (
                            '{$_POST['user']}',
                            '$enc_pass',
                            '{$_POST['email']}',
                            $mail_comments,
                            $mail_comments,
                            " . USERLEVEL_ADMIN . "
                          )";
    serendipity_db_query($query);

    $serendipity['dbPrefix'] = $_POST['dbPrefix'];

    /* Set the default template */
    serendipity_set_config_var('template', $serendipity['defaultTemplate']);

    return true;
}

function serendipity_installFiles($serendipity_core = '') {
    global $serendipity;

    // This variable is transmitted from serendipity_admin_installer. If an empty variable is used,
    // this means that serendipity_installFiles() was called from the auto-updater facility.
    if (empty($serendipity_core)) {
        $serendipity_core = $serendipity['serendipityPath'];
    }

    $htaccess = @file_get_contents($serendipity_core . '.htaccess');

    // Let this function be callable outside installation and let it use existing settings.
    $import = array('rewrite', 'serendipityHTTPPath', 'indexFile');
    foreach($import AS $key) {
        if (empty($_POST[$key]) && isset($serendipity[$key])) {
            $$key = $serendipity[$key];
        } else {
            $$key = $_POST[$key];
        }
    }

    if (php_sapi_name() == 'cgi' || php_sapi_name() == 'cgi-fcgi') {
        $htaccess_cgi = '.cgi';
    } else {
        $htaccess_cgi = '';
    }


    /* Detect comptability with php_value directives */
    if ($htaccess_cgi == '') {
        $response = '';
        $serendipity_root = dirname($_SERVER['PHP_SELF']) . '/';
        $serendipity_host = preg_replace('@^([^:]+):?.*$@', '\1', $_SERVER['HTTP_HOST']);

        $old_htaccess = @file_get_contents($serendipity_core . '.htaccess');
        $fp = @fopen($serendipity_core . '.htaccess', 'w');
        if ($fp) {
            fwrite($fp, 'php_value register_globals off'. "\n" .'php_value session.use_trans_sid 0');
            fclose($fp);

            $sock = @fsockopen($serendipity_host, $_SERVER['SERVER_PORT'], $errorno, $errorstring, 10);
            if ($sock) {
                fputs($sock, "GET {$serendipity['serendipityHTTPPath']} HTTP/1.0\r\n");
                fputs($sock, "Host: $serendipity_host\r\n");
                fputs($sock, "User-Agent: Serendipity/{$serendipity['version']}\r\n");
                fputs($sock, "Connection: close\r\n\r\n");

                while (!feof($sock) && strlen($response) < 4096) {
                    $response .= fgets($sock, 400);
                }
                fclose($sock);
            }

            /* If we get HTTP 500 Internal Server Error, we have to use the .cgi template */
            if (preg_match('@^HTTP/\d\.\d 500@', $response)) {
                $htaccess_cgi = '.cgi';
            }

            if (!empty($old_htaccess)) {
                $fp = @fopen($serendipity_core . '.htaccess', 'w');
                fwrite($fp, $old_htaccess);
                fclose($fp);
            } else {
                @unlink($serendipity_core . '.htaccess');
            }
        }
    }


    if ($rewrite == 'rewrite') {
        $template = 'htaccess' . $htaccess_cgi . '.rewrite.tpl';
    } elseif ($rewrite == 'errordocs') {
        $template = 'htaccess' . $htaccess_cgi . '.errordocs.tpl';
    } else {
        $template = 'htaccess' . $htaccess_cgi . '.normal.tpl';
    }

    if (!($a = file(S9Y_INCLUDE_PATH . $template, 1))) {
        $err[] = ERROR_TEMPLATE_FILE;
    }

    $content = str_replace(
                 array(
                   '{PREFIX}',
                   '{indexFile}',
                   '{PAT_UNSUBSCRIBE}', '{PATH_UNSUBSCRIBE}',
                   '{PAT_ARCHIVES}', '{PATH_ARCHIVES}',
                   '{PAT_ARCHIVES_SHORT}',
                   '{PAT_FEEDS}', '{PATH_FEEDS}',
                   '{PAT_FEED}',
                   '{PAT_ADMIN}', '{PATH_ADMIN}',
                   '{PAT_ENTRIES}', '{PATH_ENTRIES}',
                   '{PAT_ARCHIVE}', '{PATH_ARCHIVE}',
                   '{PAT_CATEGORIES}', '{PATH_CATEGORIES}',
                   '{PAT_PLUGIN}', '{PATH_PLUGIN}',
                   '{PAT_DELETE}', '{PATH_DELETE}',
                   '{PAT_APPROVE}', '{PATH_APPROVE}'
                 ),

                 array(
                   $serendipityHTTPPath,
                   $indexFile,
                   trim(PAT_UNSUBSCRIBE, '@/i'), PATH_UNSUBSCRIBE,
                   trim(PAT_ARCHIVES, '@/i'), PATH_ARCHIVES,
                   trim(PAT_ARCHIVES_SHORT, '@/i'),
                   trim(PAT_FEEDS, '@/i'), PATH_FEEDS,
                   trim(PAT_FEED, '@/i'),
                   trim(PAT_ADMIN, '@/i'), PATH_ADMIN,
                   trim(PAT_ENTRIES, '@/i'), PATH_ENTRIES,
                   trim(PAT_ARCHIVE, '@/i'), PATH_ARCHIVE,
                   trim(PAT_CATEGORIES, '@/i'), PATH_CATEGORIES,
                   trim(PAT_PLUGIN, '@/i'), PATH_PLUGIN,
                   trim(PAT_DELETE, '@/i'), PATH_DELETE,
                   trim(PAT_APPROVE, '@/i'), PATH_APPROVE
                 ),

                 implode('', $a)
              );

    $fp = @fopen($serendipity_core . '.htaccess', 'w');
    if (!$fp) {
        $errs[] = sprintf(FILE_WRITE_ERROR, $serendipity_core . '.htaccess') . ' ' . FILE_CREATE_YOURSELF;
        $errs[] = sprintf(COPY_CODE_BELOW , $serendipity_core . '.htaccess', 'serendipity', htmlspecialchars($content));
        return $errs;
    } else {
        // Check if an old htaccess file existed and try to preserve its contents. Otherwise completely wipe the file.
        if ($htaccess != '' && preg_match('@^(.*)#\s+BEGIN\s+s9y.*#\s+END\s+s9y(.*)$@isU', $htaccess, $match)) {
            // Code outside from s9y-code was found.
            fwrite($fp, $match[1] . $content . $match[2]);
        } else {
            fwrite($fp, $content);
        }
        fclose($fp);
        return true;
    }

}

function serendipity_updateConfiguration() {
    global $serendipity, $umask;

    // Save all basic config variables to the database
    $p = serendipity_parseTemplate(S9Y_CONFIG_TEMPLATE, true);

    foreach($p as $key => $entry) {
        serendipity_set_config_var(
          $entry['name'],
          $_POST[$entry['name']],
          (($entry['range'] == 'global' || $serendipity['serendipityUserlevel'] >= USERLEVEL_ADMIN || IS_installed === false) ? 0 : $serendipity['authorid'])
        );
    }

    // Save all user-relevant data in the usertable. Only when s9y is installed.
    if (IS_installed === true) {
        $u = serendipity_parseTemplate(S9Y_CONFIG_USERTEMPLATE, true);
        foreach($u AS $key => $entry) {
            serendipity_set_user_var(
              $entry['name'],
              $_POST[$entry['name']],

              ($entry['range'] == 'global' ? 0 : $serendipity['authorid'])
            );
        }
    }

    if (IS_installed === false || $serendipity['serendipityUserlevel'] >= USERLEVEL_ADMIN) {
        return serendipity_updateLocalConfig($_POST['dbName'],
                                             $_POST['dbPrefix'],
                                             $_POST['dbHost'],
                                             $_POST['dbUser'],
                                             $_POST['dbPass'],
                                             $_POST['dbType'],
                                             'serendipity_config_local.inc.php',
                                             $_POST['serendipityPath']);
    } else {
        return true;
    }
}

function serendipity_httpCoreDir() {
    if (!empty($_SERVER['SCRIPT_FILENAME'])) {
        return dirname($_SERVER['SCRIPT_FILENAME']) . '/';
    }

    return $_SERVER['DOCUMENT_ROOT'] . dirname($_SERVER['PHP_SELF']) . '/';
}
?>
