<?php # $Id: serendipity_rss_exchange.inc.php,v 1.5 2004/07/13 08:49:41 garvinhicking Exp $

require_once 'bundled-libs/Onyx/RSS.php';

function serendipity_rss_buildEntry($item, &$entry)
{
    global $serendipity;

    $entry = array();

    if ($item['description']) {
        $entry['body'] = $item['description'];
    }

    if ($item['content:encoded']) {
        if (!isset($entry['body'])) {
            $data = &$entry['body'];
        } else {
            $data = &$entry['extended'];
        }

        if ($entry['body'] != substr($item['content:encoded'], 0, strlen($entry['body']))) {
            $data .= substr($item['content:encoded'], strlen($entry['body']));
        } else {
            $data = $item['content:encoded'];
        }
    }

    $entry['title'] = $item['title'];
    $entry['timestamp'] = strtotime(isset($item['pubdate']) ? $item['pubdate'] : $item['dc:date']);
    if ($entry['timestamp'] == -1) {
        $entry['timestamp'] = time();
    }

    if ($serendipity['POST']['type'] == 'draft') {
        $entry['isdraft'] = 'true';
    } else {
        $entry['isdraft'] = 'false';
    }

    if (!empty($entry['category'])) {
        $cat = serendipity_fetchCategoryInfo(0, trim($entry['category']));
        if (is_array($cat) && isset($cat['categoryid'])) {
            $entry['categories'][] = $cat['categoryid'];
        }
    }

    if (!is_array($entry['categories'])) {
        $entry['categories'][] = $serendipity['POST']['category'];
    }

    return true;
}

function serendipity_rss_import($url)
{
    global $serendipity;

    $c = &new Onyx_RSS();
    $c->parse($url);

    $serendipity['noautodiscovery'] = 1;
    while ($item = $c->getNextItem()) {
        if (serendipity_rss_buildEntry($item, $entry)) {
            serendipity_updertEntry($entry);
        }
    }

    return true;
}

/* vim: set sts=4 ts=4 expandtab : */
?>
